# ************************************************************
# Sequel Pro SQL dump
# Version 4096
#
# http://www.sequelpro.com/
# http://code.google.com/p/sequel-pro/
#
# Host: localhost (MySQL 5.5.25)
# Database: qs30_Zenbase
# Generation Time: 2013-05-27 04:41:55 +0000
# ************************************************************


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


# Dump of table #__assets
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__assets`;

CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__assets` WRITE;
/*!40000 ALTER TABLE `#__assets` DISABLE KEYS */;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`)
VALUES
	(1,0,1,425,0,'root.1','Root Asset','{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":{\"6\":1},\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(2,1,1,2,1,'com_admin','com_admin','{}'),
	(3,1,3,6,1,'com_banners','com_banners','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(4,1,7,8,1,'com_cache','com_cache','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(5,1,9,10,1,'com_checkin','com_checkin','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(6,1,11,12,1,'com_config','com_config','{}'),
	(7,1,13,16,1,'com_contact','com_contact','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(8,1,17,156,1,'com_content','com_content','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
	(9,1,157,158,1,'com_cpanel','com_cpanel','{}'),
	(10,1,159,160,1,'com_installer','com_installer','{\"core.admin\":[],\"core.manage\":{\"7\":0},\"core.delete\":{\"7\":0},\"core.edit.state\":{\"7\":0}}'),
	(11,1,161,162,1,'com_languages','com_languages','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(12,1,163,164,1,'com_login','com_login','{}'),
	(13,1,165,166,1,'com_mailto','com_mailto','{}'),
	(14,1,167,168,1,'com_massmail','com_massmail','{}'),
	(15,1,169,170,1,'com_media','com_media','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1}}'),
	(16,1,171,172,1,'com_menus','com_menus','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(17,1,173,174,1,'com_messages','com_messages','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(18,1,175,176,1,'com_modules','com_modules','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(19,1,177,180,1,'com_newsfeeds','com_newsfeeds','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(20,1,181,182,1,'com_plugins','com_plugins','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(21,1,183,184,1,'com_redirect','com_redirect','{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),
	(22,1,185,186,1,'com_search','com_search','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),
	(23,1,187,188,1,'com_templates','com_templates','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(24,1,189,192,1,'com_users','com_users','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(25,1,193,196,1,'com_weblinks','com_weblinks','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
	(26,1,197,198,1,'com_wrapper','com_wrapper','{}'),
	(27,8,18,19,2,'com_content.category.2','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(28,3,4,5,2,'com_banners.category.3','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(29,7,14,15,2,'com_contact.category.4','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(30,19,178,179,2,'com_newsfeeds.category.5','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(31,25,194,195,2,'com_weblinks.category.6','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(32,24,190,191,1,'com_users.category.7','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(33,1,199,200,1,'com_finder','com_finder','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),
	(34,1,201,202,1,'com_joomlaupdate','com_joomlaupdate','{\"core.admin\":[],\"core.manage\":[],\"core.delete\":[],\"core.edit.state\":[]}'),
	(35,8,20,55,2,'com_content.category.8','Features','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(42,8,56,63,2,'com_content.category.9','Services','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(43,8,64,73,2,'com_content.category.10','Work','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(44,8,74,83,2,'com_content.category.11','News','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(45,8,84,141,2,'com_content.category.12','About Us','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(46,45,85,88,3,'com_content.category.13','About the company','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(47,45,89,102,3,'com_content.category.14','Meet the team','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(48,45,103,116,3,'com_content.category.15','Testimonials','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(49,45,117,130,3,'com_content.category.16','Frequently asked questions','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(50,45,131,138,3,'com_content.category.17','Quotes','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(51,42,57,58,3,'com_content.article.7','Services #1','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(52,42,59,60,3,'com_content.article.8','Services #2','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(53,45,139,140,3,'com_content.article.9','Services #3','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(54,42,61,62,3,'com_content.article.10','Services #4','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(55,43,65,66,3,'com_content.article.11','Project #1','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(56,43,67,68,3,'com_content.article.12','Project #2','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(57,43,69,70,3,'com_content.article.13','Project #3','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(58,43,71,72,3,'com_content.article.14','Project #4','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(59,44,75,76,3,'com_content.article.15','News #1','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(60,44,77,78,3,'com_content.article.16','News #2','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(61,44,79,80,3,'com_content.article.17','News #3','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(62,44,81,82,3,'com_content.article.18','News #4','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(63,46,86,87,4,'com_content.article.19','About The Company','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(64,47,90,91,4,'com_content.article.20','Carol Smith','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(65,47,92,93,4,'com_content.article.21','Julie Sanders','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(66,47,94,95,4,'com_content.article.22','Patrick Johnson','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(67,47,96,97,4,'com_content.article.23','Samantha Cook','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(68,47,100,101,4,'com_content.article.24','Thomas Ewing','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(69,47,98,99,4,'com_content.article.25','Walter Brown','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(70,48,104,105,4,'com_content.article.26','Testimonial #1','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(71,48,106,107,4,'com_content.article.27','Testimonial #2','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(72,48,108,109,4,'com_content.article.28','Testimonial #3','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(73,48,110,111,4,'com_content.article.29','Testimonial #4','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(74,48,112,113,4,'com_content.article.30','Testimonial #5','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(75,48,114,115,4,'com_content.article.31','Testimonial #6','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(76,49,118,119,4,'com_content.article.32','Q: Fusce scelerisque laoreet leo a porttitor. Cras condimentum facilisis dignissim.?','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(77,49,120,121,4,'com_content.article.33','Q: morbi tristique senectus et netus et?','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(78,49,122,123,4,'com_content.article.34','Q: Nullam quam felis, varius non dictum ornare, volutpat sed est?','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(79,49,124,125,4,'com_content.article.35','Q: Praesent sit amet quam tellus?','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(80,49,126,127,4,'com_content.article.36','Q: Quisque ullamcorper, nisi ac pharetra dictum, orci leo porttitor orci?','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(81,49,128,129,4,'com_content.article.37','Q: Vestibulum in turpis nulla, hendrerit pulvinar tellus?','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(82,50,132,133,4,'com_content.article.38','Edison','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(83,50,134,135,4,'com_content.article.39','Maxwell','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(84,50,136,137,4,'com_content.article.40','Thoreau','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(85,8,142,155,2,'com_content.category.18','Demo content','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(86,85,143,144,3,'com_content.article.41','All about pink','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(87,85,145,146,3,'com_content.article.42','Bespoke Verbosity','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(88,85,147,148,3,'com_content.article.43','Grass retrospective','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(89,85,149,150,3,'com_content.article.44','Inner growth','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(90,85,151,152,3,'com_content.article.45','Midnight meadow','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(99,35,23,28,3,'com_content.category.19','Typography','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(100,35,21,22,3,'com_content.category.20','ZenTools Module','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(101,99,26,27,4,'com_content.article.52','Reusable grid layouts for your content','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(102,103,30,31,4,'com_content.article.53','Module classes','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(103,35,29,36,3,'com_content.category.21','Template Features','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(104,103,32,33,4,'com_content.article.54','Module Positions','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(108,103,34,35,4,'com_content.article.57','Solid template framework','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(109,35,37,38,3,'com_content.article.58','Responsive by design','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(110,35,39,40,3,'com_content.article.59','Thememagic magically themes your site','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(111,85,153,154,3,'com_content.article.60','The Golden Field','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(114,35,41,42,3,'com_content.article.63','Template Features','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(115,35,43,44,3,'com_content.article.64','Module Chrome','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(116,35,45,46,3,'com_content.article.65','Tabbed module styles','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(117,35,47,48,3,'com_content.article.66','Modal module style','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(118,35,49,50,3,'com_content.article.67','Slider Style','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(119,35,51,52,3,'com_content.article.68','Popover Module style','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(120,35,53,54,3,'com_content.article.69','Module Overview','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
	(121,1,205,206,1,'com_advancedmodules.module.90','com_advancedmodules.module.90',''),
	(122,1,207,208,1,'com_advancedmodules.module.97','com_advancedmodules.module.97',''),
	(123,1,209,210,1,'com_advancedmodules.module.1','com_advancedmodules.module.1',''),
	(124,1,211,212,1,'com_advancedmodules.module.17','com_advancedmodules.module.17',''),
	(125,1,213,214,1,'com_advancedmodules.module.87','com_advancedmodules.module.87',''),
	(126,1,215,216,1,'com_advancedmodules.module.88','com_advancedmodules.module.88',''),
	(127,1,217,218,1,'com_advancedmodules.module.89','com_advancedmodules.module.89',''),
	(128,1,219,220,1,'com_advancedmodules.module.91','com_advancedmodules.module.91',''),
	(129,1,221,222,1,'com_advancedmodules.module.92','com_advancedmodules.module.92',''),
	(130,1,223,224,1,'com_advancedmodules.module.93','com_advancedmodules.module.93',''),
	(131,1,225,226,1,'com_advancedmodules.module.94','com_advancedmodules.module.94',''),
	(132,1,227,228,1,'com_advancedmodules.module.95','com_advancedmodules.module.95',''),
	(133,1,229,230,1,'com_advancedmodules.module.96','com_advancedmodules.module.96',''),
	(134,1,231,232,1,'com_advancedmodules.module.98','com_advancedmodules.module.98',''),
	(135,1,233,234,1,'com_advancedmodules.module.99','com_advancedmodules.module.99',''),
	(136,1,235,236,1,'com_advancedmodules.module.100','com_advancedmodules.module.100',''),
	(137,1,237,238,1,'com_advancedmodules.module.104','com_advancedmodules.module.104',''),
	(138,1,239,240,1,'com_advancedmodules.module.105','com_advancedmodules.module.105',''),
	(139,1,241,242,1,'com_advancedmodules.module.106','com_advancedmodules.module.106',''),
	(140,1,243,244,1,'com_advancedmodules.module.107','This is the first tab','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(141,1,245,246,1,'com_advancedmodules.module.109','com_advancedmodules.module.109',''),
	(142,1,247,248,1,'com_advancedmodules.module.115','com_advancedmodules.module.115',''),
	(143,1,249,250,1,'com_advancedmodules.module.116','com_advancedmodules.module.116',''),
	(144,1,251,252,1,'com_advancedmodules.module.117','com_advancedmodules.module.117',''),
	(145,1,253,254,1,'com_advancedmodules.module.118','com_advancedmodules.module.118',''),
	(146,1,255,256,1,'com_advancedmodules.module.119','com_advancedmodules.module.119',''),
	(147,1,257,258,1,'com_advancedmodules.module.120','com_advancedmodules.module.120',''),
	(148,1,259,260,1,'com_advancedmodules.module.121','com_advancedmodules.module.121',''),
	(149,1,261,262,1,'com_advancedmodules.module.122','com_advancedmodules.module.122',''),
	(150,1,263,264,1,'com_advancedmodules.module.128','com_advancedmodules.module.128',''),
	(151,1,265,266,1,'com_advancedmodules.module.129','com_advancedmodules.module.129',''),
	(152,1,267,268,1,'com_advancedmodules.module.131','com_advancedmodules.module.131',''),
	(153,1,269,270,1,'com_advancedmodules.module.132','com_advancedmodules.module.132',''),
	(154,1,271,272,1,'com_advancedmodules.module.133','com_advancedmodules.module.133',''),
	(155,1,273,274,1,'com_advancedmodules.module.136','com_advancedmodules.module.136',''),
	(156,1,275,276,1,'com_advancedmodules.module.137','com_advancedmodules.module.137',''),
	(157,1,277,278,1,'com_advancedmodules.module.138','com_advancedmodules.module.138',''),
	(158,1,279,280,1,'com_advancedmodules.module.139','com_advancedmodules.module.139',''),
	(159,1,281,282,1,'com_advancedmodules.module.142','com_advancedmodules.module.142',''),
	(160,1,283,284,1,'com_advancedmodules.module.144','com_advancedmodules.module.144',''),
	(161,1,285,286,1,'com_advancedmodules.module.145','com_advancedmodules.module.145',''),
	(162,1,287,288,1,'com_advancedmodules.module.146','com_advancedmodules.module.146',''),
	(163,1,289,290,1,'com_advancedmodules.module.147','com_advancedmodules.module.147',''),
	(164,1,291,292,1,'com_advancedmodules.module.148','com_advancedmodules.module.148',''),
	(165,1,293,294,1,'com_advancedmodules.module.149','com_advancedmodules.module.149',''),
	(166,1,295,296,1,'com_advancedmodules.module.150','com_advancedmodules.module.150',''),
	(167,1,297,298,1,'com_advancedmodules.module.151','com_advancedmodules.module.151',''),
	(168,1,299,300,1,'com_advancedmodules.module.152','com_advancedmodules.module.152',''),
	(169,1,301,302,1,'com_advancedmodules.module.153','com_advancedmodules.module.153',''),
	(170,1,303,304,1,'com_advancedmodules.module.154','com_advancedmodules.module.154',''),
	(171,1,305,306,1,'com_advancedmodules.module.155','com_advancedmodules.module.155',''),
	(172,1,307,308,1,'com_advancedmodules.module.156','com_advancedmodules.module.156',''),
	(173,1,309,310,1,'com_advancedmodules.module.157','com_advancedmodules.module.157',''),
	(174,1,311,312,1,'com_advancedmodules.module.158','com_advancedmodules.module.158',''),
	(175,1,313,314,1,'com_advancedmodules.module.159','com_advancedmodules.module.159',''),
	(176,1,315,316,1,'com_advancedmodules.module.160','com_advancedmodules.module.160',''),
	(177,1,317,318,1,'com_advancedmodules.module.161','com_advancedmodules.module.161',''),
	(178,1,319,320,1,'com_advancedmodules.module.162','com_advancedmodules.module.162',''),
	(179,1,321,322,1,'com_advancedmodules.module.163','com_advancedmodules.module.163',''),
	(180,1,323,324,1,'com_advancedmodules.module.165','com_advancedmodules.module.165',''),
	(181,1,325,326,1,'com_advancedmodules.module.166','com_advancedmodules.module.166',''),
	(182,1,327,328,1,'com_advancedmodules.module.167','com_advancedmodules.module.167',''),
	(183,1,329,330,1,'com_advancedmodules.module.168','com_advancedmodules.module.168',''),
	(184,1,331,332,1,'com_advancedmodules.module.169','com_advancedmodules.module.169',''),
	(185,1,333,334,1,'com_advancedmodules.module.170','com_advancedmodules.module.170',''),
	(186,1,335,336,1,'com_advancedmodules.module.172','com_advancedmodules.module.172',''),
	(187,1,337,338,1,'com_advancedmodules.module.175','com_advancedmodules.module.175',''),
	(188,1,339,340,1,'com_advancedmodules.module.177','com_advancedmodules.module.177',''),
	(189,1,341,342,1,'com_advancedmodules.module.180','com_advancedmodules.module.180',''),
	(190,1,343,344,1,'com_advancedmodules.module.182','Another tab','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(191,1,345,346,1,'com_advancedmodules.module.183','com_advancedmodules.module.183',''),
	(192,1,347,348,1,'com_advancedmodules.module.184','com_advancedmodules.module.184',''),
	(193,1,349,350,1,'com_advancedmodules.module.185','com_advancedmodules.module.185',''),
	(194,1,351,352,1,'com_advancedmodules.module.186','com_advancedmodules.module.186',''),
	(195,1,353,354,1,'com_advancedmodules.module.187','com_advancedmodules.module.187',''),
	(196,1,355,356,1,'com_advancedmodules.module.189','com_advancedmodules.module.189',''),
	(197,1,357,358,1,'com_advancedmodules.module.191','com_advancedmodules.module.191',''),
	(198,1,359,360,1,'com_advancedmodules.module.200','com_advancedmodules.module.200',''),
	(199,1,361,362,1,'com_advancedmodules.module.201','com_advancedmodules.module.201',''),
	(200,1,363,364,1,'com_advancedmodules.module.202','com_advancedmodules.module.202',''),
	(201,1,365,366,1,'com_advancedmodules.module.203','com_advancedmodules.module.203',''),
	(202,1,367,368,1,'com_advancedmodules.module.206','com_advancedmodules.module.206',''),
	(203,1,369,370,1,'com_advancedmodules.module.207','com_advancedmodules.module.207',''),
	(204,1,371,372,1,'com_advancedmodules.module.208','com_advancedmodules.module.208',''),
	(205,1,373,374,1,'com_advancedmodules.module.209','com_advancedmodules.module.209',''),
	(206,1,375,376,1,'com_advancedmodules.module.210','com_advancedmodules.module.210',''),
	(207,1,377,378,1,'com_advancedmodules.module.211','com_advancedmodules.module.211',''),
	(208,1,379,380,1,'com_advancedmodules.module.212','com_advancedmodules.module.212',''),
	(209,1,381,382,1,'com_advancedmodules.module.213','com_advancedmodules.module.213',''),
	(210,1,383,384,1,'com_advancedmodules.module.215','com_advancedmodules.module.215',''),
	(211,1,385,386,1,'com_advancedmodules.module.216','com_advancedmodules.module.216',''),
	(212,1,387,388,1,'com_advancedmodules.module.217','com_advancedmodules.module.217',''),
	(213,1,389,390,1,'com_advancedmodules.module.218','com_advancedmodules.module.218',''),
	(214,1,391,392,1,'com_advancedmodules.module.219','com_advancedmodules.module.219',''),
	(215,1,393,394,1,'com_advancedmodules.module.221','com_advancedmodules.module.221',''),
	(216,1,395,396,1,'com_advancedmodules.module.222','com_advancedmodules.module.222',''),
	(217,1,397,398,1,'com_advancedmodules.module.223','com_advancedmodules.module.223',''),
	(218,1,399,400,1,'com_advancedmodules.module.176','com_advancedmodules.module.176',''),
	(219,1,401,402,1,'com_advancedmodules.module.123','com_advancedmodules.module.123',''),
	(220,1,403,404,1,'com_advancedmodules.module.130','com_advancedmodules.module.130',''),
	(221,1,405,406,1,'com_advancedmodules.module.171','com_advancedmodules.module.171',''),
	(222,1,407,408,1,'com_advancedmodules.module.125','com_advancedmodules.module.125',''),
	(223,1,409,410,1,'com_advancedmodules.module.193','com_advancedmodules.module.193',''),
	(224,1,411,412,1,'com_advancedmodules.module.194','com_advancedmodules.module.194',''),
	(225,1,413,414,1,'com_advancedmodules.module.195','com_advancedmodules.module.195',''),
	(226,1,415,416,1,'com_advancedmodules.module.196','com_advancedmodules.module.196',''),
	(227,1,417,418,1,'com_advancedmodules.module.197','com_advancedmodules.module.197',''),
	(228,1,419,420,1,'com_advancedmodules.module.198','com_advancedmodules.module.198',''),
	(229,1,421,422,1,'com_advancedmodules.module.199','com_advancedmodules.module.199',''),
	(230,1,423,424,1,'com_advancedmodules.module.224','Module in a menu item','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}');

/*!40000 ALTER TABLE `#__assets` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__banner_clients
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__banner_clients`;

CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__banner_tracks
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__banner_tracks`;

CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__banners
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__banners`;

CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__categories
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__categories`;

CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__categories` WRITE;
/*!40000 ALTER TABLE `#__categories` DISABLE KEYS */;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`, `version`)
VALUES
	(1,0,0,0,41,0,'','system','ROOT',X'726F6F74','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',998,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),
	(2,27,1,1,2,1,'uncategorised','com_content','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',998,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),
	(3,28,1,3,4,1,'uncategorised','com_banners','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',998,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),
	(4,29,1,5,6,1,'uncategorised','com_contact','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',998,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),
	(5,30,1,7,8,1,'uncategorised','com_newsfeeds','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',998,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),
	(6,31,1,9,10,1,'uncategorised','com_weblinks','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',998,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),
	(7,32,1,11,12,1,'uncategorised','com_users','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',998,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),
	(8,35,1,13,20,1,'features','com_content','Features',X'6665617475726573','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:03:55',0,'0000-00-00 00:00:00',28,'*',1),
	(9,42,1,21,22,1,'services','com_content','Services',X'7365727669636573','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:21:46',0,'0000-00-00 00:00:00',84,'*',1),
	(10,43,1,23,24,1,'work','com_content','Work',X'776F726B','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:21:59',0,'0000-00-00 00:00:00',80,'*',1),
	(11,44,1,25,26,1,'news','com_content','News',X'6E657773','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:22:08',0,'0000-00-00 00:00:00',76,'*',1),
	(12,45,1,27,38,1,'about-us','com_content','About Us',X'61626F75742D7573','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:22:15',0,'0000-00-00 00:00:00',0,'*',1),
	(13,46,12,28,29,2,'about-us/about-the-company','com_content','About the company',X'61626F75742D7468652D636F6D70616E79','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:22:31',0,'0000-00-00 00:00:00',0,'*',1),
	(14,47,12,30,31,2,'about-us/meet-the-team','com_content','Meet the team',X'6D6565742D7468652D7465616D','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:22:43',0,'0000-00-00 00:00:00',377,'*',1),
	(15,48,12,32,33,2,'about-us/testimonials','com_content','Testimonials',X'74657374696D6F6E69616C73','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:22:55',0,'0000-00-00 00:00:00',7,'*',1),
	(16,49,12,34,35,2,'about-us/frequently-asked-questions','com_content','Frequently asked questions',X'6672657175656E746C792D61736B65642D7175657374696F6E73','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:23:14',0,'0000-00-00 00:00:00',17,'*',1),
	(17,50,12,36,37,2,'about-us/quotes','com_content','Quotes',X'71756F746573','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 08:23:25',0,'0000-00-00 00:00:00',0,'*',1),
	(18,85,1,39,40,1,'demo-content','com_content','Demo content',X'64656D6F2D636F6E74656E74','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 09:00:04',0,'0000-00-00 00:00:00',3,'*',1),
	(19,99,8,16,17,2,'features/typography','com_content','Typography',X'7479706F677261706879','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 21:16:39',933,'2012-12-20 23:28:10',0,'*',1),
	(20,100,8,14,15,2,'features/zentools-module','com_content','ZenTools Module',X'7A656E746F6F6C732D6D6F64756C65','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 21:16:49',0,'0000-00-00 00:00:00',73,'*',1),
	(21,103,8,18,19,2,'features/template-features','com_content','Template Features',X'74656D706C6174652D6665617475726573','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',998,'2012-12-20 23:28:34',0,'0000-00-00 00:00:00',0,'*',1);

/*!40000 ALTER TABLE `#__categories` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__contact_details
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__contact_details`;

CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__contact_details` WRITE;
/*!40000 ALTER TABLE `#__contact_details` DISABLE KEYS */;

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `hits`)
VALUES
	(1,'John Doe',X'6A6F686E2D646F65','position','address','City','State','Country','ZIP','Telephone','','<p>More information\'s can be added here</p>','','email@email.com',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":null,\"linkb_name\":\"\",\"linkb\":null,\"linkc_name\":\"\",\"linkc\":null,\"linkd_name\":\"\",\"linkd\":null,\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,4,1,'Mobile','http://Website','','','','*','2012-12-20 23:40:49',998,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,0);

/*!40000 ALTER TABLE `#__contact_details` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__content
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__content`;

CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__content` WRITE;
/*!40000 ALTER TABLE `#__content` DISABLE KEYS */;

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`)
VALUES
	(7,51,'Services #1',X'73657276696365732D31','<p><img class=\"border floatleft\" src=\"images/democontent/services/7703634_s.jpg\" alt=\"7703634 s\" width=\"400\" height=\"278\" />Cras nec lorem eget ligula varius aliquet at et mi. Fusce id quam in justo suscipit porta. Fusce non nisl nunc, id vestibulum augue. Donec interdum sapien vitae sem condimentum vel adipiscing leo consequat. In quis nisi sed velit lobortis congue in vulputate risus. Aliquam molestie, risus sed congue ullamcorper, mauris lacus volutpat mauris, nec luctus est risus in libero.</p>\n\n','\n\n<div class=\"divider\">&nbsp;</div>',1,9,'2012-12-20 08:23:54',998,'','2013-01-01 02:16:21',933,0,'0000-00-00 00:00:00','2012-12-20 08:23:54','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"1\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,2,'','',1,321,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(8,52,'Services #2',X'73657276696365732D32','<p><img src=\"images/democontent/services/photodune-653399-team-of-corporate-professionals-having-friendly-discussion-s.jpg\" width=\"425\" height=\"280\" alt=\"photodune-653399-team-of-corporate-professionals-having-friendly-discussion-s\" class=\"floatleft border\" />Cras nec lorem eget ligula varius aliquet at et mi. Fusce id quam in justo suscipit porta. Fusce non nisl nunc, id vestibulum augue. Donec interdum sapien vitae sem condimentum vel adipiscing leo consequat. In quis nisi sed velit lobortis congue in vulputate risus. Aliquam molestie, risus sed congue ullamcorper, mauris lacus volutpat mauris, nec luctus est risus in libero.</p>\n\n<div class=\"clear\"></div>\n\n','\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Overview</h2>\n\n<p>Aenean iaculis volutpat libero congue hendrerit. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus tempus tellus eu quam volutpat vehicula. Maecenas eget lorem orci, ut sagittis nulla. Donec non justo tortor, sit amet consequat enim. Mauris volutpat dignissim sagittis. Aliquam suscipit pharetra nibh, vel tincidunt sem lacinia ac. Aliquam vel magna ut dolor sagittis tincidunt. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam semper sem sit amet massa lobortis commodo. Nam scelerisque, eros interdum malesuada fermentum, ante ligula molestie quam, vitae eleifend diam lorem eget massa.</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Features</h2>\n\n<ul class=\"simple\">\n\n<li>Suspendisse mattis, mi a scelerisque pretium, leo mi semper est,</li>\n\n<li>Nunc venenatis dapibus fermentum.</li>\n\n<li>In luctus sapien sit amet velit vulputate et mollis elit bibendum.</li>\n\n<li>Donec ornare, diam sit amet imperdiet tincidunt.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>What do our customers say?</h2>\n\n<p>{jb_quote}Aenean pulvinar, nisi vitae volutpat molestie, sapien ligula imperdiet metus, quis sagittis nunc justo id ante. Maecenas id quam ut nunc molestie pharetra. Fusce facilisis vehicula consequat. Nam egestas lectus sodales risus elementum a fermentum nisl viverra. Sed tempus scelerisque lectus nec euismod. Cras vel justo ac mi interdum accumsan.{/jb_quote}</p>\n\n<p>{jb_author}Another happy customer{/jb_author}</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Get in touch</h2>\n\n<p>Suspendisse mattis, mi a scelerisque pretium, leo mi semper est, vel tincidunt dolor dolor non mi. Nunc venenatis dapibus fermentum. In luctus sapien sit amet velit vulputate et mollis elit bibendum. Donec ornare, diam sit amet imperdiet tincidunt, nisi elit congue mauris, vel consequat urna leo semper arcu.</p>',1,9,'2012-12-20 08:24:20',998,'','2013-01-02 23:35:57',933,0,'0000-00-00 00:00:00','2012-12-20 08:24:20','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,1,'','',1,19,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(9,53,'Services #3',X'73657276696365732D33','<img src=\"images/democontent/services/photodune-645566-female-executive-using-cellphone-with-colleagues-in-background-xs.jpg\" width=\"425\" height=\"280\" alt=\"photodune-645566-female-executive-using-cellphone-with-colleagues-in-background-xs\" class=\"floatleft border\" />\n\n<p>Cras nec lorem eget ligula varius aliquet at et mi. Fusce id quam in justo suscipit porta. Fusce non nisl nunc, id vestibulum augue. Donec interdum sapien vitae sem condimentum vel adipiscing leo consequat. In quis nisi sed velit lobortis congue in vulputate risus. Aliquam molestie, risus sed congue ullamcorper, mauris lacus volutpat mauris, nec luctus est risus in libero.</p>\n\n','\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Overview</h2>\n\n<p>{jb_iconic_tag}Aenean iaculis volutpat libero congue hendrerit. {/jb_iconic_tag}Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus tempus tellus eu quam volutpat vehicula. Maecenas eget lorem orci, ut sagittis nulla. Donec non justo tortor, sit amet consequat enim. Mauris volutpat dignissim sagittis. Aliquam suscipit pharetra nibh, vel tincidunt sem lacinia ac. Aliquam vel magna ut dolor sagittis tincidunt. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam semper sem sit amet massa lobortis commodo. Nam scelerisque, eros interdum malesuada fermentum, ante ligula molestie quam, vitae eleifend diam lorem eget massa.</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Features</h2>\n\n<ul class=\"simple\">\n\n<li>Suspendisse mattis, mi a scelerisque pretium, leo mi semper est,</li>\n\n<li>Nunc venenatis dapibus fermentum.</li>\n\n<li>In luctus sapien sit amet velit vulputate et mollis elit bibendum.</li>\n\n<li>Donec ornare, diam sit amet imperdiet tincidunt.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>What do our customers say?</h2>\n\n<p>{jb_quote}Aenean pulvinar, nisi vitae volutpat molestie, sapien ligula imperdiet metus, quis sagittis nunc justo id ante. Maecenas id quam ut nunc molestie pharetra. Fusce facilisis vehicula consequat. Nam egestas lectus sodales risus elementum a fermentum nisl viverra. Sed tempus scelerisque lectus nec euismod. Cras vel justo ac mi interdum accumsan.{/jb_quote}</p>\n\n<p>{jb_author}Another happy customer{/jb_author}</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Get in touch</h2>\n\n<p>Suspendisse mattis, mi a scelerisque pretium, leo mi semper est, vel tincidunt dolor dolor non mi. Nunc venenatis dapibus fermentum. In luctus sapien sit amet velit vulputate et mollis elit bibendum. Donec ornare, diam sit amet imperdiet tincidunt, nisi elit congue mauris, vel consequat urna leo semper arcu.</p>',1,12,'2012-12-20 08:24:37',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:24:37','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,7,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(10,54,'Services #4',X'73657276696365732D34','<p><img src=\"images/democontent/services/iStock_000015581511Small.jpg\" width=\"425\" height=\"282\" alt=\"iStock 000015581511Small\" class=\"floatleft border\" />Cras nec lorem eget ligula varius aliquet at et mi. Fusce id quam in justo suscipit porta. Fusce non nisl nunc, id vestibulum augue. Donec interdum sapien vitae sem condimentum vel adipiscing leo consequat. In quis nisi sed velit lobortis congue in vulputate risus. Aliquam molestie, risus sed congue ullamcorper, mauris lacus volutpat mauris, nec luctus est risus in libero.</p>\n\n','\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Overview</h2>\n\n<p>Aenean iaculis volutpat libero congue hendrerit. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus tempus tellus eu quam volutpat vehicula. Maecenas eget lorem orci, ut sagittis nulla. Donec non justo tortor, sit amet consequat enim. Mauris volutpat dignissim sagittis. Aliquam suscipit pharetra nibh, vel tincidunt sem lacinia ac. Aliquam vel magna ut dolor sagittis tincidunt. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam semper sem sit amet massa lobortis commodo. Nam scelerisque, eros interdum malesuada fermentum, ante ligula molestie quam, vitae eleifend diam lorem eget massa.</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Features</h2>\n\n<ul class=\"simple\">\n\n<li>Suspendisse mattis, mi a scelerisque pretium, leo mi semper est,</li>\n\n<li>Nunc venenatis dapibus fermentum.</li>\n\n<li>In luctus sapien sit amet velit vulputate et mollis elit bibendum.</li>\n\n<li>Donec ornare, diam sit amet imperdiet tincidunt.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>What do our customers say?</h2>\n\n<p>{jb_quote}Aenean pulvinar, nisi vitae volutpat molestie, sapien ligula imperdiet metus, quis sagittis nunc justo id ante. Maecenas id quam ut nunc molestie pharetra. Fusce facilisis vehicula consequat. Nam egestas lectus sodales risus elementum a fermentum nisl viverra. Sed tempus scelerisque lectus nec euismod. Cras vel justo ac mi interdum accumsan.{/jb_quote}</p>\n\n<p>{jb_author}Another happy customer{/jb_author}</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Get in touch</h2>\n\n<p>Suspendisse mattis, mi a scelerisque pretium, leo mi semper est, vel tincidunt dolor dolor non mi. Nunc venenatis dapibus fermentum. In luctus sapien sit amet velit vulputate et mollis elit bibendum. Donec ornare, diam sit amet imperdiet tincidunt, nisi elit congue mauris, vel consequat urna leo semper arcu.</p>',1,9,'2012-12-20 08:24:56',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:24:56','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,71,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(11,55,'Project #1',X'70726F6A6563742D31','<p><img class=\"floatleft border\" src=\"images/democontent/flowers/iStock_000018037983_ExtraSmall.jpg\" alt=\"iStock 000018037983 ExtraSmall\" 000015320462=\"\" extrasmall=\"\" width=\"347\" height=\"346\" /> Quisque convallis posuere pulvinar. Praesent convallis ultricies urna eu egestas. Vestibulum ut tempus mi. Nunc augue odio, imperdiet ac venenatis nec, faucibus ac felis. Pellentesque blandit urna ut augue sodales sagittis aliquet elit vestibulum. Praesent dictum ultricies ullamcorper. In malesuada dictum scelerisque.</p>\n\n','\n\n<h2>Project Details</h2>\n\n<ul class=\"\\&quot;\\\\&quot;simple\\\\&quot;\\&quot;\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Pellentesque vehicula dignissim augue, id semper nibh vestibulum ac.</li>\n\n<li>Etiam facilisis augue sed nisi adipiscing convallis.</li>\n\n</ul>\n\n<div class=\"\\&quot;\\\\&quot;divider\\\\&quot;\\&quot;\">&nbsp;</div>\n\n<h2>Project Gallery</h2>\n\n<div class=\"\\&quot;\\\\&quot;grid_four\\\\&quot;\\&quot;\">\n\n<p class=\"\\&quot;\\\\&quot;notice\\\\&quot;\\&quot;\">{jb_iconic_star}Click to view the full size image.{/jb_iconic_star}</p>\n\n</div>\n\n<div class=\"\\&quot;\\\\&quot;grid_eight\\&quot;\" zenlast=\"\\&quot;\\&quot;\">{loadposition project1}</div>\n\n<div class=\"\\&quot;\\\\&quot;divider\\\\&quot;\\&quot;\">&nbsp;</div>\n\n<h2>Common Objectives</h2>\n\n<ul class=\"\\&quot;\\\\&quot;simple\\\\&quot;\\&quot;\">\n\n<li>Morbi vitae eros est, eget eleifend magna.</li>\n\n<li>Nulla semper interdum quam, vel fringilla ipsum mattis ut.</li>\n\n<li>Vivamus adipiscing lacus eget nibh placerat volutpat.</li>\n\n<li>Curabitur fermentum urna sit amet.</li>\n\n<li>Nam eget magna eu velit faucibus aliquet a ac tellus.</li>\n\n</ul>\n\n<div class=\"\\&quot;\\\\&quot;divider\\\\&quot;\\&quot;\">&nbsp;</div>\n\n<h2>Client Feedback</h2>\n\n<p>{jb_quote} Phasellus imperdiet purus id sapien vulputate et molestie nunc eleifend. Nulla nec purus consectetur purus gravida molestie non et ligula. {/jb_quote} {jb_author}The Client{/jb_author}</p>\n\n<div class=\"\\&quot;\\\\&quot;divider\\\\&quot;\\&quot;\">&nbsp;</div>\n\n<h2>Outcomes</h2>\n\n<p>Phasellus imperdiet purus id sapien vulputate et molestie nunc eleifend. Nulla nec purus consectetur purus gravida molestie non et ligula. Praesent convallis, nunc et eleifend vehicula, diam leo mollis nisi, eget auctor quam urna id magna. Mauris at lacus sed diam euismod bibendum iaculis eget sem. In laoreet sem eget odio aliquet ac malesuada massa mollis.</p>',1,10,'2012-12-20 08:25:15',998,'','2012-12-28 05:10:49',933,0,'0000-00-00 00:00:00','2012-12-20 08:25:15','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',7,3,'','',1,273,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(12,56,'Project #2',X'70726F6A6563742D32','<p><img class=\"floatleft border\" src=\"images/democontent/flowers/iStock_000015320462_ExtraSmall.jpg\" alt=\"iStock 000015320462 ExtraSmall\" 000015379142=\"\" extrasmall=\"\" width=\"425\" height=\"282\" /> Quisque convallis posuere pulvinar. Praesent convallis ultricies urna eu egestas. Vestibulum ut tempus mi. Nunc augue odio, imperdiet ac venenatis nec, faucibus ac felis. Pellentesque blandit urna ut augue sodales sagittis aliquet elit vestibulum. Praesent dictum ultricies ullamcorper. In malesuada dictum scelerisque.</p>\n\n','\n\n<h2>Project Details</h2>\n\n<ul class=\"\\&quot;\\\\&quot;simple\\\\&quot;\\&quot;\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Pellentesque vehicula dignissim augue, id semper nibh vestibulum ac.</li>\n\n<li>Etiam facilisis augue sed nisi adipiscing convallis.</li>\n\n</ul>\n\n<div class=\"\\&quot;\\\\&quot;divider\\\\&quot;\\&quot;\">&nbsp;</div>\n\n<h2>Project Gallery</h2>\n\n<div class=\"\\&quot;\\\\&quot;grid_four\\\\&quot;\\&quot;\">\n\n<p class=\"\\&quot;\\\\&quot;notice\\\\&quot;\\&quot;\">{jb_iconic_star}Click to view the full size image.{/jb_iconic_star}</p>\n\n</div>\n\n<div class=\"\\&quot;\\\\&quot;grid_eight\\&quot;\" zenlast=\"\\&quot;\\&quot;\">{loadposition project2}</div>\n\n<div class=\"\\&quot;\\\\&quot;divider\\\\&quot;\\&quot;\">&nbsp;</div>\n\n<h2>Common Objectives</h2>\n\n<ul class=\"\\&quot;\\\\&quot;simple\\\\&quot;\\&quot;\">\n\n<li>Morbi vitae eros est, eget eleifend magna.</li>\n\n<li>Nulla semper interdum quam, vel fringilla ipsum mattis ut.</li>\n\n<li>Vivamus adipiscing lacus eget nibh placerat volutpat.</li>\n\n<li>Curabitur fermentum urna sit amet.</li>\n\n<li>Nam eget magna eu velit faucibus aliquet a ac tellus.</li>\n\n</ul>\n\n<div class=\"\\&quot;\\\\&quot;divider\\\\&quot;\\&quot;\">&nbsp;</div>\n\n<h2>Client Feedback</h2>\n\n<p>{jb_quote} Phasellus imperdiet purus id sapien vulputate et molestie nunc eleifend. Nulla nec purus consectetur purus gravida molestie non et ligula. {/jb_quote} {jb_author}The Client{/jb_author}</p>\n\n<div class=\"\\&quot;\\\\&quot;divider\\\\&quot;\\&quot;\">&nbsp;</div>\n\n<h2>Outcomes</h2>\n\n<p>{jb_iconic_tag}Phasellus imperdiet purus id sapien vulputate et molestie {/jb_iconic_tag}nunc eleifend. Nulla nec purus consectetur purus gravida molestie non et ligula. Praesent convallis, nunc et eleifend vehicula, diam leo mollis nisi, eget auctor quam urna id magna. Mauris at lacus sed diam euismod bibendum iaculis eget sem. In laoreet sem eget odio aliquet ac malesuada massa mollis.</p>',1,10,'2012-12-20 08:25:31',998,'','2012-12-28 05:10:57',933,0,'0000-00-00 00:00:00','2012-12-20 08:25:31','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',8,2,'','',1,125,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(13,57,'Project #3',X'70726F6A6563742D33','<p><img class=\"floatleft border\" src=\"images/democontent/flowers/iStock_000018037407_ExtraSmall.jpg\" alt=\"iStock 000018037407 ExtraSmall\" width=\"425\" height=\"282\" /> Quisque convallis posuere pulvinar. Praesent convallis ultricies urna eu egestas. Vestibulum ut tempus mi. Nunc augue odio, imperdiet ac venenatis nec, faucibus ac felis. Pellentesque blandit urna ut augue sodales sagittis aliquet elit vestibulum. Praesent dictum ultricies ullamcorper. In malesuada dictum scelerisque.</p>\n\n','\n\n<h2>Project Details</h2>\n\n<ul class=\"\\&quot;simple\\&quot;\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Pellentesque vehicula dignissim augue, id semper nibh vestibulum ac.</li>\n\n<li>Etiam facilisis augue sed nisi adipiscing convallis.</li>\n\n</ul>\n\n<div class=\"\\&quot;divider\\&quot;\">&nbsp;</div>\n\n<h2>Project Gallery</h2>\n\n<div class=\"\\&quot;grid_four\\&quot;\">\n\n<p class=\"\\&quot;notice\\&quot;\">{jb_iconic_star}Click to view the full size image.{/jb_iconic_star}</p>\n\n</div>\n\n<div class=\"\\&quot;grid_eight\" zenlast=\"\">{loadposition project3}</div>\n\n<div class=\"\\&quot;divider\\&quot;\">&nbsp;</div>\n\n<h2>Common Objectives</h2>\n\n<ul class=\"\\&quot;simple\\&quot;\">\n\n<li>Morbi vitae eros est, eget eleifend magna.</li>\n\n<li>Nulla semper interdum quam, vel fringilla ipsum mattis ut.</li>\n\n<li>Vivamus adipiscing lacus eget nibh placerat volutpat.</li>\n\n<li>Curabitur fermentum urna sit amet.</li>\n\n<li>Nam eget magna eu velit faucibus aliquet a ac tellus.</li>\n\n</ul>\n\n<div class=\"\\&quot;divider\\&quot;\">&nbsp;</div>\n\n<h2>Client Feedback</h2>\n\n<p>{jb_quote} Phasellus imperdiet purus id sapien vulputate et molestie nunc eleifend. Nulla nec purus consectetur purus gravida molestie non et ligula. {/jb_quote} {jb_author}The Client{/jb_author}</p>\n\n<div class=\"\\&quot;divider\\&quot;\">&nbsp;</div>\n\n<h2>Outcomes</h2>\n\n<p>Phasellus imperdiet purus id sapien vulputate et molestie nunc eleifend. Nulla nec purus consectetur purus gravida molestie non et ligula. Praesent convallis, nunc et eleifend vehicula, diam leo mollis nisi, eget auctor quam urna id magna. Mauris at lacus sed diam euismod bibendum iaculis eget sem. In laoreet sem eget odio aliquet ac malesuada massa mollis.</p>',1,10,'2012-12-20 08:26:12',998,'','2012-12-28 05:11:04',933,0,'0000-00-00 00:00:00','2012-12-20 08:26:12','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,1,'','',1,113,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(14,58,'Project #4',X'70726F6A6563742D34','<p><img class=\"floatleft border\" src=\"images/democontent/flowers/iStock_000015379142_ExtraSmall.jpg\" alt=\"iStock 000015379142 ExtraSmall\" width=\"425\" height=\"282\" /> Quisque convallis posuere pulvinar. Praesent convallis ultricies urna eu egestas. Vestibulum ut tempus mi. Nunc augue odio, imperdiet ac venenatis nec, faucibus ac felis. Pellentesque blandit urna ut augue sodales sagittis aliquet elit vestibulum. Praesent dictum ultricies ullamcorper. In malesuada dictum scelerisque.</p>\n\n','\n\n<h2>Project Details</h2>\n\n<ul class=\"\\&quot;simple\\&quot;\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Pellentesque vehicula dignissim augue, id semper nibh vestibulum ac.</li>\n\n<li>Etiam facilisis augue sed nisi adipiscing convallis.</li>\n\n</ul>\n\n<div class=\"\\&quot;divider\\&quot;\">&nbsp;</div>\n\n<h2>Project Gallery</h2>\n\n<div class=\"\\&quot;grid_four\\&quot;\">\n\n<p class=\"\\&quot;notice\\&quot;\">{jb_iconic_star}Click to view the full size image.{/jb_iconic_star}</p>\n\n</div>\n\n<div class=\"\\&quot;grid_eight\" zenlast=\"\">{loadposition project4}</div>\n\n<div class=\"\\&quot;divider\\&quot;\">&nbsp;</div>\n\n<h2>Common Objectives</h2>\n\n<ul class=\"\\&quot;simple\\&quot;\">\n\n<li>Morbi vitae eros est, eget eleifend magna.</li>\n\n<li>Nulla semper interdum quam, vel fringilla ipsum mattis ut.</li>\n\n<li>Vivamus adipiscing lacus eget nibh placerat volutpat.</li>\n\n<li>Curabitur fermentum urna sit amet.</li>\n\n<li>Nam eget magna eu velit faucibus aliquet a ac tellus.</li>\n\n</ul>\n\n<div class=\"\\&quot;divider\\&quot;\">&nbsp;</div>\n\n<h2>Client Feedback</h2>\n\n<p>{jb_quote} Phasellus imperdiet purus id sapien vulputate et molestie nunc eleifend. Nulla nec purus consectetur purus gravida molestie non et ligula. {/jb_quote} {jb_author}The Client{/jb_author}</p>\n\n<div class=\"\\&quot;divider\\&quot;\">&nbsp;</div>\n\n<h2>Outcomes</h2>\n\n<p>Phasellus imperdiet purus id sapien vulputate et molestie nunc eleifend. Nulla nec purus consectetur purus gravida molestie non et ligula. Praesent convallis, nunc et eleifend vehicula, diam leo mollis nisi, eget auctor quam urna id magna. Mauris at lacus sed diam euismod bibendum iaculis eget sem. In laoreet sem eget odio aliquet ac malesuada massa mollis.</p>',1,10,'2012-12-20 08:26:25',998,'','2012-12-28 05:11:10',933,0,'0000-00-00 00:00:00','2012-12-20 08:26:25','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',7,0,'','',1,155,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(15,59,'News #1',X'6E6577732D31','<p><img class=\"border\" src=\"images/democontent/news/iStock_000013332733Small.jpg\" border=\"0\" alt=\"iStock 000013332733Small\" width=\"425\" height=\"280\" /></p>\n\n<p>Cras nec lorem eget ligula varius aliquet at et mi. Fusce id quam in justo suscipit porta. Fusce non nisl nunc, id vestibulum augue. Donec interdum sapien vitae sem condimentum vel adipiscing leo consequat. In quis nisi sed velit lobortis congue in vulputate risus. Aliquam molestie, risus sed congue ullamcorper, mauris lacus volutpat mauris, nec luctus est risus in libero.</p>\n\n','\n\n<h2>Overview</h2>\n\n<p>Aenean iaculis volutpat libero congue hendrerit. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus tempus tellus eu quam volutpat vehicula. Maecenas eget lorem orci, ut sagittis nulla. Donec non justo tortor, sit amet consequat enim. Mauris volutpat dignissim sagittis. Aliquam suscipit pharetra nibh, vel tincidunt sem lacinia ac. Aliquam vel magna ut dolor sagittis tincidunt. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam semper sem sit amet massa lobortis commodo. Nam scelerisque, eros interdum malesuada fermentum, ante ligula molestie quam, vitae eleifend diam lorem eget massa.</p>\n\n<p>',1,11,'2012-12-20 08:37:13',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:37:13','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,3,'','',1,2,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(16,60,'News #2',X'6E6577732D32','<p><img class=\"border\" src=\"images/democontent/news/7703634_s.jpg\" border=\"0\" alt=\"7703634 s\" width=\"425\" height=\"280\" /></p>\n\n<p>Cras nec lorem eget ligula varius aliquet at et mi. Fusce id quam in justo suscipit porta. Fusce non nisl nunc, id vestibulum augue. Donec interdum sapien vitae sem condimentum vel adipiscing leo consequat. In quis nisi sed velit lobortis congue in vulputate risus. Aliquam molestie, risus sed congue ullamcorper, mauris lacus volutpat mauris, nec luctus est risus in libero.</p>\n\n','\n\n<h2>Overview</h2>\n\n<p>Aenean iaculis volutpat libero congue hendrerit. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus tempus tellus eu quam volutpat vehicula. Maecenas eget lorem orci, ut sagittis nulla. Donec non justo tortor, sit amet consequat enim. Mauris volutpat dignissim sagittis. Aliquam suscipit pharetra nibh, vel tincidunt sem lacinia ac. Aliquam vel magna ut dolor sagittis tincidunt. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam semper sem sit amet massa lobortis commodo. Nam scelerisque, eros interdum malesuada fermentum, ante ligula molestie quam, vitae eleifend diam lorem eget massa.</p>\n\n<p>',1,11,'2012-12-20 08:37:33',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:37:33','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(17,61,'News #3',X'6E6577732D33','<p><img class=\"border\" src=\"images/democontent/news/6317809_s.jpg\" border=\"0\" alt=\"6317809 s\" width=\"425\" height=\"280\" /></p>\n\n<p>Cras nec lorem eget ligula varius aliquet at et mi. Fusce id quam in justo suscipit porta. Fusce non nisl nunc, id vestibulum augue. Donec interdum sapien vitae sem condimentum vel adipiscing leo consequat. In quis nisi sed velit lobortis congue in vulputate risus. Aliquam molestie, risus sed congue ullamcorper, mauris lacus volutpat mauris, nec luctus est risus in libero.</p>\n\n','\n\n<h2>Overview</h2>\n\n<p>Aenean iaculis volutpat libero congue hendrerit. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus tempus tellus eu quam volutpat vehicula. Maecenas eget lorem orci, ut sagittis nulla. Donec non justo tortor, sit amet consequat enim. Mauris volutpat dignissim sagittis. Aliquam suscipit pharetra nibh, vel tincidunt sem lacinia ac. Aliquam vel magna ut dolor sagittis tincidunt. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam semper sem sit amet massa lobortis commodo. Nam scelerisque, eros interdum malesuada fermentum, ante ligula molestie quam, vitae eleifend diam lorem eget massa.</p>\n\n<p>',1,11,'2012-12-20 08:37:50',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:37:50','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,1,'','',1,3,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(18,62,'News #4',X'6E6577732D34','<p><img class=\"border\" src=\"images/democontent/news/485652_m.jpg\" border=\"0\" alt=\"485652 m\" width=\"425\" height=\"280\" /></p>\n\n<p>Cras nec lorem eget ligula varius aliquet at et mi. Fusce id quam in justo suscipit porta. Fusce non nisl nunc, id vestibulum augue. Donec interdum sapien vitae sem condimentum vel adipiscing leo consequat. In quis nisi sed velit lobortis congue in vulputate risus. Aliquam molestie, risus sed congue ullamcorper, mauris lacus volutpat mauris, nec luctus est risus in libero.</p>\n\n','\n\n<h2>Overview</h2>\n\n<p>Aenean iaculis volutpat libero congue hendrerit. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus tempus tellus eu quam volutpat vehicula. Maecenas eget lorem orci, ut sagittis nulla. Donec non justo tortor, sit amet consequat enim. Mauris volutpat dignissim sagittis. Aliquam suscipit pharetra nibh, vel tincidunt sem lacinia ac. Aliquam vel magna ut dolor sagittis tincidunt. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam semper sem sit amet massa lobortis commodo. Nam scelerisque, eros interdum malesuada fermentum, ante ligula molestie quam, vitae eleifend diam lorem eget massa.</p>\n\n<p>',1,11,'2012-12-20 08:38:09',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:38:09','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(19,63,'About The Company',X'61626F75742D7468652D636F6D70616E79','<p>Pharetra eu eget nibh. Aliquam a quam ipsum. Ut viverra ultricies urna sit amet bibendum. In sapien turpis, mattis ut sagittis a, interdum id felis. Suspendisse potenti. Fusce scelerisque laoreet leo a porttitor. Cras condimentum facilisis dignissim. Nullam quam felis, varius non dictum ornare, volutpat sed est.</p>\n\n<p>{jb_quote}Nulla in elit dolor. Quisque ullamcorper, nisi ac pharetra dictum, orci leo porttitor orci, at vehicula leo magna vel orci. Praesent sit amet quam tellus. Nullam ut dictum massa. Ut pulvinar sollicitudin eros. Duis vehicula.{/jb_quote}</p>\n\n<p>{jb_author}A Happy Customer{/jb_author}</p>\n\n','\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>We are on a mission.</h2>\n\n<p><img src=\"images/democontent/ourcompany/4754328_s.jpg\" width=\"240\" height=\"161\" alt=\"4754328 s\" class=\"border floatleft\" />Nulla in elit dolor. Quisque ullamcorper, nisi ac pharetra dictum, orci leo porttitor orci, at vehicula leo magna vel orci. Praesent sit amet quam tellus. Nullam ut dictum massa. Ut pulvinar sollicitudin eros. Duis vehicula.</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Social Conscience is a key factor.</h2>\n\n<p><img src=\"images/democontent/ourcompany/7129934_s.jpg\" width=\"240\" height=\"163\" alt=\"7129934 s\" class=\"border floatleft\" />Nulla in elit dolor. Quisque ullamcorper, nisi ac pharetra dictum, orci leo porttitor orci, at vehicula leo magna vel orci. Praesent sit amet quam tellus. Nullam ut dictum massa. Ut pulvinar sollicitudin eros. Duis vehicula.</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>The Secret to our success is in sustainability.</h2>\n\n<p><img src=\"images/democontent/ourcompany/3340170_s.jpg\" width=\"240\" height=\"160\" alt=\"3340170 s\" class=\"border floatleft\" />Nulla in elit dolor. Quisque ullamcorper, nisi ac pharetra dictum, orci leo porttitor orci, at vehicula leo magna vel orci. Praesent sit amet quam tellus. Nullam ut dictum massa. Ut pulvinar sollicitudin eros. Duis vehicula.</p>',1,13,'2012-12-20 08:38:41',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:38:41','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,108,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(20,64,'Carol Smith',X'6361726F6C2D736D697468','<p><img class=\"floatleft border\" src=\"images/democontent/team/photodune-1796420-woman-xs.jpg\" width=\"425\" height=\"283\" alt=\"photodune-1796420-woman-xs\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus lacinia sem sed sem lobortis viverra.</p>\n\n','\n\n<p>Integer elit lectus, porttitor eget aliquet ut, rhoncus sed dui. Sed sollicitudin ligula a nisi volutpat pretium. Quisque vitae nibh dolor, eu molestie tortor. Integer lobortis orci sit amet felis euismod semper. Etiam consectetur sem sagittis enim bibendum blandit.</p>\n\n<p>&nbsp;</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<div class=\"grid_six\">\n\n<h2>Work Experience</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque. Sed non sapien nisl. Duis condimentum sem faucibus urna laoreet porta. Quisque porta augue libero. Curabitur sed neque massa.</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"grid_six zenlast\">{jb_quote}Vestibulum porta nisi in purus egestas vehicula. Mauris ligula dolor, facilisis vel varius sit amet, fringilla at augue.{/jb_quote}</div>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Crucial Facts about me</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Praesent vel diam volutpat lorem aliquam sagittis et sit amet nunc.</li>\n\n<li>Donec dignissim ante id risus tempus pulvinar dictum vel ipsum.</li>\n\n<li>Aenean nec risus sed tortor tristique eleifend.</li>\n\n<li>Nam vehicula nulla ut enim sagittis aliquet.</li>\n\n<li>Phasellus in arcu a odio congue pulvinar.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Social Profile</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li><a href=\"#\">Twitter</a></li>\n\n<li><a href=\"#\">Facebook</a></li>\n\n<li><a href=\"#\">Google Plus</a></li>\n\n</ul>',1,14,'2012-12-20 08:38:59',998,'','2012-12-28 05:15:59',933,0,'0000-00-00 00:00:00','2012-12-20 08:38:59','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,4,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(21,65,'Julie Sanders',X'6A756C69652D73616E64657273','<p><img class=\"floatleft border\" src=\"images/democontent/team/iStock_000005965602XSmall.jpg\" border=\"0\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus lacinia sem sed sem lobortis viverra.</p>\n\n','\n\n<p>Integer elit lectus, porttitor eget aliquet ut, rhoncus sed dui. Sed sollicitudin ligula a nisi volutpat pretium. Quisque vitae nibh dolor, eu molestie tortor. Integer lobortis orci sit amet felis euismod semper. Etiam consectetur sem sagittis enim bibendum blandit.</p>\n\n<p>&nbsp;</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<div class=\"grid_six\">\n\n<h2>Work Experience</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque. Sed non sapien nisl. Duis condimentum sem faucibus urna laoreet porta. Quisque porta augue libero. Curabitur sed neque massa.</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"grid_six zenlast\">{jb_quote}Vestibulum porta nisi in purus egestas vehicula. Mauris ligula dolor, facilisis vel varius sit amet, fringilla at augue.{/jb_quote}</div>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Crucial Facts about me</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Praesent vel diam volutpat lorem aliquam sagittis et sit amet nunc.</li>\n\n<li>Donec dignissim ante id risus tempus pulvinar dictum vel ipsum.</li>\n\n<li>Aenean nec risus sed tortor tristique eleifend.</li>\n\n<li>Nam vehicula nulla ut enim sagittis aliquet.</li>\n\n<li>Phasellus in arcu a odio congue pulvinar.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Social Profile</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li><a href=\"#\">Twitter</a></li>\n\n<li><a href=\"#\">Facebook</a></li>\n\n<li><a href=\"#\">Google Plus</a></li>\n\n</ul>',1,14,'2012-12-20 08:39:16',998,'','2012-12-28 05:16:06',933,0,'0000-00-00 00:00:00','2012-12-20 08:39:16','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,3,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(22,66,'Patrick Johnson',X'7061747269636B2D6A6F686E736F6E','<p><img class=\"floatleft border\" src=\"images/democontent/team/iStock_000017659604XSmall.jpg\" width=\"425\" height=\"282\" alt=\"iStock 000017659604XSmall\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus lacinia sem sed sem lobortis viverra.</p>\n\n','\n\n<p>Integer elit lectus, porttitor eget aliquet ut, rhoncus sed dui. Sed sollicitudin ligula a nisi volutpat pretium. Quisque vitae nibh dolor, eu molestie tortor. Integer lobortis orci sit amet felis euismod semper. Etiam consectetur sem sagittis enim bibendum blandit.</p>\n\n<p>&nbsp;</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<div class=\"grid_six\">\n\n<h2>Work Experience</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque. Sed non sapien nisl. Duis condimentum sem faucibus urna laoreet porta. Quisque porta augue libero. Curabitur sed neque massa.</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"grid_six zenlast\">{jb_quote}Vestibulum porta nisi in purus egestas vehicula. Mauris ligula dolor, facilisis vel varius sit amet, fringilla at augue.{/jb_quote}</div>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Crucial Facts about me</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Praesent vel diam volutpat lorem aliquam sagittis et sit amet nunc.</li>\n\n<li>Donec dignissim ante id risus tempus pulvinar dictum vel ipsum.</li>\n\n<li>Aenean nec risus sed tortor tristique eleifend.</li>\n\n<li>Nam vehicula nulla ut enim sagittis aliquet.</li>\n\n<li>Phasellus in arcu a odio congue pulvinar.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Social Profile</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li><a href=\"#\">Twitter</a></li>\n\n<li><a href=\"#\">Facebook</a></li>\n\n<li><a href=\"#\">Google Plus</a></li>\n\n</ul>',1,14,'2012-12-20 08:39:35',998,'','2012-12-28 05:16:14',933,0,'0000-00-00 00:00:00','2012-12-20 08:39:35','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,2,'','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(23,67,'Samantha Cook',X'73616D616E7468612D636F6F6B','<p><img class=\"floatleft border\" src=\"images/democontent/team/photodune-1798779-woman-xs-1.jpg\" width=\"428\" height=\"282\" alt=\"photodune-1798779-woman-xs-1\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus lacinia sem sed sem lobortis viverra.</p>\n\n','\n\n<p>Integer elit lectus, porttitor eget aliquet ut, rhoncus sed dui. Sed sollicitudin ligula a nisi volutpat pretium. Quisque vitae nibh dolor, eu molestie tortor. Integer lobortis orci sit amet felis euismod semper. Etiam consectetur sem sagittis enim bibendum blandit.</p>\n\n<p>&nbsp;</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<div class=\"grid_six\">\n\n<h2>Work Experience</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque. Sed non sapien nisl. Duis condimentum sem faucibus urna laoreet porta. Quisque porta augue libero. Curabitur sed neque massa.</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"grid_six zenlast\">{jb_quote}Vestibulum porta nisi in purus egestas vehicula. Mauris ligula dolor, facilisis vel varius sit amet, fringilla at augue.{/jb_quote}</div>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Crucial Facts about me</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Praesent vel diam volutpat lorem aliquam sagittis et sit amet nunc.</li>\n\n<li>Donec dignissim ante id risus tempus pulvinar dictum vel ipsum.</li>\n\n<li>Aenean nec risus sed tortor tristique eleifend.</li>\n\n<li>Nam vehicula nulla ut enim sagittis aliquet.</li>\n\n<li>Phasellus in arcu a odio congue pulvinar.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Social Profile</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li><a href=\"#\">Twitter</a></li>\n\n<li><a href=\"#\">Facebook</a></li>\n\n<li><a href=\"#\">Google Plus</a></li>\n\n</ul>',1,14,'2012-12-20 08:40:07',998,'','2012-12-28 05:16:21',933,0,'0000-00-00 00:00:00','2012-12-20 08:40:07','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,1,'','',1,26,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(24,68,'Thomas Ewing',X'74686F6D61732D6577696E67','<p><img class=\"floatleft border\" src=\"images/democontent/team/photodune-2034477-pensive-man-xs.jpg\" width=\"425\" height=\"282\" alt=\"photodune-2034477-pensive-man-xs\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus lacinia sem sed sem lobortis viverra.</p>\n\n','\n\n<p>Integer elit lectus, porttitor eget aliquet ut, rhoncus sed dui. Sed sollicitudin ligula a nisi volutpat pretium. Quisque vitae nibh dolor, eu molestie tortor. Integer lobortis orci sit amet felis euismod semper. Etiam consectetur sem sagittis enim bibendum blandit.</p>\n\n<p>&nbsp;</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<div class=\"grid_six\">\n\n<h2>Work Experience</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque. Sed non sapien nisl. Duis condimentum sem faucibus urna laoreet porta. Quisque porta augue libero. Curabitur sed neque massa.</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"grid_six zenlast\">{jb_quote}Vestibulum porta nisi in purus egestas vehicula. Mauris ligula dolor, facilisis vel varius sit amet, fringilla at augue.{/jb_quote}</div>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Crucial Facts about me</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Praesent vel diam volutpat lorem aliquam sagittis et sit amet nunc.</li>\n\n<li>Donec dignissim ante id risus tempus pulvinar dictum vel ipsum.</li>\n\n<li>Aenean nec risus sed tortor tristique eleifend.</li>\n\n<li>Nam vehicula nulla ut enim sagittis aliquet.</li>\n\n<li>Phasellus in arcu a odio congue pulvinar.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Social Profile</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li><a href=\"#\">Twitter</a></li>\n\n<li><a href=\"#\">Facebook</a></li>\n\n<li><a href=\"#\">Google Plus</a></li>\n\n</ul>',1,14,'2012-12-20 08:40:27',998,'','2012-12-28 05:16:28',933,0,'0000-00-00 00:00:00','2012-12-20 08:40:27','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',3,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(25,69,'Walter Brown',X'77616C7465722D62726F776E','<p><img class=\"floatleft border\" src=\"images/democontent/team/photodune-1982542-scared-man-xs.jpg\" width=\"425\" height=\"282\" alt=\"photodune-1982542-scared-man-xs\" />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus lacinia sem sed sem lobortis viverra.</p>\n\n','\n\n<p>Integer elit lectus, porttitor eget aliquet ut, rhoncus sed dui. Sed sollicitudin ligula a nisi volutpat pretium. Quisque vitae nibh dolor, eu molestie tortor. Integer lobortis orci sit amet felis euismod semper. Etiam consectetur sem sagittis enim bibendum blandit.</p>\n\n<p>&nbsp;</p>\n\n<div class=\"divider\">&nbsp;</div>\n\n<div class=\"grid_six\">\n\n<h2>Work Experience</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque. Sed non sapien nisl. Duis condimentum sem faucibus urna laoreet porta. Quisque porta augue libero. Curabitur sed neque massa.</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"grid_six zenlast\">{jb_quote}Vestibulum porta nisi in purus egestas vehicula. Mauris ligula dolor, facilisis vel varius sit amet, fringilla at augue.{/jb_quote}</div>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Crucial Facts about me</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</li>\n\n<li>Praesent vel diam volutpat lorem aliquam sagittis et sit amet nunc.</li>\n\n<li>Donec dignissim ante id risus tempus pulvinar dictum vel ipsum.</li>\n\n<li>Aenean nec risus sed tortor tristique eleifend.</li>\n\n<li>Nam vehicula nulla ut enim sagittis aliquet.</li>\n\n<li>Phasellus in arcu a odio congue pulvinar.</li>\n\n</ul>\n\n<div class=\"divider\">&nbsp;</div>\n\n<h2>Social Profile</h2>\n\n<p>Fusce ac elementum lectus. Praesent feugiat scelerisque urna, vulputate rhoncus nunc imperdiet ac. Donec tempus fermentum felis ut scelerisque.</p>\n\n<ul class=\"simple\">\n\n<li><a href=\"#\">Twitter</a></li>\n\n<li><a href=\"#\">Facebook</a></li>\n\n<li><a href=\"#\">Google Plus</a></li>\n\n</ul>',1,14,'2012-12-20 08:40:36',998,'','2012-12-28 05:16:35',933,0,'0000-00-00 00:00:00','2012-12-20 08:40:36','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,'','',1,114,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(26,70,'Testimonial #1',X'74657374696D6F6E69616C2D31','<div class=\"grid_three\">\n\n<img src=\"images/democontent/testimonials/photodune-370601-family-xs.jpg\" width=\"120\" height=\"81\" alt=\"photodune-370601-family-xs\" class=\"floatleft border\" />\n\n</div>\n\n<div class=\"grid_nine zenlast\">{jb_quote}Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium.{/jb_quote}\n\n{jb_author}The Sampson Family{/jb_author}</div>','',1,15,'2012-12-20 08:41:08',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:41:08','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,5,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(27,71,'Testimonial #2',X'74657374696D6F6E69616C2D32','<div class=\"grid_three\"><img src=\"images/democontent/testimonials/3521285_s.jpg\" width=\"120\" height=\"84\" alt=\"3521285 s\" class=\"floatleft border\" /></div>\n\n<div class=\"grid_nine zenlast\">{jb_quote}Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium.{/jb_quote} {jb_author}Barbara Callan{/jb_author}</div>','',1,15,'2012-12-20 08:41:27',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:41:27','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,4,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(28,72,'Testimonial #3',X'74657374696D6F6E69616C2D33','<div class=\"grid_three\"><img src=\"images/democontent/testimonials/5447898_s.jpg\" width=\"120\" height=\"80\" alt=\"5447898 s\" class=\"floatleft border\" /></div>\n\n<div class=\"grid_nine zenlast\">{jb_quote}Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium.{/jb_quote} {jb_author}Matthew White{/jb_author}</div>','',1,15,'2012-12-20 08:41:43',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:41:43','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(29,73,'Testimonial #4',X'74657374696D6F6E69616C2D34','<div class=\"grid_three\"><img src=\"images/democontent/testimonials/7529939_s.jpg\" width=\"120\" height=\"80\" alt=\"7529939 s\" class=\"floatleft border\" /></div>\n\n<div class=\"grid_nine zenlast\">{jb_quote}Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium.{/jb_quote} {jb_author}Cynthia Wagner{/jb_author}</div>','',1,15,'2012-12-20 08:41:59',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:41:59','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(30,74,'Testimonial #5',X'74657374696D6F6E69616C2D35','<div class=\"grid_three\"><img src=\"images/democontent/testimonials/8171280_s.jpg\" width=\"120\" height=\"80\" alt=\"8171280 s\" class=\"floatleft border\" /></div>\n\n<div class=\"grid_nine zenlast\">{jb_quote}Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium.{/jb_quote} {jb_author}Stacia Garden{/jb_author}</div>','',1,15,'2012-12-20 08:42:14',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:42:14','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(31,75,'Testimonial #6',X'74657374696D6F6E69616C2D36','<div class=\"grid_three\"><img src=\"images/democontent/testimonials/iStock_000011678217Small.jpg\" width=\"120\" height=\"80\" alt=\"iStock 000011678217Small\" class=\"floatleft border\" /></div>\n\n<div class=\"grid_nine zenlast\">{jb_quote}Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium.{/jb_quote} {jb_author}Pamela Edwards{/jb_author}</div>','',1,15,'2012-12-20 08:42:30',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:42:30','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(32,76,'Q: Fusce scelerisque laoreet leo a porttitor. Cras condimentum facilisis dignissim.?',X'712D66757363652D7363656C657269737175652D6C616F726565742D6C656F2D612D706F72747469746F722D637261732D636F6E64696D656E74756D2D666163696C697369732D6469676E697373696D','<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium, elementum et nunc. Vestibulum in turpis nulla, hendrerit pulvinar tellus.</p>','',1,16,'2012-12-20 08:43:36',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:43:36','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,5,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(33,77,'Q: morbi tristique senectus et netus et?',X'712D6D6F7262692D7472697374697175652D73656E65637475732D65742D6E657475732D6574','<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium, elementum et nunc. Vestibulum in turpis nulla, hendrerit pulvinar tellus.</p>','',1,16,'2012-12-20 08:43:52',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:43:52','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,4,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(34,78,'Q: Nullam quam felis, varius non dictum ornare, volutpat sed est?',X'712D6E756C6C616D2D7175616D2D66656C69732D7661726975732D6E6F6E2D64696374756D2D6F726E6172652D766F6C75747061742D7365642D657374','<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium, elementum et nunc. Vestibulum in turpis nulla, hendrerit pulvinar tellus.</p>','',1,16,'2012-12-20 08:44:16',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:44:16','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(35,79,'Q: Praesent sit amet quam tellus?',X'712D7072616573656E742D7369742D616D65742D7175616D2D74656C6C7573','<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium, elementum et nunc. Vestibulum in turpis nulla, hendrerit pulvinar tellus.</p>','',1,16,'2012-12-20 08:44:40',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:44:40','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(36,80,'Q: Quisque ullamcorper, nisi ac pharetra dictum, orci leo porttitor orci?',X'712D717569737175652D756C6C616D636F727065722D6E6973692D61632D70686172657472612D64696374756D2D6F7263692D6C656F2D706F72747469746F722D6F726369','<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium, elementum et nunc. Vestibulum in turpis nulla, hendrerit pulvinar tellus.</p>','',1,16,'2012-12-20 08:44:55',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:44:55','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(37,81,'Q: Vestibulum in turpis nulla, hendrerit pulvinar tellus?',X'712D766573746962756C756D2D696E2D7475727069732D6E756C6C612D68656E6472657269742D70756C76696E61722D74656C6C7573','<p>Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi leo felis, convallis quis ornare pretium, elementum et nunc. Vestibulum in turpis nulla, hendrerit pulvinar tellus.</p>','',1,16,'2012-12-20 08:45:13',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:45:13','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,3,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(38,82,'Edison',X'656469736F6E','{jb_quote}\n\nMany of life\'s failures are people who did not realize how close they were to success when they gave up.\n\n{/jb_quote}\n\n{jb_author}Henry David Thoreau{/jb_author}','',1,17,'2012-12-20 08:45:35',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:45:35','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(39,83,'Maxwell',X'6D617877656C6C','{jb_quote}\n\nSuccessful and unsuccessful people do not vary greatly in their abilities. They vary in their desires to reach their potential.\n\n{/jb_quote}\n\n{jb_author}John Maxwell{/jb_author}','',1,17,'2012-12-20 08:45:53',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:45:53','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(40,84,'Thoreau',X'74686F72656175','{jb_quote}\n\nSuccess usually comes to those who are too busy to be looking for it.\n\n{/jb_quote}\n\n{jb_author}Henry David Thoreau{/jb_author}','',1,17,'2012-12-20 08:46:13',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 08:46:13','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(41,86,'All about pink',X'616C6C2D61626F75742D70696E6B','<p><img class=\"border floatleft\" src=\"images/democontent/flowers/iStock_000018037983_ExtraSmall.jpg\" alt=\"iStock 000018037983 ExtraSmall\" width=\"347\" height=\"346\" /></p>\n\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\n\n','\n\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\n\n<p>&nbsp;</p>\n\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\n\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,18,'2012-12-20 09:00:46',998,'','2012-12-28 05:39:16',933,0,'0000-00-00 00:00:00','2012-12-20 09:00:46','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,5,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(42,87,'Bespoke Verbosity',X'626573706F6B652D766572626F73697479','<p><img class=\"border\" src=\"images/democontent/flowers/iStock_000015379142_ExtraSmall.jpg\" alt=\"iStock 000015379142 ExtraSmall\" width=\"425\" height=\"282\" /></p>\n\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\n\n','\n\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\n\n<p>&nbsp;</p>\n\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\n\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,18,'2012-12-20 09:01:11',998,'','2012-12-28 05:39:27',933,0,'0000-00-00 00:00:00','2012-12-20 09:01:11','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,4,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(43,88,'Grass retrospective',X'67726173732D726574726F7370656374697665','<p><img class=\"border floatleft\" src=\"images/democontent/flowers/iStock_000015320462_ExtraSmall.jpg\" alt=\"iStock 000015320462 ExtraSmall\" width=\"425\" height=\"282\" /></p>\n\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\n\n','\n\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\n\n<p>&nbsp;</p>\n\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\n\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,18,'2012-12-20 09:01:30',998,'','2012-12-28 05:39:53',933,0,'0000-00-00 00:00:00','2012-12-20 09:01:30','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(44,89,'Inner growth',X'696E6E65722D67726F777468','<p><img class=\"border\" src=\"images/democontent/flowers/Brilliant+morning+unfolds.jpg\" alt=\"Brilliant+morning+unfolds\" width=\"425\" height=\"282\" /></p>\n\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\n\n','\n\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem.</p>\n\n<hr title=\"Part Two\" class=\"system-pagebreak\" alt=\"Part Two\" />\n\n<p>&nbsp;</p>\n\n<p>Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\n\n<p>&nbsp;</p>\n\n<hr title=\"Part Three\" class=\"system-pagebreak\" alt=\"Part Three\" />\n\n<p>&nbsp;</p>\n\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\n\n<hr title=\"Part Four\" class=\"system-pagebreak\" alt=\"Part Four\" />\n\n<p>&nbsp;</p>\n\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,18,'2012-12-20 09:02:15',998,'','2012-12-28 05:40:54',933,0,'0000-00-00 00:00:00','2012-12-20 09:02:15','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(45,90,'Midnight meadow',X'6D69646E696768742D6D6561646F77','<p><img src=\"images/democontent/flowers/Cold+macro+delight.jpg\" alt=\"Cold+macro+delight\" /></p>\n\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\n\n','\n\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\n\n<p>&nbsp;</p>\n\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\n\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,18,'2012-12-20 09:02:37',998,'','2012-12-31 00:43:18',933,0,'0000-00-00 00:00:00','2012-12-20 09:02:37','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(51,98,'Typography',X'6A622D747970652D706C7567696E31','<p>Zen Base features a wide array of beautiful typography and layout snippets that puts the power back at your finger tips.</p>\n\n<p>&nbsp;</p>\n\n<p>&nbsp;</p>\n\n','\n\n<ul class=\"nav nav-tabs\" id=\"myTab\">\n\n<li class=\"active\"><a href=\"#headings\" data-toggle=\"tab\">Basic</a></li>\n\n<li><a data-toggle=\"tab\" href=\"#quotes\">Colours and blocks</a></li>\n\n<li><a data-toggle=\"tab\" href=\"#numbers\">Numbers</a></li>\n\n<li><a data-toggle=\"tab\" href=\"#fonticons\">Font Icons</a></li>\n\n<li><a data-toggle=\"tab\" href=\"#layout\">Formatting</a></li>\n\n</ul>\n\n<div class=\"tab-content\">\n\n<div class=\"tab-pane\" id=\"quotes\">\n\n<h3>Primary and secondary styles</h3>\n\n<p>The primary1 and secondary2 colours are defined in the template theme settings, while the primary2, primary3 and secondary2, secondary3 colours are calculated using LESS to deliver shades slightly darker and slightly lighter than the original.. &nbsp;The code used to create the blocks below are as follows:</p>\n\n<br />\n\n<h2 class=\"headline\">Blocks of colour</h2>\n\n<p class=\"subheading\">These blocks are generated based on the markup below.</p>\n\n<code>&lt;div class=\"primary1\"&gt;<br />&lt;p&gt;&lt;strong&gt;Primary1 &lt;/strong&gt;&lt;/p&gt;<br />&lt;p&gt;Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.&lt;/p&gt;<br />&lt;/div&gt;</code>\n\n<p>&nbsp;</p>\n\n{grid4}\n\n<div class=\"primary1\">\n\n<p><strong>Primary1</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4}\n\n<div class=\"primary2\">\n\n<p><strong>Primary2</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"primary3\">\n\n<p><strong>Primary3</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4_last} {grid4}\n\n<div class=\"secondary1\">\n\n<p><strong>Secondary1</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4}\n\n<div class=\"secondary2\">\n\n<p><strong>Secondary2</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"secondary3\">\n\n<p><strong>Secondary3</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4_last}\n\n<div class=\"clear\">&nbsp;</div>\n\n<h2 class=\"headline\">Borders</h2>\n\n<p class=\"subheading\">These blocks are generated based on the markup below.</p>\n\n<code>&lt;div class=\"primary1 border\"&gt;<br />&lt;p&gt;&lt;strong&gt;Primary1 &lt;/strong&gt;&lt;/p&gt;<br />&lt;p&gt;Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.&lt;/p&gt;<br />&lt;/div&gt;</code>\n\n<p>&nbsp;</p>\n\n{grid4}\n\n<div class=\"primary1 border\">\n\n<p><strong>Primary1 border</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4}\n\n<div class=\"primary2 border\">\n\n<p><strong>Primary2 border</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"primary3 border\">\n\n<p><strong>primary3 border</strong></p>\n\n<p>Aliquam condimentum volutpat odio lacinia vehicula.</p>\n\n</div>\n\n{/grid4_last} {grid4}\n\n<div class=\"secondary1 border\">\n\n<p><strong>Secondary1 border</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4}\n\n<div class=\"secondary2 border\">\n\n<p><strong>Secondary2 border</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"secondary3 border\">\n\n<p><strong>secondary3 border</strong></p>\n\n<p>Aliquam condimentum volutpat odio lacinia vehicula.</p>\n\n</div>\n\n{/grid4_last}\n\n<div class=\"clear\">&nbsp;</div>\n\n<h2 class=\"headline\">Rounded</h2>\n\n<p class=\"subheading\">The following items have a class \" rounded\" added to them to create the subtle rounded edge.</p>\n\n<code>&lt;div class=\"primary1 border\"&gt;<br />&lt;p&gt;&lt;strong&gt;Primary1 &lt;/strong&gt;&lt;/p&gt;<br />&lt;p&gt;Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.&lt;/p&gt;<br />&lt;/div&gt;</code>\n\n<p>&nbsp;</p>\n\n{grid4}\n\n<div class=\"primary1 rounded\">\n\n<p><strong>Primary1 rounded</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4}\n\n<div class=\"primary2 rounded\">\n\n<p><strong>Primary2 rounded</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"primary3 rounded\">\n\n<p><strong>primary3 rounded</strong></p>\n\n<p>Aliquam condimentum volutpat odio lacinia vehicula.</p>\n\n</div>\n\n{/grid4_last} {grid4}\n\n<div class=\"secondary1 rounded\">\n\n<p><strong>Secondary1 rounded</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4}\n\n<div class=\"secondary2 rounded\">\n\n<p><strong>Secondary2 rounded</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"secondary3 rounded\">\n\n<p><strong>secondary3 rounded</strong></p>\n\n<p>Aliquam condimentum volutpat odio lacinia vehicula.</p>\n\n</div>\n\n{/grid4_last}\n\n<div class=\"clear\">&nbsp;</div>\n\n<h2 class=\"headline\">Other styles and effects</h2>\n\n<p class=\"subheading\">The following classes can be applied to modules and html markup.</p>\n\n{grid4}\n\n<div class=\"shadow\">\n\n<p><strong>Shadow</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4}\n\n<div class=\"shadow2\">\n\n<p><strong>Shadow2</strong></p>\n\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum.</p>\n\n</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"border\">\n\n<p><strong>Border</strong></p>\n\n<p>Aliquam condimentum volutpat odio lacinia vehicula.</p>\n\n</div>\n\n{/grid4_last} </div>\n\n<div class=\"tab-pane active\" id=\"headings\">\n\n<div class=\"grid_six\">\n\n<h1>Heading 1</h1>\n\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\n\n<p>&nbsp;</p>\n\n<h2>Heading 2</h2>\n\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\n\n<p>&nbsp;</p>\n\n<h3>Heading 3</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"grid_six jblast\">\n\n<h4>Heading 4</h4>\n\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\n\n<p>&nbsp;</p>\n\n<h5>Heading 5</h5>\n\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\n\n<p>&nbsp;</p>\n\n<h6>Heading 6</h6>\n\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<h2 class=\"headline\">This is a heading with the class headline.</h2>\n\n<p class=\"subheading\">And a p tag with a class subheading.</p>\n\n<br /><br />\n\n<blockquote>A simple &lt;blockquote&gt; style.</blockquote>\n\n<p>&nbsp;</p>\n\n<p><strong>A simple paragraph.</strong></p>\n\n<p>With some <em>italic text</em>, some <strong>bold text</strong> and an <span style=\"text-decoration: underline;\">underline</span>.&nbsp;Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>\n\n<p>&nbsp;</p>\n\n<p><strong>Code / Pre Tags</strong></p>\n\n<p><code>&lt;li&gt;Morbi in sem quis dui placerat ornare. Pellentesque odio nisi, euismod in, pharetra a, ultricies in, diam. Sed arcu. Cras consequat.&lt;/li&gt;<br />&lt;li&gt;Praesent dapibus, neque id cursus faucibus, tortor neque egestas augue, eu vulputate magna eros eu erat. Aliquam erat volutpat. Nam dui mi, tincidunt quis, accumsan porttitor, facilisis luctus, metus.</code></p>\n\n<p><br /><br /></p>\n\n<h2>Notices and warnings</h2>\n\n<div class=\"alert alert-block\"><button type=\"button\" class=\"close\" data-dismiss=\"alert\">×</button>\n\n<h4>Warning!</h4>\n\nBest check yo self, you\'re not...</div>\n\n<div class=\"alert alert-error\">\n\n<h4>Error!</h4>\n\nMorbi in sem quis dui placerat ornare. Pellentesque odio nisi, euismod in, pharetra a, ultricies in, diam. Sed arcu. Cras consequat.</div>\n\n<div class=\"alert alert-success\">\n\n<h4>Success!</h4>\n\nMorbi in sem quis dui placerat ornare. Pellentesque odio nisi, euismod in, pharetra a, ultricies in, diam. Sed arcu. Cras consequat.</div>\n\n<div class=\"alert alert-info\">\n\n<h4>Information</h4>\n\nMorbi in sem quis dui placerat ornare. Pellentesque odio nisi, euismod in, pharetra a, ultricies in, diam. Sed arcu. Cras consequat.</div>\n\n<h2>Unordered, ordered and nested lists</h2>\n\n<ul>\n\n<li>Morbi in sem quis dui placerat ornare. Pellentesque odio nisi, euismod in, pharetra a, ultricies in, diam. Sed arcu. Cras consequat.</li>\n\n<li>Praesent dapibus, neque id cursus faucibus, tortor neque egestas augue, eu vulputate magna eros eu erat. Aliquam erat volutpat. Nam dui mi, tincidunt quis, accumsan porttitor, facilisis luctus, metus.\n\n<ul>\n\n<li>Lorem ipsum dolor sit amet, consectetuer adipiscing elit.</li>\n\n<li>Aliquam tincidunt mauris eu risus:<ol>\n\n<li>Lorem ipsum dolor sit amet, consectetuer adipiscing elit.</li>\n\n<li>Aliquam tincidunt mauris eu risus.</li>\n\n<li>Vestibulum auctor dapibus neque.</li>\n\n</ol></li>\n\n<li>Vestibulum auctor dapibus neque.</li>\n\n</ul>\n\n</li>\n\n<li>Phasellus ultrices nulla quis nibh. Quisque a lectus. Donec consectetuer ligula vulputate sem tristique cursus. Nam nulla quam, gravida non, commodo a, sodales sit amet, nisi.</li>\n\n<li>Pellentesque fermentum dolor. Aliquam quam lectus, facilisis auctor, ultrices ut, elementum vulputate, nunc.</li>\n\n</ul>\n\n<p>&nbsp;</p>\n\n<h2>Images</h2>\n\n<p><strong>An image with a border class.</strong></p>\n\n<p><em>Images will also scale to the width of the content when the browser is resized.</em></p>\n\n<p><img class=\"border\" src=\"images/democontent/flowers/iStock_000015320462_ExtraSmall.jpg\" alt=\"iStock 000015320462 ExtraSmall\" width=\"425\" height=\"282\" /></p>\n\n<p><br /><br /></p>\n\n<h2>Buttons</h2>\n\n<p><button class=\"btn\">I am a button</button></p>\n\n<p><button class=\"btn btn-success\">I am a success button</button></p>\n\n<p><button class=\"btn btn-primary\">I am a primary button</button></p>\n\n<p><button class=\"btn btn-warning\">I am a warning button</button></p>\n\n<p><button class=\"btn btn-info\">I am an info button</button></p>\n\n<p><button class=\"btn btn-danger\">I am a danger button</button></p>\n\n<p><br /><br /></p>\n\n<h2>Other markup code</h2>\n\n<p><a>hyperlink</a><br /> <abbr title=\"title\">abbreviation</abbr><br /> <strong>offset text typically styled in bold</strong><br /> <cite>cited title of a work</cite><br /> <del>deleted text</del><br /> <dfn title=\"title\">defining instance</dfn><br /> <em>emphatic stress</em><br /> <em>offset text typically styled in italic</em><br /> <ins>inserted text</ins><br /> <kbd>user input</kbd><br /> marked (highlighted) text<br /><samp>sample output</samp><br /> <small>small print</small><br /> <strong>strong importance</strong><br /> <sup>superscript</sup> <sub>subscript</sub><br /> <var>variable or placeholder text</var></p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"tab-pane\" id=\"numbers\">\n\n<p>Am assortment of css3 styling that is suited to displaying numbers.</p>\n\n<h2 class=\"headline\">Anvil styling</h2>\n\n<p class=\"subheading\">To replicate the style below please use the following html markup.</p>\n\n<code>&lt;div class=\"anvil primary1\"&gt;1&lt;/div&gt;</code><div class=\"clear\">&nbsp;</div> {grid2}\n\n\n\n<div class=\"anvil primary1\">1</div>\n\n{/grid2} {grid2}\n\n<div class=\"anvil primary2\">2</div>\n\n{/grid2} {grid2}\n\n<div class=\"anvil primary3\">3</div>\n\n{/grid2} {grid2}\n\n<div class=\"anvil secondary1\">4</div>\n\n{/grid2} {grid2}\n\n<div class=\"anvil secondary2\">5</div>\n\n{/grid2} {grid2_last}\n\n<div class=\"anvil secondary3\">6</div>\n\n{/grid2_last}\n\n<h2 class=\"headline\">Rounded-big styling</h2>\n\n<p class=\"subheading\">To replicate the style below please use the following html markup.</p>\n\n<code>&lt;div class=\"rounded-big primary1\"&gt;1&lt;/div&gt;</code> \n\n<div class=\"clear\">&nbsp;</div>\n\n{grid2}\n\n<div class=\"rounded-big primary1\">1</div>\n\n{/grid2} {grid2}\n\n<div class=\"rounded-big primary2\">2</div>\n\n{/grid2} {grid2}\n\n<div class=\"rounded-big primary3\">3</div>\n\n{/grid2} {grid2}\n\n<div class=\"rounded-big secondary1\">4</div>\n\n{/grid2} {grid2}\n\n<div class=\"rounded-big secondary2\">5</div>\n\n{/grid2} {grid2_last}\n\n<div class=\"rounded-big secondary3\">6</div>\n\n{/grid2_last}\n\n<div class=\"clear\"></div>\n\n<h2 class=\"headline\">Corner styling</h2>\n\n<p class=\"subheading\">To replicate the style below please use the following html markup.</p>\n\n<code>&lt;div class=\"corner primary1\"&gt;1&lt;/div&gt;</code> \n\n<div class=\"clear\">&nbsp;</div>\n\n{grid4}\n\n<div class=\"corner primary1\">1</div>\n\n{/grid4} {grid4}\n\n<div class=\"corner primary2\">2</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"corner primary3\">3</div>\n\n{/grid4_last} {grid4}\n\n<div class=\"corner secondary1\">4</div>\n\n{/grid4} {grid4}\n\n<div class=\"corner secondary2\">5</div>\n\n{/grid4} {grid4_last}\n\n<div class=\"corner secondary3\">6</div>\n\n{/grid4_last}</div>\n\n<div class=\"tab-pane\" id=\"fonticons\">\n\n<p>Icon fonts are great because they are a single font asset (no images needed) and are able to be scaled using traditional css techniques - this makes them fast and flexible. The icons behave like any other font and so you can specify their color, size background etc using some simple css. Font icons also scale to suit the pixel ratio of your browser - so no need to specify a new image for retina or higher pixel ratio devices.</p>\n\n<br /><br />\n\n<h2 class=\"headline\">Font Icon syntax</h2>\n\n<p>Using the font icons is as simple as using the following syntax in your Joomla content.</p>\n\n<p><code>[jb_icon-glass]Here is my font-iconified bit of text[/jb_icon-glass]</code></p>\n\n<p><em>Please change the square brackets above to the curly brackets {</em></p>\n\n<br /><br />\n\n<h2 class=\"headline\">List of available font icons:</h2>\n\n<p>{grid4} {jb_icon-glass}jb_icon-glass{/jb_icon-glass} {/grid4} {grid4} {jb_icon-folder-open}jb_icon-folder-open{/jb_icon-folder-open} {/grid4} {grid4_last} {jb_icon-download}jb_icon-download{/jb_icon-download} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-music}jb_icon-music{/jb_icon-music} {/grid4} {grid4} {jb_icon-resize-vertical}jb_icon-resize-vertical{/jb_icon-resize-vertical} {/grid4} {grid4_last} {jb_icon-upload}jb_icon-upload{/jb_icon-upload} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-search:}jb_icon-search:{/jb_icon-search:} {/grid4} {grid4} {jb_icon-resize-horizontal}jb_icon-resize-horizontal{/jb_icon-resize-horizontal} {/grid4} {grid4_last} {jb_icon-inbox}jb_icon-inbox{/jb_icon-inbox} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-envelope}jb_icon-envelope{/jb_icon-envelope} {/grid4} {grid4} {jb_icon-bar-chart}jb_icon-bar-chart{/jb_icon-bar-chart} {/grid4} {grid4_last} {jb_icon-play-circle}jb_icon-play-circle{/jb_icon-play-circle} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-heart}jb_icon-heart{/jb_icon-heart} {/grid4} {grid4} {jb_icon-twitter-sign}jb_icon-twitter-sign{/jb_icon-twitter-sign} {/grid4} {grid4_last} {jb_icon-repeat }jb_icon-repeat {/jb_icon-repeat } {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-star}jb_icon-star{/jb_icon-star} {/grid4} {grid4} {jb_icon-facebook-sign}jb_icon-facebook-sign{/jb_icon-facebook-sign} {/grid4} {grid4_last} {jb_icon-refresh}jb_icon-refresh{/jb_icon-refresh} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-star-empty}jb_icon-star-empty{/jb_icon-star-empty} {/grid4} {grid4} {jb_icon-camera-retro}jb_icon-camera-retro{/jb_icon-camera-retro} {/grid4} {grid4_last} {jb_icon-list-alt}jb_icon-list-alt{/jb_icon-list-alt} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-user}jb_icon-user{/jb_icon-user} {/grid4} {grid4} {jb_icon-key}jb_icon-key{/jb_icon-key} {/grid4} {grid4_last} {jb_icon-lock }jb_icon-lock {/jb_icon-lock } {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-film}jb_icon-film{/jb_icon-film} {/grid4} {grid4} {jb_icon-cogs}jb_icon-cogs{/jb_icon-cogs} {/grid4} {grid4_last} {jb_icon-flag}jb_icon-flag{/jb_icon-flag} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-th-large}jb_icon-th-large{/jb_icon-th-large} {/grid4} {grid4} {jb_icon-comments}jb_icon-comments{/jb_icon-comments} {/grid4} {grid4_last} {jb_icon-headphones}jb_icon-headphones{/jb_icon-headphones} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-th}jb_icon-th{/jb_icon-th} {/grid4} {grid4} {jb_icon-thumbs-up}jb_icon-thumbs-up{/jb_icon-thumbs-up} {/grid4} {grid4_last} {jb_icon-volume-off}jb_icon-volume-off{/jb_icon-volume-off} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-th-list}jb_icon-th-list{/jb_icon-th-list} {/grid4} {grid4} {jb_icon-thumbs-down}jb_icon-thumbs-down{/jb_icon-thumbs-down} {/grid4} {grid4_last} {jb_icon-volume-down}jb_icon-volume-down{/jb_icon-volume-down} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-ok}jb_icon-ok{/jb_icon-ok} {/grid4} {grid4} {jb_icon-star-half}jb_icon-star-half{/jb_icon-star-half} {/grid4} {grid4_last} {jb_icon-volume-up}jb_icon-volume-up{/jb_icon-volume-up} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-remove}jb_icon-remove{/jb_icon-remove} {/grid4} {grid4} {jb_icon-heart-empty}jb_icon-heart-empty{/jb_icon-heart-empty} {/grid4} {grid4_last} {jb_icon-qrcode}jb_icon-qrcode{/jb_icon-qrcode} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-zoom-in}jb_icon-zoom-in{/jb_icon-zoom-in} {/grid4} {grid4} {jb_icon-signout}jb_icon-signout{/jb_icon-signout} {/grid4} {grid4_last} {jb_icon-barcode}jb_icon-barcode{/jb_icon-barcode} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-zoom-out}jb_icon-zoom-out{/jb_icon-zoom-out} {/grid4} {grid4} {jb_icon-linkedin-sign}jb_icon-linkedin-sign{/jb_icon-linkedin-sign} {/grid4} {grid4_last} {jb_icon-tag}jb_icon-tag{/jb_icon-tag} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-off}jb_icon-off{/jb_icon-off} {/grid4} {grid4} {jb_icon-pushpin}jb_icon-pushpin{/jb_icon-pushpin} {/grid4} {grid4_last} {jb_icon-tags}jb_icon-tags{/jb_icon-tags} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-signal}jb_icon-signal{/jb_icon-signal} {/grid4} {grid4} {jb_icon-external-link}jb_icon-external-link{/jb_icon-external-link} {/grid4} {grid4_last} {jb_icon-book}jb_icon-book{/jb_icon-book} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-cog}jb_icon-cog{/jb_icon-cog} {/grid4} {grid4} {jb_icon-signin}jb_icon-signin{/jb_icon-signin} {/grid4} {grid4_last} {jb_icon-bookmark}jb_icon-bookmark{/jb_icon-bookmark} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-trash}jb_icon-trash{/jb_icon-trash} {/grid4} {grid4} {jb_icon-trophy}jb_icon-trophy{/jb_icon-trophy} {/grid4} {grid4_last} {jb_icon-print}jb_icon-print{/jb_icon-print} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-home}jb_icon-home{/jb_icon-home} {/grid4} {grid4} {jb_icon-github-sign}jb_icon-github-sign{/jb_icon-github-sign} {/grid4} {grid4_last} {jb_icon-camera}jb_icon-camera{/jb_icon-camera} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-file}jb_icon-file{/jb_icon-file} {/grid4} {grid4} {jb_icon-upload-alt}jb_icon-upload-alt{/jb_icon-upload-alt} {/grid4} {grid4_last} {jb_icon-font}jb_icon-font{/jb_icon-font} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-time}jb_icon-time{/jb_icon-time} {/grid4} {grid4} {jb_icon-lemon}jb_icon-lemon{/jb_icon-lemon} {/grid4} {grid4_last} {jb_icon-bold}jb_icon-bold{/jb_icon-bold} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-road}jb_icon-road{/jb_icon-road} {/grid4} {grid4} {jb_icon-phone}jb_icon-phone{/jb_icon-phone} {/grid4} {grid4_last} {jb_icon-italic}jb_icon-italic{/jb_icon-italic} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-download-alt}jb_icon-download-alt{/jb_icon-download-alt} {/grid4} {grid4} {jb_icon-check-empty}jb_icon-check-empty{/jb_icon-check-empty} {/grid4} {grid4_last} {jb_icon-text-height}jb_icon-text-height{/jb_icon-text-height} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-download}jb_icon-download{/jb_icon-download} {/grid4} {grid4} {jb_icon-bookmark-empty}jb_icon-bookmark-empty{/jb_icon-bookmark-empty} {/grid4} {grid4_last} {jb_icon-text-width}jb_icon-text-width{/jb_icon-text-width} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-upload}jb_icon-upload{/jb_icon-upload} {/grid4} {grid4} {jb_icon-phone-sign}jb_icon-phone-sign{/jb_icon-phone-sign} {/grid4} {grid4_last} {jb_icon-align-left}jb_icon-align-left{/jb_icon-align-left} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-inbox}jb_icon-inbox{/jb_icon-inbox} {/grid4} {grid4} {jb_icon-twitter}jb_icon-twitter{/jb_icon-twitter} {/grid4} {grid4_last} {jb_icon-align-center}jb_icon-align-center{/jb_icon-align-center} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-play-circle}jb_icon-play-circle{/jb_icon-play-circle} {/grid4} {grid4} {jb_icon-facebook}jb_icon-facebook{/jb_icon-facebook} {/grid4} {grid4_last} {jb_icon-align-right}jb_icon-align-right{/jb_icon-align-right} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-repeat}jb_icon-repeat{/jb_icon-repeat} {/grid4} {grid4} {jb_icon-github}jb_icon-github{/jb_icon-github} {/grid4} {grid4_last} {jb_icon-align-justify}jb_icon-align-justify{/jb_icon-align-justify} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-refresh}jb_icon-refresh{/jb_icon-refresh} {/grid4} {grid4} {jb_icon-unlock}jb_icon-unlock{/jb_icon-unlock} {/grid4} {grid4_last} {jb_icon-list}jb_icon-list{/jb_icon-list} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-list-alt}jb_icon-list-alt{/jb_icon-list-alt} {/grid4} {grid4} {jb_icon-credit-card}jb_icon-credit-card{/jb_icon-credit-card} {/grid4} {grid4_last} {jb_icon-indent-left}jb_icon-indent-left{/jb_icon-indent-left} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-lock}jb_icon-lock{/jb_icon-lock} {/grid4} {grid4} {jb_icon-rss}jb_icon-rss{/jb_icon-rss} {/grid4} {grid4_last} {jb_icon-indent-right}jb_icon-indent-right{/jb_icon-indent-right} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-flag}jb_icon-flag{/jb_icon-flag} {/grid4} {grid4} {jb_icon-hdd}jb_icon-hdd{/jb_icon-hdd} {/grid4} {grid4_last} {jb_icon-facetime-video}jb_icon-facetime-video{/jb_icon-facetime-video} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-headphones}jb_icon-headphones{/jb_icon-headphones} {/grid4} {grid4} {jb_icon-bullhorn}jb_icon-bullhorn{/jb_icon-bullhorn} {/grid4} {grid4_last} {jb_icon-picture}jb_icon-picture{/jb_icon-picture} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-volume-off}jb_icon-volume-off{/jb_icon-volume-off} {/grid4} {grid4} {jb_icon-bell}jb_icon-bell{/jb_icon-bell} {/grid4} {grid4_last} {jb_icon-pencil}jb_icon-pencil{/jb_icon-pencil} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-volume-down}jb_icon-volume-down{/jb_icon-volume-down} {/grid4} {grid4} {jb_icon-certificate}jb_icon-certificate{/jb_icon-certificate} {/grid4} {grid4_last} {jb_icon-map-marker }jb_icon-map-marker {/jb_icon-map-marker } {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-volume-up}jb_icon-volume-up{/jb_icon-volume-up} {/grid4} {grid4} {jb_icon-hand-right}jb_icon-hand-right{/jb_icon-hand-right} {/grid4} {grid4_last} {jb_icon-adjust}jb_icon-adjust{/jb_icon-adjust} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-qrcode}jb_icon-qrcode{/jb_icon-qrcode} {/grid4} {grid4} {jb_icon-hand-left}jb_icon-hand-left{/jb_icon-hand-left} {/grid4} {grid4_last} {jb_icon-tint}jb_icon-tint{/jb_icon-tint} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-barcode}jb_icon-barcode{/jb_icon-barcode} {/grid4} {grid4} {jb_icon-hand-down}jb_icon-hand-down{/jb_icon-hand-down} {/grid4} {grid4_last} {jb_icon-edit}jb_icon-edit{/jb_icon-edit} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-tag}jb_icon-tag{/jb_icon-tag} {/grid4} {grid4} {jb_icon-circle-arrow-left}jb_icon-circle-arrow-left{/jb_icon-circle-arrow-left} {/grid4} {grid4_last} {jb_icon-share}jb_icon-share{/jb_icon-share} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-tags}jb_icon-tags{/jb_icon-tags} {/grid4} {grid4} {jb_icon-circle-arrow-right}jb_icon-circle-arrow-right{/jb_icon-circle-arrow-right} {/grid4} {grid4_last} {jb_icon-check}jb_icon-check{/jb_icon-check} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-book}jb_icon-book{/jb_icon-book} {/grid4} {grid4} {jb_icon-circle-arrow-up}jb_icon-circle-arrow-up{/jb_icon-circle-arrow-up} {/grid4} {grid4_last} {jb_icon-move}jb_icon-move{/jb_icon-move} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-bookmark}jb_icon-bookmark{/jb_icon-bookmark} {/grid4} {grid4} {jb_icon-circle-arrow-down}jb_icon-circle-arrow-down{/jb_icon-circle-arrow-down} {/grid4} {grid4_last} {jb_icon-step-backward}jb_icon-step-backward{/jb_icon-step-backward} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-print}jb_icon-print{/jb_icon-print} {/grid4} {grid4} {jb_icon-globe}jb_icon-globe{/jb_icon-globe} {/grid4} {grid4_last} {jb_icon-fast-backward}jb_icon-fast-backward{/jb_icon-fast-backward} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-camera}jb_icon-camera{/jb_icon-camera} {/grid4} {grid4} {jb_icon-wrench}jb_icon-wrench{/jb_icon-wrench} {/grid4} {grid4_last} {jb_icon-backward}jb_icon-backward{/jb_icon-backward} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-font}jb_icon-font{/jb_icon-font} {/grid4} {grid4} {jb_icon-tasks}jb_icon-tasks{/jb_icon-tasks} {/grid4} {grid4_last} {jb_icon-play}jb_icon-play{/jb_icon-play} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-bold}jb_icon-bold{/jb_icon-bold} {/grid4} {grid4} {jb_icon-filter}jb_icon-filter{/jb_icon-filter} {/grid4} {grid4_last} {jb_icon-pause}jb_icon-pause{/jb_icon-pause} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-italic}jb_icon-italic{/jb_icon-italic} {/grid4} {grid4} {jb_icon-briefcase}jb_icon-briefcase{/jb_icon-briefcase} {/grid4} {grid4_last} {jb_icon-stop}jb_icon-stop{/jb_icon-stop} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-text-height}jb_icon-text-height{/jb_icon-text-height} {/grid4} {grid4} {jb_icon-fullscreen}jb_icon-fullscreen{/jb_icon-fullscreen} {/grid4} {grid4_last} {jb_icon-forward}jb_icon-forward{/jb_icon-forward} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-text-width}jb_icon-text-width{/jb_icon-text-width} {/grid4} {grid4} {jb_icon-group}jb_icon-group{/jb_icon-group} {/grid4} {grid4_last} {jb_icon-fast-forward}jb_icon-fast-forward{/jb_icon-fast-forward} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-align-left}jb_icon-align-left{/jb_icon-align-left} {/grid4} {grid4} {jb_icon-link}jb_icon-link{/jb_icon-link} {/grid4} {grid4_last} {jb_icon-step-forward}jb_icon-step-forward{/jb_icon-step-forward} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-align-center}jb_icon-align-center{/jb_icon-align-center} {/grid4} {grid4} {jb_icon-cloud}jb_icon-cloud{/jb_icon-cloud} {/grid4} {grid4_last} {jb_icon-eject}jb_icon-eject{/jb_icon-eject} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-align-right}jb_icon-align-right{/jb_icon-align-right} {/grid4} {grid4} {jb_icon-beaker}jb_icon-beaker{/jb_icon-beaker} {/grid4} {grid4_last} {jb_icon-chevron-left}jb_icon-chevron-left{/jb_icon-chevron-left} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-align-justify}jb_icon-align-justify{/jb_icon-align-justify} {/grid4} {grid4} {jb_icon-cut}jb_icon-cut{/jb_icon-cut} {/grid4} {grid4_last} {jb_icon-chevron-right }jb_icon-chevron-right {/jb_icon-chevron-right } {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-list}jb_icon-list{/jb_icon-list} {/grid4} {grid4} {jb_icon-copy}jb_icon-copy{/jb_icon-copy} {/grid4} {grid4_last} {jb_icon-plus-sign}jb_icon-plus-sign{/jb_icon-plus-sign} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-indent-left}jb_icon-indent-left{/jb_icon-indent-left} {/grid4} {grid4} {jb_icon-paper-clip}jb_icon-paper-clip{/jb_icon-paper-clip} {/grid4} {grid4_last} {jb_icon-minus-sign}jb_icon-minus-sign{/jb_icon-minus-sign} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-indent-right}jb_icon-indent-right{/jb_icon-indent-right} {/grid4} {grid4} {jb_icon-save}jb_icon-save{/jb_icon-save} {/grid4} {grid4_last} {jb_icon-remove-sign}jb_icon-remove-sign{/jb_icon-remove-sign} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-facetime-video}jb_icon-facetime-video{/jb_icon-facetime-video} {/grid4} {grid4} {jb_icon-sign-blank}jb_icon-sign-blank{/jb_icon-sign-blank} {/grid4} {grid4_last} {jb_icon-ok-sign}jb_icon-ok-sign{/jb_icon-ok-sign} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-picture}jb_icon-picture{/jb_icon-picture} {/grid4} {grid4} {jb_icon-reorder}jb_icon-reorder{/jb_icon-reorder} {/grid4} {grid4_last} {jb_icon-question-sign}jb_icon-question-sign{/jb_icon-question-sign} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-pencil}jb_icon-pencil{/jb_icon-pencil} {/grid4} {grid4} {jb_icon-list-ul}jb_icon-list-ul{/jb_icon-list-ul} {/grid4} {grid4_last} {jb_icon-info-sign}jb_icon-info-sign{/jb_icon-info-sign} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-map-marker}jb_icon-map-marker{/jb_icon-map-marker} {/grid4} {grid4} {jb_icon-list-ol}jb_icon-list-ol{/jb_icon-list-ol} {/grid4} {grid4_last} {jb_icon-screenshot}jb_icon-screenshot{/jb_icon-screenshot} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-adjust}jb_icon-adjust{/jb_icon-adjust} {/grid4} {grid4} {jb_icon-strikethrough}jb_icon-strikethrough{/jb_icon-strikethrough} {/grid4} {grid4_last} {jb_icon-remove-circle}jb_icon-remove-circle{/jb_icon-remove-circle} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-tint}jb_icon-tint{/jb_icon-tint} {/grid4} {grid4} {jb_icon-underline}jb_icon-underline{/jb_icon-underline} {/grid4} {grid4_last} {jb_icon-ok-circle}jb_icon-ok-circle{/jb_icon-ok-circle} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-edit}jb_icon-edit{/jb_icon-edit} {/grid4} {grid4} {jb_icon-table}jb_icon-table{/jb_icon-table} {/grid4} {grid4_last} {jb_icon-ban-circle}jb_icon-ban-circle{/jb_icon-ban-circle} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-share}jb_icon-share{/jb_icon-share} {/grid4} {grid4} {jb_icon-magic}jb_icon-magic{/jb_icon-magic} {/grid4} {grid4_last} {jb_icon-arrow-left}jb_icon-arrow-left{/jb_icon-arrow-left} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-check}jb_icon-check{/jb_icon-check} {/grid4} {grid4} {jb_icon-truck}jb_icon-truck{/jb_icon-truck} {/grid4} {grid4_last} {jb_icon-arrow-right}jb_icon-arrow-right{/jb_icon-arrow-right} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-move}jb_icon-move{/jb_icon-move} {/grid4} {grid4} {jb_icon-pinterest}jb_icon-pinterest{/jb_icon-pinterest} {/grid4} {grid4_last} {jb_icon-arrow-up}jb_icon-arrow-up{/jb_icon-arrow-up} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-step-backward}jb_icon-step-backward{/jb_icon-step-backward} {/grid4} {grid4} {jb_icon-pinterest-sign}jb_icon-pinterest-sign{/jb_icon-pinterest-sign} {/grid4} {grid4_last} {jb_icon-arrow-down}jb_icon-arrow-down{/jb_icon-arrow-down} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-fast-backward}jb_icon-fast-backward{/jb_icon-fast-backward} {/grid4} {grid4} {jb_icon-google-plus-sign}jb_icon-google-plus-sign{/jb_icon-google-plus-sign} {/grid4} {grid4_last} {jb_icon-share-alt}jb_icon-share-alt{/jb_icon-share-alt} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-backward}jb_icon-backward{/jb_icon-backward} {/grid4} {grid4} {jb_icon-google-plus}jb_icon-google-plus{/jb_icon-google-plus} {/grid4} {grid4_last} {jb_icon-resize-full}jb_icon-resize-full{/jb_icon-resize-full} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-play}jb_icon-play{/jb_icon-play} {/grid4} {grid4} {jb_icon-money}jb_icon-money{/jb_icon-money} {/grid4} {grid4_last} {jb_icon-resize-small}jb_icon-resize-small{/jb_icon-resize-small} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-pause}jb_icon-pause{/jb_icon-pause} {/grid4} {grid4} {jb_icon-caret-down}jb_icon-caret-down{/jb_icon-caret-down} {/grid4} {grid4_last} {jb_icon-plus}jb_icon-plus{/jb_icon-plus} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-stop}jb_icon-stop{/jb_icon-stop} {/grid4} {grid4} {jb_icon-caret-up}jb_icon-caret-up{/jb_icon-caret-up} {/grid4} {grid4_last} {jb_icon-minus}jb_icon-minus{/jb_icon-minus} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-forward}jb_icon-forward{/jb_icon-forward} {/grid4} {grid4} {jb_icon-caret-left}jb_icon-caret-left{/jb_icon-caret-left} {/grid4} {grid4_last} {jb_icon-asterisk}jb_icon-asterisk{/jb_icon-asterisk} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-fast-forward}jb_icon-fast-forward{/jb_icon-fast-forward} {/grid4} {grid4} {jb_icon-caret-right}jb_icon-caret-right{/jb_icon-caret-right} {/grid4} {grid4_last} {jb_icon-exclamation-sign}jb_icon-exclamation-sign{/jb_icon-exclamation-sign} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-step-forward}jb_icon-step-forward{/jb_icon-step-forward} {/grid4} {grid4} {jb_icon-columns}jb_icon-columns{/jb_icon-columns} {/grid4} {grid4_last} {jb_icon-gift}jb_icon-gift{/jb_icon-gift} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-eject}jb_icon-eject{/jb_icon-eject} {/grid4} {grid4} {jb_icon-sort}jb_icon-sort{/jb_icon-sort} {/grid4} {grid4_last} {jb_icon-leaf}jb_icon-leaf{/jb_icon-leaf} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-chevron-left}jb_icon-chevron-left{/jb_icon-chevron-left} {/grid4} {grid4} {jb_icon-sort-down}jb_icon-sort-down{/jb_icon-sort-down} {/grid4} {grid4_last} {jb_icon-fire}jb_icon-fire{/jb_icon-fire} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-chevron-right}jb_icon-chevron-right{/jb_icon-chevron-right} {/grid4} {grid4} {jb_icon-sort-up}jb_icon-sort-up{/jb_icon-sort-up} {/grid4} {grid4_last} {jb_icon-eye-open }jb_icon-eye-open {/jb_icon-eye-open } {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-plus-sign}jb_icon-plus-sign{/jb_icon-plus-sign} {/grid4} {grid4} {jb_icon-envelope-alt}jb_icon-envelope-alt{/jb_icon-envelope-alt} {/grid4} {grid4_last} {jb_icon-eye-close}jb_icon-eye-close{/jb_icon-eye-close} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-minus-sign}jb_icon-minus-sign{/jb_icon-minus-sign} {/grid4} {grid4} {jb_icon-linkedin}jb_icon-linkedin{/jb_icon-linkedin} {/grid4} {grid4_last} {jb_icon-warning-sign}jb_icon-warning-sign{/jb_icon-warning-sign} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-remove-sign}jb_icon-remove-sign{/jb_icon-remove-sign} {/grid4} {grid4} {jb_icon-undo}jb_icon-undo{/jb_icon-undo} {/grid4} {grid4_last} {jb_icon-plane}jb_icon-plane{/jb_icon-plane} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-ok-sign}jb_icon-ok-sign{/jb_icon-ok-sign} {/grid4} {grid4} {jb_icon-legal}jb_icon-legal{/jb_icon-legal} {/grid4} {grid4_last} {jb_icon-calendar}jb_icon-calendar{/jb_icon-calendar} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-question-sign}jb_icon-question-sign{/jb_icon-question-sign} {/grid4} {grid4} {jb_icon-dashboard}jb_icon-dashboard{/jb_icon-dashboard} {/grid4} {grid4_last} {jb_icon-random}jb_icon-random{/jb_icon-random} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-info-sign}jb_icon-info-sign{/jb_icon-info-sign} {/grid4} {grid4} {jb_icon-comment-alt}jb_icon-comment-alt{/jb_icon-comment-alt} {/grid4} {grid4_last} {jb_icon-comment}jb_icon-comment{/jb_icon-comment} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-screenshot}jb_icon-screenshot{/jb_icon-screenshot} {/grid4} {grid4} {jb_icon-comments-alt}jb_icon-comments-alt{/jb_icon-comments-alt} {/grid4} {grid4_last} {jb_icon-magnet}jb_icon-magnet{/jb_icon-magnet} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-remove-circle}jb_icon-remove-circle{/jb_icon-remove-circle} {/grid4} {grid4} {jb_icon-bolt}jb_icon-bolt{/jb_icon-bolt} {/grid4} {grid4_last} {jb_icon-chevron-up}jb_icon-chevron-up{/jb_icon-chevron-up} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-ok-circle}jb_icon-ok-circle{/jb_icon-ok-circle} {/grid4} {grid4} {jb_icon-sitemap}jb_icon-sitemap{/jb_icon-sitemap} {/grid4} {grid4_last} {jb_icon-chevron-down}jb_icon-chevron-down{/jb_icon-chevron-down} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-ban-circle}jb_icon-ban-circle{/jb_icon-ban-circle} {/grid4} {grid4} {jb_icon-umbrella}jb_icon-umbrella{/jb_icon-umbrella} {/grid4} {grid4_last} {jb_icon-retweet}jb_icon-retweet{/jb_icon-retweet} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-arrow-left}jb_icon-arrow-left{/jb_icon-arrow-left} {/grid4} {grid4} {jb_icon-paste}jb_icon-paste{/jb_icon-paste} {/grid4} {grid4_last} {jb_icon-shopping-cart}jb_icon-shopping-cart{/jb_icon-shopping-cart} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-arrow-right}jb_icon-arrow-right{/jb_icon-arrow-right} {/grid4} {grid4} {jb_icon-user-md}jb_icon-user-md{/jb_icon-user-md} {/grid4} {grid4_last} {jb_icon-folder-close}jb_icon-folder-close{/jb_icon-folder-close} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-arrow-up}jb_icon-arrow-up{/jb_icon-arrow-up} {/grid4} {grid4} {jb_icon-glass}jb_icon-glass{/jb_icon-glass} {/grid4} {grid4_last} {jb_icon-folder-open}jb_icon-folder-open{/jb_icon-folder-open} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-arrow-down}jb_icon-arrow-down{/jb_icon-arrow-down} {/grid4} {grid4} {jb_icon-music}jb_icon-music{/jb_icon-music} {/grid4} {grid4_last} {jb_icon-resize-vertical}jb_icon-resize-vertical{/jb_icon-resize-vertical} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-share-alt}jb_icon-share-alt{/jb_icon-share-alt} {/grid4} {grid4} {jb_icon-search}jb_icon-search{/jb_icon-search} {/grid4} {grid4_last} {jb_icon-resize-horizontal}jb_icon-resize-horizontal{/jb_icon-resize-horizontal} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-resize-full}jb_icon-resize-full{/jb_icon-resize-full} {/grid4} {grid4} {jb_icon-envelope}jb_icon-envelope{/jb_icon-envelope} {/grid4} {grid4_last} {jb_icon-hdd }jb_icon-hdd {/jb_icon-hdd } {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-resize-small}jb_icon-resize-small{/jb_icon-resize-small} {/grid4} {grid4} {jb_icon-heart}jb_icon-heart{/jb_icon-heart} {/grid4} {grid4_last} {jb_icon-bullhorn}jb_icon-bullhorn{/jb_icon-bullhorn} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-plus}jb_icon-plus{/jb_icon-plus} {/grid4} {grid4} {jb_icon-star}jb_icon-star{/jb_icon-star} {/grid4} {grid4_last} {jb_icon-bell}jb_icon-bell{/jb_icon-bell} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-minus}jb_icon-minus{/jb_icon-minus} {/grid4} {grid4} {jb_icon-star-empty}jb_icon-star-empty{/jb_icon-star-empty} {/grid4} {grid4_last} {jb_icon-certificate}jb_icon-certificate{/jb_icon-certificate} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-asterisk}jb_icon-asterisk{/jb_icon-asterisk} {/grid4} {grid4} {jb_icon-user}jb_icon-user{/jb_icon-user} {/grid4} {grid4_last} {jb_icon-thumbs-up}jb_icon-thumbs-up{/jb_icon-thumbs-up} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-exclamation-sign}jb_icon-exclamation-sign{/jb_icon-exclamation-sign} {/grid4} {grid4} {jb_icon-film}jb_icon-film{/jb_icon-film} {/grid4} {grid4_last} {jb_icon-thumbs-down}jb_icon-thumbs-down{/jb_icon-thumbs-down} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-gift}jb_icon-gift{/jb_icon-gift} {/grid4} {grid4} {jb_icon-th-large}jb_icon-th-large{/jb_icon-th-large} {/grid4} {grid4_last} {jb_icon-hand-right}jb_icon-hand-right{/jb_icon-hand-right} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-leaf}jb_icon-leaf{/jb_icon-leaf} {/grid4} {grid4} {jb_icon-th}jb_icon-th{/jb_icon-th} {/grid4} {grid4_last} {jb_icon-hand-left}jb_icon-hand-left{/jb_icon-hand-left} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-fire}jb_icon-fire{/jb_icon-fire} {/grid4} {grid4} {jb_icon-th-list}jb_icon-th-list{/jb_icon-th-list} {/grid4} {grid4_last} {jb_icon-hand-up}jb_icon-hand-up{/jb_icon-hand-up} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-eye-open}jb_icon-eye-open{/jb_icon-eye-open} {/grid4} {grid4} {jb_icon-ok}jb_icon-ok{/jb_icon-ok} {/grid4} {grid4_last} {jb_icon-hand-down}jb_icon-hand-down{/jb_icon-hand-down} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-eye-close}jb_icon-eye-close{/jb_icon-eye-close} {/grid4} {grid4} {jb_icon-remove}jb_icon-remove{/jb_icon-remove} {/grid4} {grid4_last} {jb_icon-circle-arrow-right}jb_icon-circle-arrow-right{/jb_icon-circle-arrow-right} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-warning-sign}jb_icon-warning-sign{/jb_icon-warning-sign} {/grid4} {grid4} {jb_icon-zoom-in}jb_icon-zoom-in{/jb_icon-zoom-in} {/grid4} {grid4_last} {jb_icon-circle-arrow-left}jb_icon-circle-arrow-left{/jb_icon-circle-arrow-left} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-plane}jb_icon-plane{/jb_icon-plane} {/grid4} {grid4} {jb_icon-zoom-out}jb_icon-zoom-out{/jb_icon-zoom-out} {/grid4} {grid4_last} {jb_icon-circle-arrow-up}jb_icon-circle-arrow-up{/jb_icon-circle-arrow-up} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-calendar}jb_icon-calendar{/jb_icon-calendar} {/grid4} {grid4} {jb_icon-off}jb_icon-off{/jb_icon-off} {/grid4} {grid4_last} {jb_icon-circle-arrow-down}jb_icon-circle-arrow-down{/jb_icon-circle-arrow-down} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-random}jb_icon-random{/jb_icon-random} {/grid4} {grid4} {jb_icon-signal}jb_icon-signal{/jb_icon-signal} {/grid4} {grid4_last} {jb_icon-globe}jb_icon-globe{/jb_icon-globe} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-comment}jb_icon-comment{/jb_icon-comment} {/grid4} {grid4} {jb_icon-cog }jb_icon-cog {/jb_icon-cog } {/grid4} {grid4_last} {jb_icon-wrench}jb_icon-wrench{/jb_icon-wrench} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-magnet}jb_icon-magnet{/jb_icon-magnet} {/grid4} {grid4} {jb_icon-trash}jb_icon-trash{/jb_icon-trash} {/grid4} {grid4_last} {jb_icon-tasks}jb_icon-tasks{/jb_icon-tasks} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-chevron-up}jb_icon-chevron-up{/jb_icon-chevron-up} {/grid4} {grid4} {jb_icon-home}jb_icon-home{/jb_icon-home} {/grid4} {grid4_last} {jb_icon-filter}jb_icon-filter{/jb_icon-filter} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-chevron-down}jb_icon-chevron-down{/jb_icon-chevron-down} {/grid4} {grid4} {jb_icon-file}jb_icon-file{/jb_icon-file} {/grid4} {grid4_last} {jb_icon-briefcase}jb_icon-briefcase{/jb_icon-briefcase} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-retweet}jb_icon-retweet{/jb_icon-retweet} {/grid4} {grid4} {jb_icon-time}jb_icon-time{/jb_icon-time} {/grid4} {grid4_last} {jb_icon-fullscreen}jb_icon-fullscreen{/jb_icon-fullscreen} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-shopping-cart}jb_icon-shopping-cart{/jb_icon-shopping-cart} {/grid4} {grid4} {jb_icon-road}jb_icon-road{/jb_icon-road} {/grid4} {grid4_last} {/grid4_last}</p>\n\n<p>{grid4} {jb_icon-folder-close}jb_icon-folder-close{/jb_icon-folder-close} {/grid4} {grid4} {jb_icon-download-alt}jb_icon-download-alt{/jb_icon-download-alt} {/grid4} {grid4_last} {/grid4_last}</p>\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"tab-pane\" id=\"layout\">\n\n<h3>JB Type Layout Setting</h3>\n\n<p>Using some simple JB Type syntax it is now possible to replicate the span markup used in the Bootstrap css framework. Separating a block of your content is as simple as wrapping it in some curly brackets.&nbsp;</p>\n\n<p><strong>Example:</strong></p>\n\n<p><code>[grid6]This is a block of content that will take up half of the width of the page.[/grid6]</code></p>\n\n<p>&nbsp;</p>\n\n<p><strong>Last grid block</strong></p>\n\n<p>To make the last item in the row fit in the row we need to use the _last suffix to make the block float right and also remove it\'s margin.</p>\n\n<p><strong>Example</strong></p>\n\n<code>[grid6_last]This is a block of content that will take up half of the width of the page.[/grid6_last].</code>\n\n<p><em>&nbsp;</em></p>\n\n<p><em>Please note that the above example uses square brackets as opposed to curly brackets to avoid the text rendering on the page.</em></p>\n\n<p><strong>&nbsp;</strong></p>\n\n<p><strong>List of available grids:</strong></p>\n\n<ul>\n\n<li>grid1</li>\n\n<li>grid2</li>\n\n<li>grid3</li>\n\n<li>grid4</li>\n\n<li>grid5</li>\n\n<li>grid6</li>\n\n<li>grid7</li>\n\n<li>grid8</li>\n\n<li>grid9</li>\n\n<li>grid10</li>\n\n<li>grid11</li>\n\n<li>grid12.</li>\n\n</ul>\n\n<p>Here are examples:</p>\n\n<p>{grid12}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid12</div>\n\n<p>{/grid12} {grid6}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid6</div>\n\n<p>{/grid6}{grid6_last}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid6_last</div>\n\n<p>{/grid6_last} {grid4}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid4</div>\n\n<p>{/grid4}{grid4}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid4</div>\n\n<p>{/grid4}{grid4_last}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid4_last</div>\n\n<p>{/grid4_last} {grid3}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid3</div>\n\n<p>{/grid3}{grid3}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid3</div>\n\n<p>{/grid3}{grid3}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid3</div>\n\n<p>{/grid3}{grid3_last}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid3_last</div>\n\n<p>{/grid3_last} {grid2}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid2</div>\n\n<p>{/grid2}{grid2}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid2</div>\n\n<p>{/grid2}{grid2}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid2</div>\n\n<p>{/grid2}{grid2}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid2</div>\n\n<p>{/grid2}{grid2}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid2</div>\n\n<p>{/grid2}{grid2_last}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid2_last</div>\n\n<p>{/grid2_last} {grid10}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid10</div>\n\n<p>{/grid10}{grid2_last}</p>\n\n<div style=\"background-color: #eee; width: 100%;\">grid2_last</div>\n\n<p>{/grid2_last}</p>\n\n<p>{jb_clear}{/jb_clear}</p>\n\n</div>\n\n</div>',1,19,'2012-12-20 21:15:27',998,'','2012-12-31 06:21:48',933,0,'0000-00-00 00:00:00','2012-12-20 21:15:27','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',134,1,'','',1,734,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(52,101,'Reusable grid layouts for your content',X'7265757361626C652D677269642D6C61796F7574732D666F722D796F75722D636F6E74656E74','<p><img src=\"images/democontent/zengridframework/gridsincontent.jpg\" width=\"650\" height=\"250\" alt=\"gridsincontent\" class=\"border\" /></p>\n\n<p>The blocks of text below are controlled via width classes that are built into the Zen Grid Framework.&nbsp;The classes scale according to your browser width and are useful for employing complex or interesting content layouts directly within your Joomla content.</p>\n\n','\n\n<h2>4 columns grid</h2>\n\n<div class=\"row\">\n\n{grid3}\n\n<p><strong>Grid_four.</strong> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium.</p>\n\n{/grid3}\n\n{grid3}\n\n<p><strong>Grid_four</strong>. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium.</p>\n\n{/grid3}\n\n{grid3}\n\n<p><strong>Grid_four</strong>. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium.</p>\n\n{/grid3}\n\n{grid3}\n\n<p><strong>Grid_four<strong style=\"font-weight: bold; font-style: inherit;\">&nbsp;w/ zenlast class</strong><br /></strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo.</p>\n\n{/grid3}\n\n</div>\n\n<p>&nbsp;</p>\n\n<p>&nbsp;</p>\n\n<h2>You can access the grid classes below in your wysiwyg editor.</h2>\n\n<p><img src=\"images/democontent/documentation/gridsincontent.png\" class=\"border\" alt=\"gridsincontent\" /></p>\n\n<p>&nbsp;</p>\n\n<div class=\"grid_twelve\"><br />\n\n<h2>A code sample</h2>\n\n<p><strong>Please note that since we are floating paragraphs both left and right you also need to clear the row of paragraphs after each row is populated. You can see a snippet of the html used below as an example.</strong></p>\n\n<pre>&lt;h2&gt;Simple 2 columns grid&lt;/h2&gt;<br />\n\n<br />&lt;div class=\"grid_six\"&gt;<br />&lt;p&gt;&lt;strong&gt;grid_six&lt;/strong&gt;.Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.&lt;/p&gt;<br />&lt;/div&gt;<br />&lt;div class=\"grid_six jblast\"&gt;<br />&lt;p&gt;&lt;strong&gt;grid_six with the zenlast class&lt;/strong&gt;.Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.&lt;/p&gt;<br />&lt;/div&gt;\n\n&lt;div class=\"clear\"&gt;&lt;/div&gt;</pre>\n\n<p>&nbsp;</p>\n\n<h2>Simple 2 columns grid</h2>\n\n</div>\n\n<div class=\"grid_six\">\n\n<p><strong>grid_six</strong>.Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n</div>\n\n<div class=\"grid_six jblast\">\n\n<p><strong>grid_six with the zenlast class</strong>.Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<h2>4 columns grid</h2>\n\n<div class=\"grid_three\">\n\n<p><strong>Grid_four.</strong> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n</div>\n\n<div class=\"grid_three\">\n\n<p><strong>Grid_four</strong>. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n</div>\n\n<div class=\"grid_three\">\n\n<p><strong>Grid_four</strong>. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n</div>\n\n<div class=\"grid_three jblast\">\n\n<p><strong>Grid_four<strong style=\"font-weight: bold; font-style: inherit;\">&nbsp;with the zenlast class</strong><br /></strong>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<div class=\"grid_nine\">\n\n<h2>2 columns, main content and sidebar</h2>\n\n<p><strong>Grid_nine</strong>.Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo. Mauris ultricies sapien id dolor lacinia porta. Etiam egestas pharetra molestie. Donec ullamcorper laoreet nisi et pulvinar.</p>\n\n</div>\n\n<div class=\"grid_three jblast\">\n\n<h2>Sidebar</h2>\n\n<h3>With a subtitle</h3>\n\n<p><strong style=\"font-weight: bold; font-style: inherit;\">Grid_three<strong style=\"font-weight: bold; font-style: inherit;\">&nbsp;with the zenlast class</strong></strong></p>\n\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla facilisis justo dictum justo accumsan pretium. Vestibulum sodales massa id dolor eleifend in bibendum odio pulvinar. Donec id laoreet augue. Nulla suscipit arcu vitae metus pellentesque cursus eu nec massa. Donec nec quam velit. Suspendisse potenti. Nam in est et nibh accumsan porta in eget lacus. Maecenas vestibulum scelerisque diam, nec tristique enim interdum a. Fusce eget sem justo.&nbsp;</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<h2>Units</h2>\n\n<div class=\"grid_one \">\n\n<h3>grid_one</h3>\n\n<p>Lorem ipsum dolor sit amet</p>\n\n</div>\n\n<div class=\"grid_eleven  jblast\">\n\n<h3>grid_eleven</h3>\n\n<p>&nbsp;</p>\n\n<p><strong style=\"font-weight: bold; font-style: inherit;\">Grid_eleven<strong style=\"font-weight: bold; font-style: inherit;\">&nbsp;with the zenlast class</strong></strong></p>\n\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.\n\n<p>&nbsp;</p>\n\n</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<div class=\"grid_two\">\n\n<h3>grid_two</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer&nbsp;</p>\n\n</div>\n\n<div class=\"grid_ten jblast\">\n\n<h3>grid_ten with additional zenlast class.</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet</p>\n\n</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<div class=\"grid_three\">\n\n<h3>grid_three</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam&nbsp;</p>\n\n</div>\n\n<div class=\"grid_nine jblast\">\n\n<h3>grid_nine&nbsp;with additional zenlast class</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci</p>\n\n</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<div class=\"grid_four\">\n\n<h3>grid_four</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.&nbsp;</p>\n\n</div>\n\n<div class=\"grid_eight jblast\">\n\n<h3>grid_eight&nbsp;with additional zenlast class</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.</p>\n\n</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<div class=\"grid_five\">\n\n<h3>grid_five</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud&nbsp;</p>\n\n</div>\n\n<div class=\"grid_seven jblast\">\n\n<h3>grid_seven&nbsp;with additional zenlast class</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.</p>\n\n</div>\n\n<div class=\"clear\">&nbsp;</div>\n\n<div class=\"grid_six\">\n\n<h3>grid_six</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.</p>\n\n</div>\n\n<div class=\"grid_six jblast\">\n\n<h3>grid_six&nbsp;with additional zenlast class</h3>\n\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.</p>\n\n</div>',1,19,'2012-12-20 21:37:37',998,'','2012-12-28 23:23:38',933,0,'0000-00-00 00:00:00','2012-12-20 21:37:37','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',7,2,'','',1,37,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(53,102,'Module classes',X'6D6F64756C652D636C6173736573','<p>This template comes with a wide variety of module classes that can be used to change the appearance and structure of your module classes.&nbsp;</p>\n\n<p>The module classes are broken up into the three broad categories - strucure, function and appearance.</p>\n\n<h2 class=\"headline\">Structural module classes</h2>\n\n<p class=\"subheading\">Used to change the position of a module</p>\n\n<p><strong>Positioning</strong></p>\n\n<ul>\n\n<li>top25 {margin-top: 25px}</li>\n\n<li>top50 {margin-top: 50px}</li>\n\n<li>top75 {margin-top: 75px}</li>\n\n<li>top100 {margin-top: 100px}</li>\n\n<li>top125 {margin-top: 125px}</li>\n\n<li>top150 {margin-top: 150px}</li>\n\n<li>top175 {margin-top: 175px}</li>\n\n<li>top200 {margin-top: 200px}</li>\n\n<li>top225 {margin-top: 225px}</li>\n\n<li>top250 {margin-top: 250px}</li>\n\n<li>top275 {margin-top: 275px}</li>\n\n<li>top300 {margin-top: 300px}</li>\n\n<li>top325 {margin-top: 325px}</li>\n\n<li>top350 {margin-top: 350px}</li>\n\n<li>top375 {margin-top: 375px}</li>\n\n<li>top400 {margin-top: 400px}</li>\n\n<li>top425 {margin-top: 425px}&nbsp;</li>\n\n<li>top450\" {margin-top: 450px}</li>\n\n<li>top475 {margin-top: 475px}</li>\n\n<li>top500 {margin-top: 500px}</li>\n\n</ul>\n\n<h2 class=\"headline\">Functional module styles</h2>\n\n<p class=\"subheading\">Used to change the function of a module</p>\n\n<p>All functional module classes are handled via the module chrome / style options in each module\'s module settings.</p>\n\n<p>Functional module styling available includes:</p>\n\n<ul>\n\n<li>zentabs - Bootstrap tab styling</li>\n\n<li>zenmodal - Bootstrap modal style</li>\n\n<li>zenslider - Bootstrap collapse style</li>\n\n<li>zenpopover - Bootstrap Popover style</li>\n\n</ul>\n\n<h2 class=\"headline\">Appearance module classes</h2>\n\n<p class=\"subheading\">Used to change the appearance of a module</p>\n\n<ul>\n\n<li>primary1</li>\n\n<li>primary2</li>\n\n<li>primary3</li>\n\n<li>secondary1</li>\n\n<li>secondary2</li>\n\n<li>secondary3</li>\n\n<li>inset</li>\n\n<li>border</li>\n\n<li>shadow</li>\n\n<li>shadow2</li>\n\n<li>hot - adds the word hot to the .moduletable h3 span:after</li>\n\n<li>new&nbsp;- adds the word new to the .moduletable h3 span:after</li>\n\n</ul>\n\n<p>The appearance module classes can be used in combination with each other to create more compel xmoduel styles. To use multiple styles together please ensure that each module class suffix is separated by a space as per the following example. Also please note that there needs to be a space before the start of the first class in order to render the class output properly:</p>\n\n<p><code>&nbsp;primary1 inset border</code></p>\n\n<p>&nbsp;</p>\n\n<h2 class=\"headline\">Font Icon Module classes</h2>\n\n<p class=\"subheading\">Add font awesome icons to your modules</p>\n\n<p>Using a combination of module classes, it is possible to create a wide range of module styles using the font awesome font icons.</p>\n\n<p>A typical module class suffix using the font icons looks like this:</p>\n\n<p><code>icon icon-comments large bottom secondary1</code></p>\n\n<ul>\n\n<li>icon - initiates the font icon display</li>\n\n<li>icon-comments - selects the icon to display. You can see a full list of icons available on the <a href=\"index.php/typography\">typography page</a>.</li>\n\n<li>large - (optional) You can choose between tiny, medium or large which set the font-size of the icon as follows: 1em, 2em (default), 4em and 8em.</li>\n\n<li>bottom - (optional) Displays the icon at the bottom of the module. By default the icon is set to display at the top.</li>\n\n<li>secondary1 - as per the examples on this page this refers to the built in colour control in the template.</li>\n\n</ul>\n\n<p>You can scroll down to the bottom of this page to see a very small selection of the styles in action.</p>','',1,21,'2012-12-20 23:27:47',998,'','2013-01-08 02:41:50',933,0,'0000-00-00 00:00:00','2012-12-20 23:27:47','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',20,2,'','',1,358,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(54,104,'Module Positions',X'6D6F64756C652D706F736974696F6E73','<p><img class=\"border\" src=\"images/democontent/documentation/modulepositions.jpg\" border=\"0\" alt=\"modulepositions\" width=\"650\" height=\"309\" /></p>\n\n<p>This template is built using the Zen Grid Framework and contains 52 module positions for you to use to create flexible page layouts. For a full understanding of how the module positions work in framework compatible templates please visit the Zen Grid Framework documentation.</p>\n\n<p>The screenshot below highlights the modules available in this template. For a run down on how we created the demo site for this template please visit the setup menu item and review the documentation available there.</p>\n\n','',1,21,'2012-12-20 23:30:27',998,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-20 23:30:27','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,1,'','',1,141,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(57,108,'Solid template framework',X'736F6C69642D74656D706C6174652D6672616D65776F726B','<h3><img src=\"images/democontent/documentation/t3-banner.png\" width=\"960\" height=\"432\" alt=\"t3-banner\" />Zen to the power of T3.</h3>\n\n<p>The Zen Base template is built on the powerful T3 template framework.</p>\n\n<p>T3 adds a new dimension to controlling and creating flexibile layouts for responsive Joomla templates and combined with the minimalism of our previous Zen Grid Framework templates, it\'s a combination that is hard to beat.</p>\n\n<p>T3 offers an incredible amount of control and flexibility. With it\'s easy to use drag and drop interface, the way you control what goes where in your website just got a whole lot easier.</p>\n\n<p>&nbsp;</p>\n\n<p><strong>Key features of the T3 framework:</strong></p>\n\n<ul>\n\n<li>Drag and drop templating interface</li>\n\n<li>Theme Magic interface for creating your own template style</li>\n\n<li>Less compiled templating system which enables you to do more with less code.</li>\n\n<li>High performance front and back end&nbsp;</li>\n\n<li>Built on Bootstrap to seamlessly work with other bootstrap based Joomla extensions</li>\n\n<li>Complete control over module positions and module position names</li>\n\n<li>Extended module chrome to leverage Bootstrap native functions such as sliders, tabs, modals and more.</li>\n\n</ul>\n\n<p>&nbsp;</p>','',1,21,'2012-12-30 23:45:17',998,'','2012-12-31 01:39:38',933,0,'0000-00-00 00:00:00','2012-12-30 23:45:17','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,'','',1,14,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(58,109,'Responsive by design',X'726573706F6E736976652D62792D64657369676E','<p><img src=\"images/democontent/documentation/zenbase-responsive.gif\" class=\"border\" width=\"600\" height=\"250\" alt=\"zenbase-responsive\" />The Zen Base Joomla template offers is a responsive, mobile friendly, device agnostic template that offers complete control over the look and feel of your website . The template has been created so that it scales effortlessly regardless of the device the user is viewing the web site on. This means that whether your visitors are mobile or stuck to the desk you and your content look good.</p>\n\n<p>&nbsp;</p>\n\n<p><strong>Powerful visual tools for determining module layouts.</strong></p>\n\n<p>The new T3 framework offers an unprecedented control over responsive layouts. Giving you the ultimate control over the width and type of modules available on 5 different screen sizes - check out the screenshots below for more.</p>\n\n<h3><strong>Control the number of modules to use on a single row at the click of a button.</strong></h3>\n\n<p>Using the module position layout you can control the number of modules to display in a given row.</p>\n\n<p><img src=\"images/democontent/documentation/modules/responsive1.jpg\" width=\"600\" height=\"325\" alt=\"responsive1\" class=\"border\" /></p>\n\n<h3><strong>&nbsp;</strong></h3>\n\n<h3><strong>Granular module control</strong></h3>\n\n<p>T3 now offers the ability to determine the name of the module you want to use in a particular position. Don\'t like what we have called an item? then no problem - just change it in the module position are in the template admin.</p>\n\n<p><img src=\"images/democontent/documentation/modules/responsive1a.jpg\" width=\"600\" height=\"420\" alt=\"responsive1a\" class=\"border\" /></p>\n\n<p><strong>&nbsp;</strong></p>\n\n<h3><strong>Control the width and visibility of those modules depending on the screensize.</strong></h3>\n\n<p>T3 offers the ability to specify the width and number of modules assigned to a row across a pre-defined number of common screensizes. The screenshot below shows four modules published evenly in the first grid row of modules for wide screen sizes.</p>\n\n<p><strong><img src=\"images/democontent/documentation/modules/responsive2.jpg\" width=\"600\" height=\"317\" alt=\"responsive2\" class=\"border\" /></strong></p>\n\n<p>&nbsp;</p>\n\n<p><strong>Desktop / Normal Screens</strong></p>\n\n<p>The screenshot below shows the same row with the grid2 module removed and the widths of each module adjusted to create a new layout - this will only be shown on normal / desktop screen sizes.</p>\n\n<p><img src=\"images/democontent/documentation/modules/responsive3.jpg\" width=\"600\" height=\"312\" alt=\"responsive3\" class=\"border\" /></p>\n\n<p>&nbsp;</p>\n\n<p><strong>Phone sized screens</strong></p>\n\n<p>And finally on mobile srceens the grid2 and grid3 positions have been removed and the modules that are left stretch to fill the full width of mobile screens.</p>\n\n<p><img src=\"images/democontent/documentation/modules/responsive4.jpg\" width=\"600\" height=\"560\" alt=\"responsive4\" class=\"border\" /></p>','',1,8,'2012-12-31 00:01:16',998,'','2012-12-31 01:41:56',933,0,'0000-00-00 00:00:00','2012-12-31 00:01:16','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,8,'','',1,28,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(59,110,'Thememagic magically themes your site',X'7468656D656D616769632D6D61676963616C6C792D7468656D65732D796F75722D73697465','<p><img src=\"images/democontent/documentation/thememagic/thememagic1.jpg\" width=\"297\" height=\"315\" alt=\"thememagic1\" class=\"border floatleft\" />The T3 framework also offers an incredible visual tool for controlling the visible appearance of your site.</p>\n\n<p>It\'s a LESS driven templating tool that allows you to create template styles on the fly.&nbsp;</p>\n\n<p>Need to change one of the preset styles but don\'t want to get your hand dirty? No problem ... just fire up Thememagic, change a colour setting, hit save an then you are done.</p>\n\n','\n\n<div class=\"clear\"></div>\n\n<h3>Full control over key colour settings in your template.</h3>\n\n<p><img src=\"images/democontent/documentation/thememagic/thememagic2.jpg\" width=\"587\" height=\"583\" class=\"border\" style=\"margin-bottom:30px\" alt=\"thememagic2\" /></p>\n\n<p> You can create multiple style variations on the fly and test out your colour skills with incredible ease - all&nbsp;<strong>without</strong> destroying the template defaults. You can experiement but if you need to go back to the starting board it\'s as easy as clicking a button (or perhaps two).</p>',1,8,'2012-12-31 00:19:44',998,'','2012-12-31 00:39:28',933,0,'0000-00-00 00:00:00','2012-12-31 00:19:44','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',9,7,'','',1,16,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(60,111,'The Golden Field',X'6D69646E696768742D6D6561646F772D32','<p><img src=\"images/democontent/flowers/The+golden+field.jpg\" alt=\"The+golden+field\" width=\"693\" height=\"350\" /></p>\n\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\n\n','\n\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\n\n<p>&nbsp;</p>\n\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\n\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,18,'2012-12-20 09:02:37',998,'','2012-12-31 00:44:12',933,0,'0000-00-00 00:00:00','2012-12-20 09:02:37','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',3,0,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(63,114,'Template Features',X'74656D706C6174652D6665617475726573','<p><img src=\"images/democontent/documentation/zenbase-responsive.gif\" width=\"600\" height=\"250\" alt=\"zenbase-responsive\" class=\"border floatleft\" /></p>\n\n<div class=\"clear\">&nbsp;</div>\n\n<p>Zen Base is a simple, solid responsive skeleton built for Jooml 2.5 / Joomla 3.0 on the powerful T3 Joomla template framework.</p>\n\n<p>It\'s a powerful scaffold to build your next Joomal website on and includes features such as:</p>\n\n<ul>\n\n<li>Complete Bootstrap integration</li>\n\n<li>Powerful templating layout tools</li>\n\n<li>Easy colour customisation</li>\n\n<li>Google font ready</li>\n\n<li>Responsive layout and design</li>\n\n<li>Multiple module chromes to display modules using the native bootstrap functions such as tabs, sliders, modals and more.&nbsp;</li>\n\n<li>A healthy array of typography and module classes using JB Type and built in styling.</li>\n\n</ul>\n\n<p>&nbsp;</p>','',1,8,'2012-12-31 02:16:03',998,'','2012-12-31 02:20:28',933,0,'0000-00-00 00:00:00','2012-12-31 02:16:03','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,6,'','',1,73,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),
	(64,115,'Module Chrome',X'6D6F64756C652D6368726F6D65','<p>The Zen Base template comes with built in module style / chrome that can be used to implement core Bootstrap component functionality like tabbed layouts, sliders, modal windows and even the pop over display.</p>\n\n<p>&nbsp;</p>\n\n<h2 class=\"headline\">Granular control over module style</h2>\n\n<p class=\"subheading\">One of the key features of Joomla 3.0 is the ability to assign modules a specific module chrome.</p>\n\n<p>Prior to Joomal 3.0 each module position was required to have the module style hard coded into the template. There were certain workarounds available for doing this in versions prior to Joomla 3.0 but workarounds to Joomla always come at a cost.</p>\n\n<p>&nbsp;</p>\n\n<h3>Assigning a new module chrome to a module.</h3>\n\n<p>Assigning a new module style to a module is as simple as selecting a style from the drop down list in the module manager.</p>\n\n<p>1. In your module manager edit the moduel you want to assign the new chrome to.</p>\n\n<p>2. Click on the Advanced options tab</p>\n\n<p>3. Scroll down the page and select the module style from the select list.</p>\n\n<p>4. Click apply.</p>\n\n<p><img src=\"images/democontent/documentation/chrome.png\" width=\"400\" height=\"567\" alt=\"chrome\" class=\"border\" /></p>\n\n<h2 class=\"headline\">Module style examples</h2>\n\n<p class=\"subheading\">The following module styles are available in this template.</p>\n\n<ul>\n\n<li>zendefault - A default module chrome</li>\n\n<li>zentabs - a tabbed interface</li>\n\n<li>zenslider - use the module title to slide open or closed a module</li>\n\n<li>zenmodal - Use the module title to trigger a modal window with the module content in the modal window.</li>\n\n<li>zenpopover - Use the module title to display a tooltip / popover with the module content.</li>\n\n</ul>','',1,8,'2012-12-31 06:36:26',998,'','2012-12-31 06:50:48',933,0,'0000-00-00 00:00:00','2012-12-31 06:36:26','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,5,'','',1,86,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(65,116,'Tabbed module styles',X'7461626265642D6D6F64756C652D7374796C6573','<p>The tabbed module style is a group of modules assigned to the same position and given the zentabs module style in the module settings. The tab triggers are populated by the module title and the tab content is the actual module content.</p>\n\n\n\n<h2 class=\"headline\">Demonstration</h2>\n\n<p class=\"subheading\">Click the titles below to view the contents of the module.</p>\n\n<p>&nbsp;{loadposition tabs}</p>\n\n','',1,8,'2012-12-31 09:00:27',998,'','2013-01-01 00:13:32',933,0,'0000-00-00 00:00:00','2012-12-31 09:00:27','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,4,'','',1,118,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(66,117,'Modal module style',X'7461626265642D6D6F64756C652D7374796C65732D32','<p>The modal module style replicates the core Bootstrap modal window functionality.</p>\n\n<p>When a module is given this module style it will automatically create the necessary markup to display the module title as a button which when clicked will then display the content of the module in a modal window.&nbsp;</p>\n\n<p>&nbsp;</p>\n\n<h2 class=\"headline\">Demonstration</h2>\n\n<p class=\"subheading\">Click the titles below to view the contents of the module in a modal window.</p>\n\n{loadposition modal}','',1,8,'2012-12-31 09:00:27',998,'','2013-01-01 00:15:07',933,0,'0000-00-00 00:00:00','2012-12-31 09:00:27','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',7,3,'','',1,45,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(67,118,'Slider Style',X'7461626265642D6D6F64756C652D7374796C65732D33','<p>The slider module style is a group of modules assigned to the same position and given the zentabs module style in the module settings.</p>\n\n<p>When there are more than one modules assigned to the same position and given the same zentab style the modules are displayed in a tabbed layout based on the core Bootstrap tab functionality.&nbsp;</p>\n\n<p>&nbsp;</p>\n\n<h2 class=\"headline\">Demonstration</h2>\n\n<p class=\"subheading\">Click the titles below to view the contents of the module.</p>\n\n<p>&nbsp;{loadposition slider}</p>\n\n','',1,8,'2012-12-31 09:00:27',998,'','2013-01-01 00:16:18',933,0,'0000-00-00 00:00:00','2012-12-31 09:00:27','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',9,2,'','',1,151,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(68,119,'Popover Module style',X'7461626265642D6D6F64756C652D7374796C65732D34','\n\n<p>The popover module style replicates the Bootstrap popover functionality - a clickable button that produces a content popover / tooltip when clicked.</p>\n\n<p>The module title serves as the text for the popover button while the actual module content provides the content for the popover text.</p>\n\n<h2 class=\"headline\">Demonstration</h2>\n\n<p class=\"subheading\">Click the buttons below to view the contents of the module.</p>\n\n<p>&nbsp;{loadposition popover}</p>\n\n<p>&nbsp;</p>','',1,8,'2012-12-31 09:00:27',998,'','2013-01-01 00:15:26',933,0,'0000-00-00 00:00:00','2012-12-31 09:00:27','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',8,1,'','',1,86,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(69,120,'Module Overview',X'6D6F64756C6573','<p><img src=\"images/democontent/documentation/modulepositions.jpg\" width=\"650\" height=\"309\" alt=\"modulepositions\" /></p>\n\n<h2 class=\"headline\">A myriad of module positions</h2>\n\n<p class=\"subheading\">The Zen base template has 40+ module positions.</p>\n\n<p>You don\'t need to use all of them at the same time, but if you need a position, then it\'s highly likely that the Zen Base template has got you covered. <a href=\"index.php?option=com_content&amp;view=article&amp;id=54&amp;Itemid=129\">More&nbsp;</a></p>\n\n<p>&nbsp;</p>\n\n<h2 class=\"headline\">A collection of classes</h2>\n\n<p class=\"subheading\">Eleven base classes that can be combined to create an unlimited number of module classes.</p>\n\n<p>Want to change the colour of a module? Easily add flavour to your layouts by adding simple to use moduel class suffixes for any of your modules. <a href=\"index.php?option=com_content&amp;view=article&amp;id=53&amp;Itemid=130\">More.</a></p>\n\n<p>&nbsp;</p>\n\n<h2 class=\"headline\">Bootstrap inspired module chrome</h2>\n\n<p class=\"subheading\">Create modal windows, tabs, sliders and popovers out of the box</p>\n\n<p>The module chrome functionality in this template provides an easy / out of the box solution for adding the core Bootstrap functionality within your &nbsp;module layouts. <a href=\"index.php?option=com_content&amp;view=article&amp;id=64&amp;Itemid=145\">More</a>.</p>','',1,8,'2013-01-01 01:53:02',998,'','2013-01-01 02:10:23',933,0,'0000-00-00 00:00:00','2013-01-01 01:53:02','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,0,'','',1,149,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');

/*!40000 ALTER TABLE `#__content` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__content_frontpage
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__content_frontpage`;

CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__content_frontpage` WRITE;
/*!40000 ALTER TABLE `#__content_frontpage` DISABLE KEYS */;

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`)
VALUES
	(61,2),
	(63,1);

/*!40000 ALTER TABLE `#__content_frontpage` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__content_rating
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__content_rating`;

CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__contentitem_tag_map
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__contentitem_tag_map`;

CREATE TABLE `#__contentitem_tag_map` (
  `type_alias` varchar(255) NOT NULL DEFAULT '',
  `core_content_id` int(10) unsigned NOT NULL COMMENT 'PK from the core content table',
  `content_item_id` int(11) NOT NULL COMMENT 'PK from the content type table',
  `tag_id` int(10) unsigned NOT NULL COMMENT 'PK from the tag table',
  `tag_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Date of most recent save for this tag-item',
  `type_id` mediumint(8) NOT NULL COMMENT 'PK from the content_type table',
  UNIQUE KEY `uc_ItemnameTagid` (`type_id`,`content_item_id`,`tag_id`),
  KEY `idx_tag_type` (`tag_id`,`type_id`),
  KEY `idx_date_id` (`tag_date`,`tag_id`),
  KEY `idx_tag` (`tag_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_core_content_id` (`core_content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps items from content tables to tags';



# Dump of table #__extensions
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__extensions`;

CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__extensions` WRITE;
/*!40000 ALTER TABLE `#__extensions` DISABLE KEYS */;

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`)
VALUES
	(1,'com_mailto','component','com_mailto','',0,1,1,1,'{\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(2,'com_wrapper','component','com_wrapper','',0,1,1,1,'{\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(3,'com_admin','component','com_admin','',1,1,1,1,'{\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(4,'com_banners','component','com_banners','',1,1,1,0,'{\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(5,'com_cache','component','com_cache','',1,1,1,1,'{\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(6,'com_categories','component','com_categories','',1,1,1,1,'{\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(7,'com_checkin','component','com_checkin','',1,1,1,1,'{\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(8,'com_contact','component','com_contact','',1,1,1,0,'{\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"sliders\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"allow_vcard_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_category_crumb\":\"0\",\"metakey\":\"\",\"metadesc\":\"\",\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(9,'com_cpanel','component','com_cpanel','',1,1,1,1,'{\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(10,'com_installer','component','com_installer','',1,1,1,1,'{\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(11,'com_languages','component','com_languages','',1,1,1,1,'{\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}','','',0,'0000-00-00 00:00:00',0,0),
	(12,'com_login','component','com_login','',1,1,1,1,'{\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(13,'com_media','component','com_media','',1,1,0,1,'{\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}','{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(14,'com_menus','component','com_menus','',1,1,1,1,'{\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(15,'com_messages','component','com_messages','',1,1,1,1,'{\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(16,'com_modules','component','com_modules','',1,1,1,1,'{\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(17,'com_newsfeeds','component','com_newsfeeds','',1,1,1,0,'{\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(18,'com_plugins','component','com_plugins','',1,1,1,1,'{\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(19,'com_search','component','com_search','',1,1,1,0,'{\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','{\"enabled\":\"0\",\"show_date\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(20,'com_templates','component','com_templates','',1,1,1,1,'{\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(21,'com_weblinks','component','com_weblinks','',1,1,1,0,'{\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(22,'com_content','component','com_content','',1,1,0,1,'{\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"1\",\"show_parent_category\":\"0\",\"link_parent_category\":\"1\",\"show_author\":\"0\",\"link_author\":\"1\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"0\",\"readmore_limit\":\"100\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"0\",\"show_publishing_options\":\"1\",\"show_article_options\":\"1\",\"show_urls_images_frontend\":\"0\",\"show_urls_images_backend\":\"1\",\"targeta\":0,\"targetb\":0,\"targetc\":0,\"float_intro\":\"left\",\"float_fulltext\":\"left\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\",\"feed_show_readmore\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(23,'com_config','component','com_config','',1,1,0,1,'{\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}','{\"filters\":{\"1\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"9\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),
	(24,'com_redirect','component','com_redirect','',1,1,0,1,'{\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(25,'com_users','component','com_users','',1,1,0,1,'{\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"guest_usergroup\":\"9\",\"sendpassword\":\"1\",\"useractivation\":\"1\",\"mail_to_admin\":\"0\",\"captcha\":\"\",\"frontend_userparams\":\"1\",\"site_language\":\"0\",\"change_login_name\":\"0\",\"reset_count\":\"10\",\"reset_time\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(27,'com_finder','component','com_finder','',1,1,0,0,'{\"name\":\"com_finder\",\"type\":\"component\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_description\":\"1\",\"description_length\":255,\"allow_empty_query\":\"0\",\"show_url\":\"1\",\"show_advanced\":\"1\",\"expand_advanced\":\"0\",\"show_date_filters\":\"0\",\"highlight_terms\":\"1\",\"opensearch_name\":\"\",\"opensearch_description\":\"\",\"batch_size\":\"50\",\"memory_table_limit\":30000,\"title_multiplier\":\"1.7\",\"text_multiplier\":\"0.7\",\"meta_multiplier\":\"1.2\",\"path_multiplier\":\"2.0\",\"misc_multiplier\":\"0.3\",\"stemmer\":\"snowball\"}','','',0,'0000-00-00 00:00:00',0,0),
	(28,'com_joomlaupdate','component','com_joomlaupdate','',1,1,0,1,'{\"name\":\"com_joomlaupdate\",\"type\":\"component\",\"creationDate\":\"February 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(100,'PHPMailer','library','phpmailer','',0,1,1,1,'{\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2001\",\"author\":\"PHPMailer\",\"copyright\":\"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2012, Jim Jagielski. All Rights Reserved.\",\"authorEmail\":\"jimjag@gmail.com\",\"authorUrl\":\"https:\\/\\/code.google.com\\/a\\/apache-extras.org\\/p\\/phpmailer\\/\",\"version\":\"5.2.1\",\"description\":\"LIB_PHPMAILER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(101,'SimplePie','library','simplepie','',0,1,1,1,'{\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2004\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.2\",\"description\":\"LIB_SIMPLEPIE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(102,'phputf8','library','phputf8','',0,1,1,1,'{\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2006\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"hfuecks@gmail.com\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"0.5\",\"description\":\"LIB_PHPUTF8_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(103,'Joomla! Platform','library','joomla','',0,1,1,1,'{\"name\":\"Joomla! Platform\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"12.2\",\"description\":\"LIB_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(200,'mod_articles_archive','module','mod_articles_archive','',0,1,1,0,'{\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(201,'mod_articles_latest','module','mod_articles_latest','',0,1,1,0,'{\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(202,'mod_articles_popular','module','mod_articles_popular','',0,1,1,0,'{\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(203,'mod_banners','module','mod_banners','',0,1,1,0,'{\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(204,'mod_breadcrumbs','module','mod_breadcrumbs','',0,1,1,1,'{\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(205,'mod_custom','module','mod_custom','',0,1,1,1,'{\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(206,'mod_feed','module','mod_feed','',0,1,1,0,'{\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(207,'mod_footer','module','mod_footer','',0,1,1,0,'{\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(208,'mod_login','module','mod_login','',0,1,1,1,'{\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(209,'mod_menu','module','mod_menu','',0,1,1,1,'{\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(210,'mod_articles_news','module','mod_articles_news','',0,1,1,0,'{\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(211,'mod_random_image','module','mod_random_image','',0,1,1,0,'{\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(212,'mod_related_items','module','mod_related_items','',0,1,1,0,'{\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(213,'mod_search','module','mod_search','',0,1,1,0,'{\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(214,'mod_stats','module','mod_stats','',0,1,1,0,'{\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(215,'mod_syndicate','module','mod_syndicate','',0,1,1,1,'{\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(216,'mod_users_latest','module','mod_users_latest','',0,1,1,0,'{\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(217,'mod_weblinks','module','mod_weblinks','',0,1,1,0,'{\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(218,'mod_whosonline','module','mod_whosonline','',0,1,1,0,'{\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(219,'mod_wrapper','module','mod_wrapper','',0,1,1,0,'{\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(220,'mod_articles_category','module','mod_articles_category','',0,1,1,0,'{\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(221,'mod_articles_categories','module','mod_articles_categories','',0,1,1,0,'{\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(222,'mod_languages','module','mod_languages','',0,1,1,1,'{\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(223,'mod_finder','module','mod_finder','',0,1,0,0,'{\"name\":\"mod_finder\",\"type\":\"module\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(300,'mod_custom','module','mod_custom','',1,1,1,1,'{\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(301,'mod_feed','module','mod_feed','',1,1,1,0,'{\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(302,'mod_latest','module','mod_latest','',1,1,1,0,'{\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(303,'mod_logged','module','mod_logged','',1,1,1,0,'{\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(304,'mod_login','module','mod_login','',1,1,1,1,'{\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(305,'mod_menu','module','mod_menu','',1,1,1,0,'{\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(307,'mod_popular','module','mod_popular','',1,1,1,0,'{\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(308,'mod_quickicon','module','mod_quickicon','',1,1,1,1,'{\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(309,'mod_status','module','mod_status','',1,1,1,0,'{\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(310,'mod_submenu','module','mod_submenu','',1,1,1,0,'{\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(311,'mod_title','module','mod_title','',1,1,1,0,'{\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(312,'mod_toolbar','module','mod_toolbar','',1,1,1,1,'{\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(313,'mod_multilangstatus','module','mod_multilangstatus','',1,1,1,0,'{\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}','{\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(314,'mod_version','module','mod_version','',1,1,1,0,'{\"name\":\"mod_version\",\"type\":\"module\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_VERSION_XML_DESCRIPTION\",\"group\":\"\"}','{\"format\":\"short\",\"product\":\"1\",\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(315,'mod_stats_admin','module','mod_stats_admin','',1,1,1,0,'{\"name\":\"mod_stats_admin\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','{\"serverinfo\":\"0\",\"siteinfo\":\"0\",\"counter\":\"0\",\"increase\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}','','',0,'0000-00-00 00:00:00',0,0),
	(400,'plg_authentication_gmail','plugin','gmail','authentication',0,0,1,0,'{\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}','{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}','','',0,'0000-00-00 00:00:00',1,0),
	(401,'plg_authentication_joomla','plugin','joomla','authentication',0,1,1,1,'{\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(402,'plg_authentication_ldap','plugin','ldap','authentication',0,0,1,0,'{\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}','{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}','','',0,'0000-00-00 00:00:00',3,0),
	(404,'plg_content_emailcloak','plugin','emailcloak','content',0,1,1,0,'{\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\"}','','',0,'0000-00-00 00:00:00',1,0),
	(405,'plg_content_geshi','plugin','geshi','content',0,0,1,0,'{\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),
	(406,'plg_content_loadmodule','plugin','loadmodule','content',0,1,1,0,'{\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}','{\"style\":\"xhtml\"}','','',0,'0000-00-00 00:00:00',0,0),
	(407,'plg_content_pagebreak','plugin','pagebreak','content',0,1,1,0,'{\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"title\":\"1\",\"multipage_toc\":\"1\",\"showall\":\"1\"}','','',0,'0000-00-00 00:00:00',4,0),
	(408,'plg_content_pagenavigation','plugin','pagenavigation','content',0,1,1,0,'{\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}','{\"position\":\"1\"}','','',0,'0000-00-00 00:00:00',5,0),
	(409,'plg_content_vote','plugin','vote','content',0,1,1,0,'{\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),
	(410,'plg_editors_codemirror','plugin','codemirror','editors',0,1,1,1,'{\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}','{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}','','',0,'0000-00-00 00:00:00',1,0),
	(411,'plg_editors_none','plugin','none','editors',0,1,1,1,'{\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"3.0.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),
	(412,'plg_editors_tinymce','plugin','tinymce','editors',0,1,1,0,'{\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2012\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.5.6\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\",\"skin\":\"0\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"resizing\":\"true\",\"resize_horizontal\":\"false\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"}','','',0,'0000-00-00 00:00:00',3,0),
	(413,'plg_editors-xtd_article','plugin','article','editors-xtd',0,1,1,1,'{\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),
	(414,'plg_editors-xtd_image','plugin','image','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),
	(415,'plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),
	(416,'plg_editors-xtd_readmore','plugin','readmore','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),
	(417,'plg_search_categories','plugin','categories','search',0,1,1,0,'{\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(418,'plg_search_contacts','plugin','contacts','search',0,1,1,0,'{\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(419,'plg_search_content','plugin','content','search',0,1,1,0,'{\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(420,'plg_search_newsfeeds','plugin','newsfeeds','search',0,1,1,0,'{\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(421,'plg_search_weblinks','plugin','weblinks','search',0,1,1,0,'{\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(422,'plg_system_languagefilter','plugin','languagefilter','system',0,0,1,1,'{\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),
	(423,'plg_system_p3p','plugin','p3p','system',0,1,1,0,'{\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}','{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}','','',0,'0000-00-00 00:00:00',2,0),
	(424,'plg_system_cache','plugin','cache','system',0,0,1,1,'{\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','{\"browsercache\":\"0\",\"cachetime\":\"15\"}','','',0,'0000-00-00 00:00:00',9,0),
	(425,'plg_system_debug','plugin','debug','system',0,1,1,0,'{\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}','{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}','','',0,'0000-00-00 00:00:00',4,0),
	(426,'plg_system_log','plugin','log','system',0,1,1,1,'{\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),
	(427,'plg_system_redirect','plugin','redirect','system',0,1,1,1,'{\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),
	(428,'plg_system_remember','plugin','remember','system',0,1,1,1,'{\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0),
	(429,'plg_system_sef','plugin','sef','system',0,1,1,0,'{\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',8,0),
	(430,'plg_system_logout','plugin','logout','system',0,1,1,1,'{\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),
	(431,'plg_user_contactcreator','plugin','contactcreator','user',0,0,1,0,'{\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}','','',0,'0000-00-00 00:00:00',1,0),
	(432,'plg_user_joomla','plugin','joomla','user',0,1,1,0,'{\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{\"autoregister\":\"1\"}','','',0,'0000-00-00 00:00:00',2,0),
	(433,'plg_user_profile','plugin','profile','user',0,0,1,0,'{\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}','{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(434,'plg_extension_joomla','plugin','joomla','extension',0,1,1,1,'{\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),
	(435,'plg_content_joomla','plugin','joomla','content',0,1,1,0,'{\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(436,'plg_system_languagecode','plugin','languagecode','system',0,0,1,0,'{\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',10,0),
	(437,'plg_quickicon_joomlaupdate','plugin','joomlaupdate','quickicon',0,1,1,1,'{\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(438,'plg_quickicon_extensionupdate','plugin','extensionupdate','quickicon',0,1,1,1,'{\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(439,'plg_captcha_recaptcha','plugin','recaptcha','captcha',0,1,1,0,'{\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\"}','{\"public_key\":\"\",\"private_key\":\"\",\"theme\":\"clean\"}','','',0,'0000-00-00 00:00:00',0,0),
	(440,'plg_system_highlight','plugin','highlight','system',0,1,1,0,'{\"name\":\"plg_system_highlight\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0),
	(441,'plg_content_finder','plugin','finder','content',0,0,1,0,'{\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(442,'plg_finder_categories','plugin','categories','finder',0,1,1,0,'{\"name\":\"plg_finder_categories\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),
	(443,'plg_finder_contacts','plugin','contacts','finder',0,1,1,0,'{\"name\":\"plg_finder_contacts\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),
	(444,'plg_finder_content','plugin','content','finder',0,1,1,0,'{\"name\":\"plg_finder_content\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),
	(445,'plg_finder_newsfeeds','plugin','newsfeeds','finder',0,1,1,0,'{\"name\":\"plg_finder_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),
	(446,'plg_finder_weblinks','plugin','weblinks','finder',0,1,1,0,'{\"name\":\"plg_finder_weblinks\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),
	(503,'beez3','template','beez3','',0,1,1,0,'{\"name\":\"beez3\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"3.0.0\",\"description\":\"TPL_BEEZ3_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}','','',0,'0000-00-00 00:00:00',0,0),
	(504,'hathor','template','hathor','',1,1,1,0,'{\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"3.0.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(506,'protostar','template','protostar','',0,1,1,0,'{\"name\":\"protostar\",\"type\":\"template\",\"creationDate\":\"4\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_PROTOSTAR_XML_DESCRIPTION\",\"group\":\"\"}','{\"templateColor\":\"\",\"logoFile\":\"\",\"googleFont\":\"1\",\"googleFontName\":\"Open+Sans\",\"fluidContainer\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(507,'isis','template','isis','',1,1,1,0,'{\"name\":\"isis\",\"type\":\"template\",\"creationDate\":\"3\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_ISIS_XML_DESCRIPTION\",\"group\":\"\"}','{\"templateColor\":\"\",\"logoFile\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(600,'English (United Kingdom)','language','en-GB','',0,1,1,1,'{\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.3\",\"description\":\"en-GB site language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(601,'English (United Kingdom)','language','en-GB','',1,1,1,1,'{\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.3\",\"description\":\"en-GB administrator language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(700,'files_joomla','file','joomla','',0,1,1,1,'{\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"April 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.1.1\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(10000,'Zen Tools','module','mod_zentools','',0,1,0,0,'{\"name\":\"Zen Tools\",\"type\":\"module\",\"creationDate\":\"December 17, 2012\",\"author\":\"Joomla Bamboo\",\"copyright\":\"Copyright (c) 2012 Joomla Bamboo. All rights reserved.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.8.0\",\"description\":\"Zen Tools makes creating image and content galleries for Joomla simple.<p style=\\\"line-height:180%;font-size:1.2em\\\"><a href=\\\"http:\\/\\/www.joomlabamboo.com\\\"><img src=\\\"http:\\/\\/www.joomlabamboo.com\\/images\\/zentoolsSmall.jpg\\\" alt=\\\"joomla Bamboo\\\" style=\\\"float:left;margin:0 20px 20px 0px;padding:4px;border:1px solid #ddd\\\"\\/><\\/a><br style=\\\"clear:both\\\" \\/><\\/p><p  style=\\\"color:#555\\\">The module features the following layouts:<\\/p>\\n\\t<ul style=\\\"color:#777\\\">\\n\\t\\t<li>Grid galleries<\\/li>\\n\\t\\t<li>Responsive Slideshows<\\/li>\\n\\t\\t<li>Responsive Carousels<\\/li>\\n\\t\\t<li>Masonry Layouts<\\/li>\\n\\t\\t<li>Accordions<\\/li>\\n\\t\\t<li>Simple Lists and more<\\/li>\\n\\t<\\/ul>\\n\\t<div style=\\\"color:#555\\\"><p>You can use this module to display your Joomla content, your k2 items or even images from a folder.<\\/p>\\n\\t<p>Please ensure you read the documentation contained within the module or via the <a href=\\\"http:\\/\\/zentools.joomlabamboo.com\\\">Zentools<\\/a> demo site.<\\/p>\\n\\t<p>Please ensure that you also have either the  <a href=\'http:\\/\\/www.joomlabamboo.com\\/downloads\\/zen-grid-framework-downloads\' target=\'_blank\'>Zen Grid Framework plugin<\\/a> or the <a href=\'http:\\/\\/www.joomlabamboo.com\\/joomla-extensions\\/jb-library-plugin-a-free-joomla-jquery-plugin\' target=\'_blank\'>JB Library plugin<\\/a> in order to use this module.<\\/p><\\/div>\\n\\t<\\/p>\",\"group\":\"\"}','{\"layout\":\"1\",\"contentSource\":\"2\",\"count\":\"5\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"items\":\"1\",\"useditems\":\"\",\"unuseditems\":\"\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":\"\",\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"category_id\":\"\",\"getChildren\":\"0\",\"itemid\":\"\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"1\",\"image_width\":\"245\",\"image_height\":\"100\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"itemImgSize\":\"Small\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"1\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"documentation\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10008,'System - JB Type ','plugin','jbtype','system',0,1,1,0,'{\"name\":\"System - JB Type \",\"type\":\"plugin\",\"creationDate\":\"Feb 2010\",\"author\":\"Joomla Bamboo\",\"copyright\":\"Copyright 2009 - joomlabamboo.com\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com.com\",\"version\":\"1.5.10\",\"description\":\"<p style=\\\"line-height:180%;font-size:1.2em\\\"><a href=\\\"http:\\/\\/www.joomlabamboo.com\\/joomla-extensions\\/jb-type-joomla-typography-plugin\\\"><img src=\\\"http:\\/\\/d129tlhqmunv45.cloudfront.net\\/images\\/stories\\/blog\\/icons\\/JBtype.png?1305337042\\\" alt=\\\"JB Type\\\" style=\\\"float:left;margin:0 20px 20px 0px\\\"\\/><\\/a>JB Type is a Joomla style and typography plugin for your content. By using some simple Joomla syntax you can create some awesome typography for your site without knowing any html at all.<\\/p>\",\"group\":\"\"}','{\"iconStyle\":\"coquette\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10018,'com_jaextmanager','component','com_jaextmanager','',1,1,1,0,'{\"name\":\"com_jaextmanager\",\"type\":\"component\",\"creationDate\":\"November 2012\",\"author\":\"JoomlArt\",\"copyright\":\"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.\",\"authorEmail\":\"webmaster@joomlart.com\",\"authorUrl\":\"http:\\/\\/www.joomlart.com\",\"version\":\"2.5.3\",\"description\":\"JA Extension Manager Component\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10023,'zenbase','template','zenbase','',0,1,1,0,'{\"name\":\"zenbase\",\"type\":\"template\",\"creationDate\":\"01 January 2013\",\"author\":\"Joomlabamboo\",\"copyright\":\"Copyright (C), Joomlabamboo. All Rights Reserved.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"http:\\/\\/www.joomlabamboo.com\",\"version\":\"1.0\",\"description\":\"\\t\\n\\t\\n\\tBlank template for T3 using Bootstrap\\n\\t\\t\\n\\t\",\"group\":\"t3\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10031,'T3 Framework','plugin','t3','system',0,1,1,0,'{\"name\":\"T3 Framework\",\"type\":\"plugin\",\"creationDate\":\"05 February 2013\",\"author\":\"JoomlArt.com\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"info@joomlart.com\",\"authorUrl\":\"http:\\/\\/www.t3-framework.org\",\"version\":\"1.1.0 RC2\",\"description\":\"\\n\\t\\n\\t<div align=\\\"center\\\">\\n\\t\\t<div class=\\\"alert alert-success\\\" style=\\\"background-color:#DFF0D8;border-color:#D6E9C6;color: #468847;padding: 1px 0;\\\">\\n               <h2>Thanks for using T3 Framework.<\\/h2>\\n\\t\\t\\t\\t<a href=\\\"http:\\/\\/t3-framework.org\\/\\\"><img src=\\\"http:\\/\\/joomlart.s3.amazonaws.com\\/images\\/jat3v3-documents\\/message-installation\\/logo.png\\\" alt=\\\"some_text\\\" width=\\\"400\\\" height=\\\"132\\\"><\\/a>\\n\\t\\t\\t\\t<h3><a href=\\\"http:\\/\\/t3-framework.org\\/\\\" title=\\\"\\\">Home<\\/a> | <a href=\\\"http:\\/\\/demo.t3-framework.org\\/j25\\/\\\" title=\\\"\\\">Demo J25<\\/a> | <a href=\\\"http:\\/\\/demo.t3-framework.org\\/j30\\/\\\" title=\\\"\\\">Demo J30<\\/a> | <a href=\\\"http:\\/\\/t3-framework.org\\/documentation\\\" title=\\\"\\\">Document<\\/a> | <a href=\\\"https:\\/\\/github.com\\/t3framework\\/t3\\/wiki\\/Changelog\\\" title=\\\"\\\">Changelog<\\/a><\\/h3>\\n\\t\\t<p> <\\/p>\\n\\t\\t<p>Copyright 2004 - 2013 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n     <style>table.adminform{width: 100%;}<\\/style>\\n\\t <\\/div>\\n\\t\\t\\n\\t\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10033,'T3','package','pkg_T3','',0,1,1,0,'{\"name\":\"T3 Framework Package\",\"type\":\"package\",\"creationDate\":\"05 February 2013\",\"author\":\"t3-framework.org\",\"copyright\":\"(C) 2012 - 2013. All rights reserved.\",\"authorEmail\":\"support@t3-framework.org\",\"authorUrl\":\"www.t3-framework.org\",\"version\":\"1.1.0 RC2\",\"description\":\"\\t\\n\\t\\n\\t<div align=\\\"center\\\">\\n\\t\\t<div class=\\\"alert alert-success\\\" style=\\\"background-color:#DFF0D8;border-color:#D6E9C6;color: #468847;padding: 1px 0;\\\">\\n               <h2>Thanks for using T3 Framework.<\\/h2>\\n\\t\\t\\t\\t<a href=\\\"http:\\/\\/t3-framework.org\\/\\\"><img src=\\\"http:\\/\\/joomlart.s3.amazonaws.com\\/images\\/jat3v3-documents\\/message-installation\\/logo.png\\\" alt=\\\"some_text\\\" width=\\\"400\\\" height=\\\"132\\\"><\\/a>\\n\\t\\t\\t\\t<h3><a href=\\\"http:\\/\\/t3-framework.org\\/\\\" title=\\\"\\\">Home<\\/a> | <a href=\\\"http:\\/\\/demo.t3-framework.org\\/j25\\/\\\" title=\\\"\\\">Demo J25<\\/a> | <a href=\\\"http:\\/\\/demo.t3-framework.org\\/j30\\/\\\" title=\\\"\\\">Demo J30<\\/a> | <a href=\\\"http:\\/\\/t3-framework.org\\/documentation\\\" title=\\\"\\\">Document<\\/a> | <a href=\\\"https:\\/\\/github.com\\/t3framework\\/t3\\/wiki\\/Changelog\\\" title=\\\"\\\">Changelog<\\/a><\\/h3>\\n\\t\\t<p> <\\/p>\\n\\t\\t<p>Copyright 2004 - 2013 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n     <style>table.adminform{width: 100%;}<\\/style>\\n\\t <\\/div>\\n\\t\\t\\n\\t\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10034,'com_tags','component','com_tags','',1,1,1,0,'{\"name\":\"com_tags\",\"type\":\"component\",\"creationDate\":\"December 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.1.0\",\"description\":\"COM_TAGS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10035,'mod_tags_popular','module','mod_tags_popular','',0,1,1,0,'{\"name\":\"mod_tags_popular\",\"type\":\"module\",\"creationDate\":\"January 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.1.0\",\"description\":\"MOD_TAGS_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','{\"maximum\":\"5\",\"timeframe\":\"alltime\",\"owncache\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10036,'mod_tags_similar','module','mod_tags_similar','',0,1,1,0,'{\"name\":\"mod_tags_similar\",\"type\":\"module\",\"creationDate\":\"January 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.1.0\",\"description\":\"MOD_TAGS_SIMILAR_XML_DESCRIPTION\",\"group\":\"\"}','{\"maximum\":\"5\",\"matchtype\":\"any\",\"owncache\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10037,'plg_finder_tags','plugin','tags','finder',0,0,1,0,'{\"name\":\"plg_finder_tags\",\"type\":\"plugin\",\"creationDate\":\"February 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_TAGS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);

/*!40000 ALTER TABLE `#__extensions` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__menu
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__menu`;

CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(255)),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__menu` WRITE;
/*!40000 ALTER TABLE `#__menu` DISABLE KEYS */;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`)
VALUES
	(1,'','Menu_Item_Root',X'726F6F74','','','','',1,0,0,0,0,'0000-00-00 00:00:00',0,0,'',0,'',0,137,0,'*',0),
	(2,'menu','com_banners',X'42616E6E657273','','Banners','index.php?option=com_banners','component',0,1,1,4,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',1,10,0,'*',1),
	(3,'menu','com_banners',X'42616E6E657273','','Banners/Banners','index.php?option=com_banners','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',2,3,0,'*',1),
	(4,'menu','com_banners_categories',X'43617465676F72696573','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component',0,2,2,6,0,'0000-00-00 00:00:00',0,0,'class:banners-cat',0,'',4,5,0,'*',1),
	(5,'menu','com_banners_clients',X'436C69656E7473','','Banners/Clients','index.php?option=com_banners&view=clients','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners-clients',0,'',6,7,0,'*',1),
	(6,'menu','com_banners_tracks',X'547261636B73','','Banners/Tracks','index.php?option=com_banners&view=tracks','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners-tracks',0,'',8,9,0,'*',1),
	(7,'menu','com_contact',X'436F6E7461637473','','Contacts','index.php?option=com_contact','component',0,1,1,8,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',71,76,0,'*',1),
	(8,'menu','com_contact',X'436F6E7461637473','','Contacts/Contacts','index.php?option=com_contact','component',0,7,2,8,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',72,73,0,'*',1),
	(9,'menu','com_contact_categories',X'43617465676F72696573','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component',0,7,2,6,0,'0000-00-00 00:00:00',0,0,'class:contact-cat',0,'',74,75,0,'*',1),
	(10,'menu','com_messages',X'4D6573736167696E67','','Messaging','index.php?option=com_messages','component',0,1,1,15,0,'0000-00-00 00:00:00',0,0,'class:messages',0,'',77,82,0,'*',1),
	(11,'menu','com_messages_add',X'4E65772050726976617465204D657373616765','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component',0,10,2,15,0,'0000-00-00 00:00:00',0,0,'class:messages-add',0,'',78,79,0,'*',1),
	(12,'menu','com_messages_read',X'526561642050726976617465204D657373616765','','Messaging/Read Private Message','index.php?option=com_messages','component',0,10,2,15,0,'0000-00-00 00:00:00',0,0,'class:messages-read',0,'',80,81,0,'*',1),
	(13,'menu','com_newsfeeds',X'4E657773204665656473','','News Feeds','index.php?option=com_newsfeeds','component',0,1,1,17,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',83,88,0,'*',1),
	(14,'menu','com_newsfeeds_feeds',X'4665656473','','News Feeds/Feeds','index.php?option=com_newsfeeds','component',0,13,2,17,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',84,85,0,'*',1),
	(15,'menu','com_newsfeeds_categories',X'43617465676F72696573','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component',0,13,2,6,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds-cat',0,'',86,87,0,'*',1),
	(16,'menu','com_redirect',X'5265646972656374','','Redirect','index.php?option=com_redirect','component',0,1,1,24,0,'0000-00-00 00:00:00',0,0,'class:redirect',0,'',101,102,0,'*',1),
	(17,'menu','com_search',X'426173696320536561726368','','Basic Search','index.php?option=com_search','component',0,1,1,19,0,'0000-00-00 00:00:00',0,0,'class:search',0,'',91,92,0,'*',1),
	(18,'menu','com_weblinks',X'5765626C696E6B73','','Weblinks','index.php?option=com_weblinks','component',0,1,1,21,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',93,98,0,'*',1),
	(19,'menu','com_weblinks_links',X'4C696E6B73','','Weblinks/Links','index.php?option=com_weblinks','component',0,18,2,21,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',94,95,0,'*',1),
	(20,'menu','com_weblinks_categories',X'43617465676F72696573','','Weblinks/Categories','index.php?option=com_categories&extension=com_weblinks','component',0,18,2,6,0,'0000-00-00 00:00:00',0,0,'class:weblinks-cat',0,'',96,97,0,'*',1),
	(21,'menu','com_finder',X'536D61727420536561726368','','Smart Search','index.php?option=com_finder','component',0,1,1,27,0,'0000-00-00 00:00:00',0,0,'class:finder',0,'',89,90,0,'*',1),
	(22,'menu','com_joomlaupdate',X'4A6F6F6D6C612120557064617465','','Joomla! Update','index.php?option=com_joomlaupdate','component',0,1,1,28,0,'0000-00-00 00:00:00',0,0,'class:joomlaupdate',0,'',99,100,0,'*',1),
	(101,'mainmenu','Home',X'686F6D65','','home','index.php?option=com_content&view=featured','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',24,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',39,40,1,'*',0),
	(102,'mainmenu','About Us',X'61626F75742D7573','','about-us','','heading',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1}',41,48,0,'*',0),
	(103,'mainmenu','Meet the team',X'6D6565742D7468652D7465616D','','about-us/meet-the-team','index.php?option=com_content&view=category&layout=blog&id=14','component',1,102,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',42,43,0,'*',0),
	(104,'mainmenu','Our Company',X'6F75722D636F6D70616E79','','about-us/our-company','index.php?option=com_content&view=article&id=19','component',1,102,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',44,45,0,'*',0),
	(105,'mainmenu','Customer Testimonials',X'637573746F6D65722D74657374696D6F6E69616C73','','about-us/customer-testimonials','index.php?option=com_content&view=category&layout=blog&id=15','component',1,102,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"1\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"6\",\"num_columns\":\"1\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',46,47,0,'*',0),
	(106,'mainmenu','Services',X'7365727669636573','','services','index.php?option=com_content&view=category&layout=blog&id=9','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',15,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"\",\"num_intro_articles\":\"\",\"num_columns\":\"\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',49,58,0,'*',0),
	(107,'mainmenu','Service #1',X'736572766963652D31','','services/service-1','index.php?option=com_content&view=article&id=7','component',1,106,2,22,0,'0000-00-00 00:00:00',0,1,'',15,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',50,51,0,'*',0),
	(108,'mainmenu','Service #2',X'736572766963652D32','','services/service-2','index.php?option=com_content&view=article&id=8','component',1,106,2,22,0,'0000-00-00 00:00:00',0,1,'',15,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',52,53,0,'*',0),
	(109,'mainmenu','Service #3',X'736572766963652D33','','services/service-3','index.php?option=com_content&view=article&id=9','component',1,106,2,22,0,'0000-00-00 00:00:00',0,1,'',15,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',54,55,0,'*',0),
	(110,'mainmenu','Service #4',X'736572766963652D34','','services/service-4','index.php?option=com_content&view=article&id=10','component',1,106,2,22,0,'0000-00-00 00:00:00',0,1,'',15,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',56,57,0,'*',0),
	(111,'mainmenu','Projects',X'70726F6A65637473','','projects','index.php?option=com_content&view=category&layout=blog&id=10','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"\",\"num_intro_articles\":\"\",\"num_columns\":\"\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',59,68,0,'*',0),
	(112,'mainmenu','Project #1',X'70726F6A6563742D31','','projects/project-1','index.php?option=com_content&view=article&id=11','component',1,111,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',60,61,0,'*',0),
	(113,'mainmenu','Project #2',X'70726F6A6563742D32','','projects/project-2','index.php?option=com_content&view=article&id=12','component',1,111,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',62,63,0,'*',0),
	(114,'mainmenu','Project #3',X'70726F6A6563742D33','','projects/project-3','index.php?option=com_content&view=article&id=13','component',1,111,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',64,65,0,'*',0),
	(115,'mainmenu','Project #4',X'70726F6A6563742D34','','projects/project-4','index.php?option=com_content&view=article&id=14','component',1,111,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',66,67,0,'*',0),
	(116,'mainmenu','News',X'6E657773','','news','index.php?option=com_content&view=category&layout=blog&id=11','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"\",\"num_intro_articles\":\"\",\"num_columns\":\"\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',69,70,0,'*',0),
	(117,'template-features','Features',X'6665617475726573','','features','index.php?option=com_content&view=article&id=63','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',11,32,0,'*',0),
	(118,'template-features','Slideshow',X'7A656E746F6F6C732D736C69646573686F77','','features/zentools/zentools-slideshow','index.php?option=com_content&view=article&id=6','component',-2,141,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',17,18,0,'*',0),
	(119,'template-features','Carousel',X'6361726F7573656C','','features/zentools/carousel','index.php?option=com_content&view=article&id=2','component',-2,141,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',19,20,0,'*',0),
	(120,'template-features','Grid',X'67726964','','features/zentools/grid','index.php?option=com_content&view=article&id=3','component',-2,141,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',21,22,0,'*',0),
	(121,'template-features','List',X'6C697374','','features/zentools/list','index.php?option=com_content&view=article&id=4','component',-2,141,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',23,24,0,'*',0),
	(122,'template-features','Masonry',X'6D61736F6E7279','','features/zentools/masonry','index.php?option=com_content&view=article&id=5','component',-2,141,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',25,26,0,'*',0),
	(123,'template-features','Accordion',X'6163636F7264696F6E','','features/zentools/accordion','index.php?option=com_content&view=article&id=1','component',-2,141,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',27,28,0,'*',0),
	(126,'template-features','Typography',X'7479706F677261706879','','typography','index.php?option=com_content&view=article&id=51','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',33,38,0,'*',0),
	(127,'template-features','Layout typography',X'6C61796F75742D7479706F677261706879','','typography/layout-typography','index.php?option=com_content&view=article&id=52','component',-2,126,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',36,37,0,'*',0),
	(128,'template-features','Basic Typography',X'62617369632D7479706F677261706879','','typography/basic-typography','index.php?option=com_content&view=article&id=55','component',-2,126,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',34,35,0,'*',0),
	(129,'template-features','Module Positions',X'6D6F64756C652D6F76657276696577','','module-overview/module-overview','index.php?option=com_content&view=article&id=54','component',1,152,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',120,121,0,'*',0),
	(130,'template-features','Module Classes',X'6D6F64756C652D636C6173736573','','module-overview/module-classes','index.php?option=com_content&view=article&id=53','component',1,152,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',114,119,0,'*',0),
	(132,'footermenu','FAQ',X'666171','','faq','index.php?option=com_content&view=category&layout=blog&id=16','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"20\",\"num_columns\":\"1\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',105,106,0,'*',0),
	(133,'footermenu','Login',X'6C6F67696E','','login','index.php?option=com_users&view=login','component',1,1,1,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',107,108,0,'*',0),
	(134,'footermenu','Contact',X'636F6E74616374','','contact','index.php?option=com_contact&view=contact&id=1','component',1,1,1,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"plain\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',109,110,0,'*',0),
	(135,'main','COM_JAEXTMANAGER',X'636F6D2D6A616578746D616E61676572','','com-jaextmanager','index.php?option=com_jaextmanager','component',0,1,1,10018,0,'0000-00-00 00:00:00',0,1,'components/com_jaextmanager/assets/images/jauc.png',0,'',111,112,0,'',1),
	(141,'template-features','Zentools',X'7A656E746F6F6C73','','features/zentools','index.php?option=com_content&view=article&id=56','component',-2,117,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',16,29,0,'*',0),
	(142,'template-features','Solid template framework',X'736F6C69642D74656D706C6174652D6672616D65776F726B','','features/solid-template-framework','index.php?option=com_content&view=article&id=57','component',1,117,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',12,13,0,'*',0),
	(143,'template-features','Responsive Layouts',X'726573706F6E736976652D6C61796F757473','','features/responsive-layouts','index.php?option=com_content&view=article&id=58','component',1,117,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',14,15,0,'*',0),
	(144,'template-features','Theme Magic',X'7468656D652D6D61676963','','features/theme-magic','index.php?option=com_content&view=article&id=59','component',1,117,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',30,31,0,'*',0),
	(145,'template-features','Module Styles',X'6D6F64756C652D6368726F6D65','','module-overview/module-chrome','index.php?option=com_content&view=article&id=64','component',1,152,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',122,131,0,'*',0),
	(146,'template-features','Tabs',X'74616273','','module-overview/module-chrome/tabs','index.php?option=com_content&view=article&id=65','component',1,145,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',123,124,0,'*',0),
	(147,'template-features','Module Slider',X'6D6F64756C652D736C69646572','','module-overview/module-chrome/module-slider','index.php?option=com_content&view=article&id=67','component',1,145,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',125,126,0,'*',0),
	(148,'template-features','Modal Style',X'6D6F64616C2D7374796C65','','module-overview/module-chrome/modal-style','index.php?option=com_content&view=article&id=66','component',1,145,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',127,128,0,'*',0),
	(149,'template-features','Popover Style',X'706F706F7665722D7374796C65','','module-overview/module-chrome/popover-style','index.php?option=com_content&view=article&id=68','component',1,145,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',129,130,0,'*',0),
	(150,'template-features','Module Positions',X'6D6F64756C652D706F736974696F6E73','','module-overview/module-classes/module-positions','index.php?option=com_content&view=article&id=54','component',-2,130,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',115,116,0,'*',0),
	(151,'template-features','Module Classes',X'6D6F64756C652D636C6173736573','','module-overview/module-classes/module-classes','index.php/module-classes','url',-2,130,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',117,118,0,'*',0),
	(152,'template-features','Module Overview',X'6D6F64756C652D6F76657276696577','','module-overview','index.php?option=com_content&view=article&id=69','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',113,132,0,'*',0),
	(153,'main','com_tags',X'636F6D2D74616773','','com-tags','index.php?option=com_tags','component',0,1,1,10034,0,'0000-00-00 00:00:00',0,1,'class:tags',0,'',135,136,0,'',1);

/*!40000 ALTER TABLE `#__menu` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__menu_types
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__menu_types`;

CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__menu_types` WRITE;
/*!40000 ALTER TABLE `#__menu_types` DISABLE KEYS */;

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`)
VALUES
	(1,'mainmenu','Main Menu','The main menu for the site'),
	(2,'footermenu','Footer Menu',''),
	(3,'template-features','Template Features','');

/*!40000 ALTER TABLE `#__menu_types` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__modules
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__modules`;

CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__modules` WRITE;
/*!40000 ALTER TABLE `#__modules` DISABLE KEYS */;

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`)
VALUES
	(1,'Template Features','','',1,'top4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"template-features\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"1\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(2,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'',1,'*'),
	(3,'Popular Articles','','',3,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_popular',3,1,'{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(4,'Recently Added Articles','','',4,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_latest',3,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(8,'Toolbar','','',1,'toolbar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_toolbar',3,1,'',1,'*'),
	(9,'Quick Icons','','',1,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_quickicon',3,1,'',1,'*'),
	(10,'Logged-in Users','','',2,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_logged',3,1,'{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(12,'Admin Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',3,1,'{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}',1,'*'),
	(13,'Admin Submenu','','',1,'submenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_submenu',3,1,'',1,'*'),
	(14,'User Status','','',2,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_status',3,1,'',1,'*'),
	(15,'Title','','',1,'title',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_title',3,1,'',1,'*'),
	(16,'Login Form','','',7,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_login',1,1,'{\"greeting\":\"1\",\"name\":\"0\"}',0,'*'),
	(17,'Breadcrumbs','','',1,'breadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,0,'{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(79,'Multilanguage status','','',1,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_multilangstatus',3,1,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*'),
	(86,'Joomla Version','','',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_version',3,1,'{\"format\":\"short\",\"product\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*'),
	(87,'Zentools Masonry','','',1,'masonry',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"masonry\",\"contentSource\":\"2\",\"count\":\"6\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image,category,title,text\",\"unuseditems\":\"date,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"180\",\"image_height\":\"110\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"0\",\"masonryColWidths\":\"3\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(88,'ZenTools Slideshow','','',1,'slideshow',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"slideshow\",\"contentSource\":\"1\",\"count\":\"6\",\"link\":\"1\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image,title\",\"unuseditems\":\"text,date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\\/images\\/democontent\\/slideshow\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"800\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenrounded\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"0\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(89,'ZenTools Slideshow Flat','','',1,'slideshow2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"slideshow\",\"contentSource\":\"1\",\"count\":\"5\",\"link\":\"1\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image,column2,title,text\",\"unuseditems\":\"\",\"col1Width\":\"four\",\"col2Width\":\"eight\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\\/images\\/democontent\\/slideshow\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"800\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenrounded\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"flat\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"numbers\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"0\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(90,'Zentools Accordion','','',1,'accordion',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"accordion\",\"contentSource\":\"2\",\"count\":\"5\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"title,column2,image,column3,category,date,text,more\",\"unuseditems\":\"column4,tweet,isfeatured\",\"col1Width\":\"twelve\",\"col2Width\":\"four\",\"col3Width\":\"eight\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(91,'ZenTools Carousel','','',1,'carousel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"carousel\",\"contentSource\":\"2\",\"count\":\"10\",\"link\":\"1\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"3\",\"carouselSpeed\":\"450\",\"imageW\":\"300\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(92,'ZenTools Columns within Columns','','',1,'zengrid3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"2\",\"count\":\"6\",\"link\":\"2\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image,column2,title,text\",\"unuseditems\":\"date,category,more,column3,column4,tweet,isfeatured\",\"col1Width\":\"six\",\"col2Width\":\"six\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"2\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(93,'ZenTools Grid','','',1,'grid',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"2\",\"count\":\"6\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image,title,text\",\"unuseditems\":\"date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(94,'ZenTools List 2 Col','','',1,'list',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"list\",\"contentSource\":\"2\",\"count\":\"5\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"title,category,date,text,column2,image\",\"unuseditems\":\"more,column3,column4,tweet,isfeatured\",\"col1Width\":\"six\",\"col2Width\":\"six\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"1\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(95,'ZenTools List 3 Col','','',1,'list2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"list\",\"contentSource\":\"2\",\"count\":\"5\",\"link\":\"2\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"title,category,column2,date,text,column3,image\",\"unuseditems\":\"column4,tweet,more,isfeatured\",\"col1Width\":\"four\",\"col2Width\":\"four\",\"col3Width\":\"four\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(96,'ZenTools Grid Lots of Columns','','',1,'zengrid2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"2\",\"count\":\"6\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"title,text,date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"18\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"6\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(97,'Project1 Gallery','','',0,'project1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"1\",\"count\":\"50\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"title,text,date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\\/images\\/democontent\\/galleries\\/project1\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"10\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"245\",\"image_height\":\"245\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(98,'Project2 Gallery','','',1,'project2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"1\",\"count\":\"50\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"title,text,date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\\/images\\/democontent\\/galleries\\/project2\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"10\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"245\",\"image_height\":\"245\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(99,'Project3 Gallery','','',1,'project3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"1\",\"count\":\"50\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"title,text,date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\\/images\\/democontent\\/galleries\\/project3\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"10\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"245\",\"image_height\":\"245\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(100,'Project4 Gallery','','',1,'project4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"1\",\"count\":\"50\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"title,text,date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\\/images\\/democontent\\/galleries\\/project4\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"10\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"245\",\"image_height\":\"245\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(101,'Popular Items','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_popular',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_front\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(102,'Latest Items','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(103,'togglemenu','','',1,'menu',933,'2012-12-31 06:42:03','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"nav\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(104,'Our Services','','',1,'grid4',369,'2013-03-17 05:07:55','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"2\",\"count\":\"3\",\"link\":\"1\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image,title,text,more\",\"unuseditems\":\"date,category,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"9\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"strong\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"Read More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"0\",\"option\":\"crop\",\"image_width\":\"245\",\"image_height\":\"100\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenrounded\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"0\",\"masonryColWidths\":\"3\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"800\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(105,'Recent Work','','',1,'grid8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"2\",\"count\":\"3\",\"link\":\"2\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image,title,text,more\",\"unuseditems\":\"date,category,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"10\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"strong\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"Read More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"0\",\"option\":\"crop\",\"image_width\":\"245\",\"image_height\":\"100\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenrounded\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(106,'Panel1','','This module is using module class suffix \\\\\\\" primary1\\\\\\\"',1,'panel1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" primary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(107,'This is the first tab','','<p>The content in this tab is the content from a custom html module. In order to control the order of the tabs simply change the ordering of the items in the Joomla administrator.</p>',1,'belowcontent',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zenbase-zentabs\"}',0,'*'),
	(108,'This is the second tab','','<p>This is the second tab.</p>',1,'tabs',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" primary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zen-base-zentabs\"}',0,'*'),
	(109,'Top1','','<p>This is the top1 position.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(110,'Left','','This module is using module class suffix \" warning\"',1,'position-8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" warning\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(111,'Left','','This module is using module class suffix \" success\"',1,'position-8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" success\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(112,'Left','','This module is using module class suffix \" notice\"',1,'position-8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" notice\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(113,'Left','','This module is using module class suffix \" border\"',1,'position-8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(114,'Left','','This module is using module class suffix \" shadow\"',1,'position-8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" shadow\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(115,'Banner','','<p>This module is the banner position.</p>',1,'banner',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(116,'Grid1','','<p>This module is the grid1 position.</p>',1,'grid1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(117,'Grid2','','<p>This is the grid2 position.</p>',1,'grid2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(118,'Grid3','','<p>This is the Grid3 position.</p>',1,'grid3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(119,'Footer menu','','',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"footermenu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(120,'Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\" nav-pills\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(121,'Our Services','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget. Phasellus porttitor rhoncus ipsum, quis vestibulum urna sodales quis. </p>',1,'grid1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h6\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(122,'Our Work','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget. Phasellus porttitor rhoncus ipsum, quis vestibulum urna sodales quis. </p>',1,'grid5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(123,'Like the way we work?','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget. Phasellus porttitor rhoncus ipsum, quis vestibulum urna sodales quis.</p>',3,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" inset primary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h4\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(124,'Right (2)','','This module is using module class suffix \" inset secondary2\"',1,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" inset secondary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(125,'Awards and achievements','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',933,'2013-02-08 00:25:52','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"secondary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(126,'This is the first slider','','<p>This is the first slider <img src=\\\"\\\\&quot;\\\\\\\\&quot;images/democontent/democontent/Fotolia_4446837_XS.jpg\\\\\\\\&quot;\\\\&quot;\\\" alt=\\\"\\\\&quot;\\\\\\\\&quot;\\\\\\\\&quot;\\\\&quot;\\\" /></p>',1,'grid1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"p\",\"header_class\":\"\",\"style\":\"Zen-base-zentabs\"}',0,'*'),
	(127,'This is the second slide','','<p>This is the second slider</p>',1,'grid1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" primary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zen-base-zentabs\"}',0,'*'),
	(128,'Frontpage Slideshow','','',1,'banner',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"slideshow\",\"contentSource\":\"1\",\"count\":\"6\",\"link\":\"1\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image,title\",\"unuseditems\":\"text,date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\\/images\\/democontent\\/slideshow\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"strong\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"940\",\"image_height\":\"250\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"full\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenrounded\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"standard\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"0\",\"slideshowPause\":\"0\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(129,'Zentools overview','','',1,'zentools',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"list\",\"contentSource\":\"2\",\"count\":\"20\",\"link\":\"2\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"title\",\"unuseditems\":\"image,text,date,category,more,column2,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"items\",\"catid\":[\"20\"],\"artids\":[\"1\",\"2\",\"3\",\"4\",\"5\",\"6\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"strong\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"200\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"Read More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"0\",\"option\":\"crop\",\"image_width\":\"245\",\"image_height\":\"100\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenrounded\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"0\",\"masonryColWidths\":\"3\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(130,'Template Features','','',4,'sidebar-2',933,'2013-01-07 04:21:12','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"template-features\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"7\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"nav-list\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(131,'Top2','','<p>This is the top2 position.</p>',1,'top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(132,'Top3','','<p>This is the top3 position.</p>',1,'top3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(133,'Top4','','<p>This is the top4 position.</p>',1,'top4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(134,'Top5','','<p>This is the top4 position.</p>',1,'top5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(135,'Top6','','<p>This is the top6 position.</p>',1,'top6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(136,'Header1','','<p>This is the header1 position.</p>',1,'header1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(137,'Header2','','<p>This is the header2 position.</p>',1,'header2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(138,'Header3','','<p>This is the header3 position.</p>',1,'header3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(139,'Header4','','<p>This is the header4 position.</p>',1,'header4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(140,'Top5 (2)','','<p>This is the top4 position.</p>',1,'top5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(141,'Top6 (2)','','<p>This is the top6 position.</p>',1,'top6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(142,'Grid4','','<p>This is the Grid4 position.</p>',1,'grid4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(143,'Grid5','','<p>This is the Grid5 position.</p>',1,'grid5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(144,'Grid5','','<p>This is the Grid5 position.</p>',1,'grid5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(145,'Grid6','','<p>This is the Grid6 position.</p>',1,'grid6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(146,'Grid7','','<p>This is the Grid7 position.</p>',1,'grid7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(147,'Grid8','','<p>This is the Grid8 position.</p>',1,'grid8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(148,'Grid9','','<p>This is the Grid9 position.</p>',1,'grid9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(149,'Grid10','','<p>This is the Grid10 position.</p>',1,'grid10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(150,'Grid11','','<p>This is the Grid11 position.</p>',1,'grid11',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(151,'Grid12','','<p>This is the Grid12 position.</p>',1,'grid12',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(152,'Grid13','','<p>This is the Grid13 position.</p>',1,'grid13',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(153,'Grid14','','<p>This is the Grid14 position.</p>',1,'grid14',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(154,'Grid15','','<p>This is the Grid15 position.</p>',1,'grid15',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(155,'Grid16','','<p>This is the Grid16 position.</p>',1,'grid16',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(156,'Grid17','','<p>This is the Grid17 position.</p>',1,'grid17',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(157,'Grid18','','<p>This is the Grid18 position.</p>',1,'grid18',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(158,'Grid19','','<p>This is the Grid19 position.</p>',1,'grid19',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(159,'Grid20','','<p>This is the Grid20 position.</p>',1,'grid20',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(160,'Grid21','','<p>This is the Grid21 position.</p>',1,'grid21',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(161,'Grid22','','<p>This is the Grid22 position.</p>',1,'grid22',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(162,'Grid23','','<p>This is the Grid23 position.</p>',1,'grid23',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(163,'Grid24','','<p>This is the Grid24 position.</p>',1,'grid24',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(164,'Bottom1','','<p>This is the Bottom1 position.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(165,'Bottom2','','<p>This is the Bottom2 position.</p>',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(166,'Bottom3','','<p>This is the Bottom3 position.</p>',1,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(167,'Bottom4','','<p>This is the Bottom4 position.</p>',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(168,'Bottom5','','<p>This is the Bottom5 position.</p>',1,'bottom5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(169,'Bottom6','','<p>This is the Bottom6 position.</p>',1,'bottom6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(170,'Footer','','<p>This is the Footer position.</p>',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(171,'Sidebar-2','','<p>This module is the sidebar-2 position.</p>',5,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(172,'Sidebar-1','','<p>This module is the sidebar-1 position.</p>',1,'sidebar-1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(173,'Template Features','','',1,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',1,1,'{\"menutype\":\"template-features\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"7\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(174,'Slider1 Example','','<p>This is some text from a custom html module that is being displayed inside a sliding window.&nbsp;</p>',2,'grid9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zen-standard-zenslider\"}',0,'*'),
	(175,'Modal Example','','<p>This is some text from a custom html module that is being displayed inside a modal window.&nbsp;</p>',1,'modal',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zenbase-zenmodal\"}',0,'*'),
	(176,'Slider2','','<p>This is text from another custom html module given the module style - zenslider.</p>',2,'slider',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zenbase-zenslider\"}',0,'*'),
	(177,'Click to trigger popover','','<p>The popover module chrome allows you to display the module content in a bootstrap popover style. To trigger the popover simple click on the moduel title.</p>',1,'popover',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" left\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zenbase-popover\"}',0,'*'),
	(178,'This is the second tab (2)','','<p>This is the second tab.</p>',1,'tabs',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" primary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zen-base-zentabs\"}',0,'*'),
	(179,'This is the first tab (2)','','<p>The content in this tab is the content from a custom html module. In order to control the order of the tabs simply change the ordering of the items in the Joomla administrator.</p>',1,'tabs',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zen-base-zentabs\"}',0,'*'),
	(180,'A zentools module','','',1,'belowcontent',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_zentools',1,1,'{\"layout\":\"grid\",\"contentSource\":\"1\",\"count\":\"9\",\"link\":\"0\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"text,more,column2,title,column3,column4,tweet\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\\/images\\/democontent\\/flowers\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"filterwidth\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"245\",\"image_height\":\"100\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"imageFX\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(181,'A menu in a tab','','',1,'tabs',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',1,1,'{\"menutype\":\"template-features\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zen-base-zentabs\"}',0,'*'),
	(182,'Another tab','','<p>This is another custom html module published using the zentabs module style.</p>',1,'belowcontent',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zenbase-zentabs\"}',0,'*'),
	(183,'Bottom1','','<p>This is the Bottom1 position.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(184,'above','','<p>This is the Above position.</p>',1,'above',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(185,'belowcontent','','<p>This is the Belowcontent position.</p>',1,'belowcontent',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(186,'Below','','<p>This is the Below position.</p>',1,'below',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(187,'abovecontent','','<p>This is the Abovecontent position.</p>',1,'abovecontent',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(188,'Modal Example (2)','','<p>This is some text from a custom html module that is being displayed inside a modal window.&nbsp;</p>\n\n',2,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zen-base-zenmodal\"}',0,'*'),
	(189,'Zentools in a popover','','',1,'popover',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,0,'{\"layout\":\"grid\",\"contentSource\":\"2\",\"count\":\"6\",\"link\":\"2\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"date,category,text,more,column2,title,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"14\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zenbase-popover\"}',0,'*'),
	(190,'Slider2','','<p>This is text from another custom html module given the module style - zenslider.</p>',3,'slider',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zen-base-zenslider\"}',0,'*'),
	(191,'Zentools in a slider','','',1,'slider',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zentools',1,1,'{\"layout\":\"grid\",\"contentSource\":\"2\",\"count\":\"6\",\"link\":\"2\",\"linktarget\":\"_self\",\"altlink\":\"0\",\"extlinks\":\"5\",\"useditems\":\"image\",\"unuseditems\":\"date,category,text,more,column2,title,column3,column4,tweet,isfeatured\",\"col1Width\":\"one\",\"col2Width\":\"one\",\"col3Width\":\"one\",\"col4Width\":\"one\",\"directory\":\"\",\"random_image\":\"0\",\"prefix\":\"0\",\"separator\":\"+\",\"joomlaContentSource\":\"categories\",\"catid\":[\"14\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"user_id\":\"0\",\"show_front\":\"1\",\"k2contentSource\":\"categories\",\"getChildren\":\"0\",\"FeaturedItems\":\"1\",\"itemsOrdering\":\"\",\"imagesreplace\":\"1\",\"videosOnly\":\"0\",\"titleClass\":\"h2\",\"titlewordCount\":\"100\",\"titleSuffix\":\"\",\"wordCount\":\"100\",\"textsuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"readonText\":\"More ...\",\"overlayMore\":\"0\",\"animateMoreOverlay\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"imagesPerRow\":\"3\",\"disableMargin\":\"0\",\"overlayGrid\":\"0\",\"animateOverlay\":\"1\",\"categoryFilter\":\"0\",\"filterstart\":\"\",\"pagStartPage\":\"1\",\"pagStartRange\":\"3\",\"pagMidRange\":\"3\",\"pagEndRange\":\"1\",\"resizeImage\":\"1\",\"option\":\"crop\",\"image_width\":\"400\",\"image_height\":\"300\",\"imageTitleAtt\":\"1\",\"responsiveimages\":\"0\",\"sourceImage\":\"Medium\",\"mobile\":\"Medium\",\"tabletPortrait\":\"Medium\",\"tabletLandscape\":\"Default\",\"desktopImage\":\"Default\",\"wideImage\":\"Default\",\"fullwidthimage\":\"auto\",\"usePlaceholder\":\"0\",\"placeHolderImage\":\"\",\"imageEffect\":\"zenshadow\",\"imageFade\":\"0\",\"accordionOpen\":\"1\",\"masonryWidths\":\"1\",\"masonryColWidths\":\"1\",\"browserThreshold\":\"600\",\"masonryColumnWidth\":\"100\",\"masonryGutter\":\"20\",\"minItems\":\"2\",\"carouselSpeed\":\"600\",\"imageW\":\"180\",\"overlayCarousel\":\"0\",\"animateOverlayCarousel\":\"1\",\"slideshowTheme\":\"overlay\",\"overlayAnimation\":\"1\",\"slideshowAuto\":\"1\",\"slideshowLoop\":\"1\",\"transition\":\"fade\",\"slideshowSpeed\":\"6000\",\"slideshowDuration\":\"600\",\"slideshowPaginationType\":\"thumb\",\"slideshowPaginationPos\":\"zenleft\",\"slideshowTitleTheme\":\"zendark\",\"slideTitleWidth\":\"26%\",\"slideTitleHide\":\"800px\",\"itemsperpage\":\"3\",\"thumb_width\":\"20\",\"thumb_height\":\"20\",\"slideCount\":\"0\",\"slideCountSep\":\"of\",\"slideshowNav\":\"1\",\"slideshowPause\":\"1\",\"playText\":\"Play\",\"pauseText\":\"Pause\",\"modalTitle\":\"1\",\"modalImage\":\"0\",\"modalText\":\"1\",\"modalVideo\":\"1\",\"modalMore\":\"0\",\"modalWidth\":\"600\",\"twitterName\":\"joomlabamboo\",\"tweetText\":\"\",\"tweetCount\":\"yes\",\"tweetHashtag\":\"\",\"tweetLargeButton\":\"small\",\"fonticons\":\"0\",\"scripts\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"Zenbase-zenslider\"}',0,'*'),
	(192,'\" primary1\"','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"primary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(193,'Primary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"primary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(194,'Primary2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"primary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(195,'Primary3','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"primary3\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(196,'Secondary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" secondary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(197,'Secondary2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" secondary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(198,'Secondary3','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" secondary3\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(199,'Dark','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',6,'sidebar-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" dark\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(200,'Shadow2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid15',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" shadow2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(201,'Light','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid13',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" light\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(202,'Shadow','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid14',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" shadow\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(203,'Border','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid16',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" border\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(204,'Shadow2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid15',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" shadow2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(205,'Shadow2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid15',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" shadow2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(206,'Inset','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid17',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" inset\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(207,'Inset Shadow2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid20',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" inset shadow2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(208,'Inset Primary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid18',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" inset primary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(209,'Inset Secondary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid19',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" inset secondary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(210,'Corner Secondary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid23',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" corner secondary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(211,'Corner Primary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid21',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" corner primary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(212,'Corner Primary2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid22',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" corner primary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(213,'Corner Secondary2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid24',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" corner secondary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(214,'More module classes below ','','',1,'belowcontent',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(215,'Hot Primary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid21',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"hot primary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(216,'Title New Primary2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid22',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"new primary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(217,'Hot Secondary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid23',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"hot secondary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(218,'New Secondary2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid24',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"new secondary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(219,'Icon Icon-twitter Primary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid21',933,'2013-01-15 01:24:26','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"icon icon-twitter primary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(220,'Hot Secondary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid23',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"hot secondary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(221,'icon icon-comments bottom large secondary1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid23',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"icon icon-comments bottom large secondary1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(222,'icon icon-phone medium primary2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid22',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"icon icon-phone medium primary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(223,'icon icon-pinterest bottom medium secondary2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec venenatis dictum sem, eu lacinia ligula dictum eget.</p>',1,'grid24',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"icon icon-pinterest bottom medium secondary2\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(224,'Module in a menu item','','<p>This is an example module in a menu item via the T3 Mega Menu.</p>',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),
	(225,'zenfeaturetable','','',1,'grid13',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_zenfeaturetable',1,1,'{\"panels\":\"4\",\"theme\":\"dark\",\"titletag\":\"h3\",\"titlesubtag\":\"h4\",\"showprices\":\"0\",\"pricesymbol\":\"\\u20ac\",\"linktarget\":\"_top\",\"panel1enable\":\"1\",\"panel1emphasis\":\"0\",\"panel1image\":\"images\\/democontent\\/democontent\\/Fotolia_6355435_XS.jpg\",\"panel1imagealt\":\"Photo\",\"panel1title\":\"Service1\",\"panel1subtitle\":\"This is the subtitle\",\"panel1text\":\"This is the panel text\",\"panel1price\":30,\"panel1linktext\":\"More\",\"panel1link\":\"#\",\"panel2enable\":\"0\",\"panel2emphasis\":\"0\",\"panel2image\":\"\",\"panel2imagealt\":\"\",\"panel2title\":\"\",\"panel2subtitle\":\"\",\"panel2text\":\"\",\"panel2price\":0,\"panel2linktext\":\"\",\"panel2link\":\"\",\"panel3enable\":\"0\",\"panel3emphasis\":\"0\",\"panel3image\":\"\",\"panel3imagealt\":\"\",\"panel3title\":\"\",\"panel3subtitle\":\"\",\"panel3text\":\"\",\"panel3price\":0,\"panel3linktext\":\"\",\"panel3link\":\"\",\"panel4enable\":\"0\",\"panel4emphasis\":\"0\",\"panel4image\":\"\",\"panel4imagealt\":\"\",\"panel4title\":\"\",\"panel4subtitle\":\"\",\"panel4text\":\"\",\"panel4price\":0,\"panel4linktext\":\"\",\"panel4link\":\"\",\"panel5enable\":\"0\",\"panel5emphasis\":\"0\",\"panel5image\":\"\",\"panel5imagealt\":\"\",\"panel5title\":\"\",\"panel5subtitle\":\"\",\"panel5text\":\"\",\"panel5price\":0,\"panel5linktext\":\"\",\"panel5link\":\"\",\"panel6enable\":\"0\",\"panel6emphasis\":\"0\",\"panel6image\":\"\",\"panel6imagealt\":\"\",\"panel6title\":\"\",\"panel6subtitle\":\"\",\"panel6text\":\"\",\"panel6price\":0,\"panel6linktext\":\"\",\"panel6link\":\"\",\"moduleclass_sfx\":\"\",\"loadcss\":\"1\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*');

/*!40000 ALTER TABLE `#__modules` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__modules_menu
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__modules_menu`;

CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__modules_menu` WRITE;
/*!40000 ALTER TABLE `#__modules_menu` DISABLE KEYS */;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`)
VALUES
	(1,101),
	(1,102),
	(1,103),
	(1,104),
	(1,105),
	(1,106),
	(1,107),
	(1,108),
	(1,109),
	(1,110),
	(1,111),
	(1,112),
	(1,113),
	(1,114),
	(1,115),
	(1,116),
	(1,117),
	(1,118),
	(1,119),
	(1,120),
	(1,121),
	(1,122),
	(1,123),
	(1,126),
	(1,130),
	(1,131),
	(1,132),
	(1,133),
	(1,134),
	(1,141),
	(1,142),
	(1,143),
	(1,144),
	(1,145),
	(1,146),
	(1,147),
	(1,148),
	(1,149),
	(1,151),
	(2,0),
	(3,0),
	(4,0),
	(6,0),
	(7,0),
	(8,0),
	(9,0),
	(10,0),
	(12,0),
	(13,0),
	(14,0),
	(15,0),
	(16,0),
	(17,0),
	(79,0),
	(86,0),
	(87,0),
	(88,0),
	(89,0),
	(90,0),
	(91,0),
	(92,0),
	(93,0),
	(94,0),
	(95,0),
	(96,0),
	(97,0),
	(98,0),
	(99,0),
	(100,0),
	(101,0),
	(102,0),
	(103,0),
	(104,101),
	(105,101),
	(106,101),
	(106,102),
	(106,103),
	(106,104),
	(106,105),
	(106,106),
	(106,107),
	(106,108),
	(106,109),
	(106,110),
	(106,111),
	(106,112),
	(106,113),
	(106,114),
	(106,115),
	(106,116),
	(106,117),
	(106,118),
	(106,119),
	(106,120),
	(106,121),
	(106,122),
	(106,123),
	(106,126),
	(106,127),
	(106,128),
	(106,129),
	(106,130),
	(106,131),
	(106,132),
	(106,133),
	(106,134),
	(107,146),
	(108,146),
	(109,129),
	(110,130),
	(111,130),
	(112,130),
	(113,130),
	(114,130),
	(115,129),
	(116,129),
	(117,129),
	(118,129),
	(119,101),
	(119,102),
	(119,103),
	(119,104),
	(119,105),
	(119,106),
	(119,107),
	(119,108),
	(119,109),
	(119,110),
	(119,111),
	(119,112),
	(119,113),
	(119,114),
	(119,115),
	(119,116),
	(119,117),
	(119,118),
	(119,119),
	(119,120),
	(119,121),
	(119,122),
	(119,123),
	(119,126),
	(119,129),
	(119,130),
	(119,131),
	(119,132),
	(119,133),
	(119,134),
	(119,141),
	(119,142),
	(119,143),
	(119,144),
	(119,145),
	(119,146),
	(119,147),
	(119,148),
	(119,149),
	(119,152),
	(120,0),
	(121,101),
	(122,101),
	(123,102),
	(123,103),
	(123,104),
	(123,105),
	(123,106),
	(123,107),
	(123,108),
	(123,109),
	(123,110),
	(123,111),
	(123,112),
	(123,113),
	(123,114),
	(123,115),
	(123,116),
	(124,130),
	(125,102),
	(125,103),
	(125,104),
	(125,105),
	(125,106),
	(125,107),
	(125,108),
	(125,109),
	(125,110),
	(125,111),
	(125,112),
	(125,113),
	(125,114),
	(125,115),
	(125,116),
	(126,101),
	(126,102),
	(126,103),
	(126,104),
	(126,105),
	(126,106),
	(126,107),
	(126,108),
	(126,109),
	(126,110),
	(126,111),
	(126,112),
	(126,113),
	(126,114),
	(126,115),
	(126,116),
	(126,117),
	(126,118),
	(126,119),
	(126,120),
	(126,121),
	(126,122),
	(126,123),
	(126,126),
	(126,127),
	(126,128),
	(126,129),
	(126,130),
	(126,131),
	(126,132),
	(126,133),
	(126,134),
	(127,101),
	(127,102),
	(127,103),
	(127,104),
	(127,105),
	(127,106),
	(127,107),
	(127,108),
	(127,109),
	(127,110),
	(127,111),
	(127,112),
	(127,113),
	(127,114),
	(127,115),
	(127,116),
	(127,117),
	(127,118),
	(127,119),
	(127,120),
	(127,121),
	(127,122),
	(127,123),
	(127,126),
	(127,127),
	(127,128),
	(127,129),
	(127,130),
	(127,131),
	(127,132),
	(127,133),
	(127,134),
	(128,101),
	(129,0),
	(130,0),
	(131,129),
	(132,129),
	(133,129),
	(134,129),
	(135,129),
	(136,129),
	(137,129),
	(138,129),
	(139,129),
	(140,129),
	(141,129),
	(142,129),
	(143,129),
	(144,129),
	(145,129),
	(146,129),
	(147,129),
	(148,129),
	(149,129),
	(150,129),
	(151,129),
	(152,129),
	(153,129),
	(154,129),
	(155,129),
	(156,129),
	(157,129),
	(158,129),
	(159,129),
	(160,129),
	(161,129),
	(162,129),
	(163,129),
	(164,129),
	(165,129),
	(166,129),
	(167,129),
	(168,129),
	(169,129),
	(170,129),
	(171,129),
	(172,129),
	(173,101),
	(173,102),
	(173,103),
	(173,104),
	(173,105),
	(173,106),
	(173,107),
	(173,108),
	(173,109),
	(173,110),
	(173,111),
	(173,112),
	(173,113),
	(173,114),
	(173,115),
	(173,116),
	(173,117),
	(173,118),
	(173,119),
	(173,120),
	(173,121),
	(173,122),
	(173,123),
	(173,126),
	(173,130),
	(173,131),
	(173,132),
	(173,133),
	(173,134),
	(173,141),
	(173,142),
	(173,143),
	(173,144),
	(173,145),
	(173,146),
	(173,147),
	(173,148),
	(173,149),
	(174,147),
	(175,148),
	(176,101),
	(176,102),
	(176,103),
	(176,104),
	(176,105),
	(176,106),
	(176,107),
	(176,108),
	(176,109),
	(176,110),
	(176,111),
	(176,112),
	(176,113),
	(176,114),
	(176,115),
	(176,116),
	(176,117),
	(176,118),
	(176,119),
	(176,120),
	(176,121),
	(176,122),
	(176,123),
	(176,126),
	(176,129),
	(176,130),
	(176,131),
	(176,132),
	(176,133),
	(176,134),
	(176,141),
	(176,142),
	(176,143),
	(176,144),
	(176,145),
	(176,146),
	(176,147),
	(176,148),
	(176,149),
	(177,149),
	(178,146),
	(179,146),
	(180,0),
	(181,0),
	(182,146),
	(183,129),
	(184,129),
	(185,129),
	(186,129),
	(187,129),
	(188,148),
	(189,0),
	(190,101),
	(190,102),
	(190,103),
	(190,104),
	(190,105),
	(190,106),
	(190,107),
	(190,108),
	(190,109),
	(190,110),
	(190,111),
	(190,112),
	(190,113),
	(190,114),
	(190,115),
	(190,116),
	(190,117),
	(190,118),
	(190,119),
	(190,120),
	(190,121),
	(190,122),
	(190,123),
	(190,126),
	(190,129),
	(190,130),
	(190,131),
	(190,132),
	(190,133),
	(190,134),
	(190,141),
	(190,142),
	(190,143),
	(190,144),
	(190,145),
	(190,146),
	(190,147),
	(190,148),
	(190,149),
	(191,0),
	(192,130),
	(193,130),
	(194,130),
	(195,130),
	(196,130),
	(197,130),
	(198,130),
	(199,130),
	(200,130),
	(201,130),
	(202,130),
	(203,130),
	(204,130),
	(205,130),
	(206,130),
	(207,130),
	(208,130),
	(209,130),
	(210,130),
	(211,130),
	(212,130),
	(213,130),
	(214,130),
	(215,130),
	(216,130),
	(217,130),
	(218,130),
	(219,130),
	(220,130),
	(221,130),
	(222,130),
	(223,130),
	(224,0),
	(225,0);

/*!40000 ALTER TABLE `#__modules_menu` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__tags
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__tags`;

CREATE TABLE `#__tags` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `tag_idx` (`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__template_styles
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__template_styles`;

CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__template_styles` WRITE;
/*!40000 ALTER TABLE `#__template_styles` DISABLE KEYS */;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`)
VALUES
	(4,'beez3',0,'0','Beez3 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}'),
	(5,'hathor',1,'0','Hathor - Default','{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),
	(7,'protostar',0,'0','protostar - Default','{\"templateColor\":\"\",\"logoFile\":\"\",\"googleFont\":\"1\",\"googleFontName\":\"Open+Sans\",\"fluidContainer\":\"0\"}'),
	(8,'isis',1,'1','isis - Default','{\"templateColor\":\"\",\"logoFile\":\"\"}'),
	(20,'zenbase',0,'1','zenbase - Default','{\"jblogotype\":\"text\",\"jblogoimage\":\"\",\"logotext\":\"Zenbase\",\"tagline\":\"A fresh starter theme for Joomla3\",\"logoalign\":\"zenleft\",\"logoclass\":\"h2\",\"logoFont\":\"-1\",\"logoFont_custom\":\"Istok Web\",\"menualign\":\"zenleft\",\"baseFontSize\":\"80%\",\"bodyFont\":\"sans-serif\",\"bodyFont_custom\":\"sans-serif\",\"headingFont\":\"sans-serif\",\"headingFont_custom\":\"sans-serif\",\"navFont\":\"sans-serif\",\"navFont_custom\":\"sans-serif\",\"lazyload\":\"1\",\"llselector\":\"img\",\"notllselector\":\"\",\"backtotop\":\"1\",\"stickynav\":\"1\",\"stickynavoffset\":\"200\",\"copyright\":\"1\",\"customcopyright\":\"\",\"addcode\":\"\",\"ZEN_MAINBODY_DISABLED\":\"1\",\"ZEN_COMPONENT_DISABLED\":\"1\",\"t3_template\":\"1\",\"devmode\":\"0\",\"themermode\":\"1\",\"minify\":\"1\",\"t3-assets\":\"t3-assets\",\"t3-rmvlogo\":\"1\",\"theme\":\"\",\"logotype\":\"text\",\"sitename\":\"zenBase\",\"slogan\":\"A blank theme built on the T3 Framework\",\"logoimage\":\"images\\/joomla_black.gif\",\"mainlayout\":\"default\",\"navigation_trigger\":\"click\",\"navigation_collapse_offcanvas\":\"1\",\"navigation_collapse_showsub\":\"1\",\"navigation_type\":\"megamenu\",\"mm_type\":\"mainmenu\",\"mm_config\":\"{\\\"mainmenu\\\":{\\\"item-102\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":103,\\\"width\\\":12}]]}},\\\"item-106\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":107,\\\"width\\\":12}]]}},\\\"item-111\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":112,\\\"width\\\":12}]]}}}}\"}');

/*!40000 ALTER TABLE `#__template_styles` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__ucm_content
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__ucm_content`;

CREATE TABLE `#__ucm_content` (
  `core_content_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `core_type_alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'FK to the content types table',
  `core_title` varchar(255) NOT NULL,
  `core_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `core_body` mediumtext NOT NULL,
  `core_state` tinyint(1) NOT NULL DEFAULT '0',
  `core_checked_out_time` varchar(255) NOT NULL DEFAULT '',
  `core_checked_out_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_access` int(10) unsigned NOT NULL DEFAULT '0',
  `core_params` text NOT NULL,
  `core_featured` tinyint(4) unsigned NOT NULL DEFAULT '0',
  `core_metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `core_created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `core_created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_modified_user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Most recent user that modified',
  `core_modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_language` char(7) NOT NULL,
  `core_publish_up` datetime NOT NULL,
  `core_publish_down` datetime NOT NULL,
  `core_content_item_id` int(10) unsigned DEFAULT NULL COMMENT 'ID from the individual type table',
  `asset_id` int(10) unsigned DEFAULT NULL COMMENT 'FK to the #__assets table.',
  `core_images` text NOT NULL,
  `core_urls` text NOT NULL,
  `core_hits` int(10) unsigned NOT NULL DEFAULT '0',
  `core_version` int(10) unsigned NOT NULL DEFAULT '1',
  `core_ordering` int(11) NOT NULL DEFAULT '0',
  `core_metakey` text NOT NULL,
  `core_metadesc` text NOT NULL,
  `core_catid` int(10) unsigned NOT NULL DEFAULT '0',
  `core_xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `core_type_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`core_content_id`),
  KEY `tag_idx` (`core_state`,`core_access`),
  KEY `idx_access` (`core_access`),
  KEY `idx_alias` (`core_alias`),
  KEY `idx_language` (`core_language`),
  KEY `idx_title` (`core_title`),
  KEY `idx_modified_time` (`core_modified_time`),
  KEY `idx_created_time` (`core_created_time`),
  KEY `idx_content_type` (`core_type_alias`),
  KEY `idx_core_modified_user_id` (`core_modified_user_id`),
  KEY `idx_core_checked_out_user_id` (`core_checked_out_user_id`),
  KEY `idx_core_created_user_id` (`core_created_user_id`),
  KEY `idx_core_type_id` (`core_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Contains core content data in name spaced fields';



# Dump of table #__viewlevels
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__viewlevels`;

CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__viewlevels` WRITE;
/*!40000 ALTER TABLE `#__viewlevels` DISABLE KEYS */;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`)
VALUES
	(1,'Public',0,'[1]'),
	(2,'Registered',1,'[6,2,8]'),
	(3,'Special',2,'[6,3,8]'),
	(5,'Guest',0,'[9]');

/*!40000 ALTER TABLE `#__viewlevels` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__weblinks
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__weblinks`;

CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;




/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
